1997-09-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Version 20.2 released.

	* textmodes/outline.el (outline-up-heading):
	Avoid infinite loop at beginning of buffer.

1997-09-19  Kenichi Handa  <handa@etl.go.jp>

	* loadup.el: Load case-table before loading
	international/characters.el.

	* international/characters.el: Set case-table for Cyrillic characters.

1997-09-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* gnus/gnus-topic.el (gnus-topic-check-topology):
	Don't crash if (cadr topic) is nil.

	* language/english.el (ASCII): Define as alias for English.

	* saveplace.el (save-place-version-control): Make nil the default.

	* international/quail.el (quail-simple-translation-keymap):
	Bind delete and backspace explicitly, like DEL.

1997-09-18  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cal-menu.el: Require calendar only when compiling.

	* international/quail.el (quail-set-keyboard-layout):
	Add autoload cookie.

1997-09-15  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Version 20.1 released.

	* startup.el (normal-top-level-add-to-load-path):
	Ignore case when comparing, if ms-dos or windows-nt.

	* mail/mh-comp.el: Many doc fixes.
	(mh-send-letter): Choose a coding system
	the same way sendmail-send-it (sendmail.el) does.

	* international/quail.el (quail-simple-translation-keymap): 
	Set the default (t) binding properly.
	
	* international/quail.el (quail-terminate-translation):
	If quail-overlay is not an overlay, don't mess with it.

	* international/mule-util.el:
	(coding-system-unification-table-for-encode): Recurse properly.
	(coding-system-unification-table-for-decode): Recurse properly.

1997-09-15  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* mule.el (find-new-buffer-file-coding-system): Reflect
	text coding part of default-buffer-file-coding-system to
	buffer-file-coding-system when buffer-file-coding-system is
	not locally set and ASCII only text is read.

1997-09-15  Barry A. Warsaw  <cc-mode-help@python.org>
	
	* progmodes/cc-styles.el (c-initialize-builtin-style):
	Copy the whole tree instead of just copy-sequence.

1997-09-15  Eli Zaretskii  <eliz@is.elta.co.il>

	* info.el (Info-suffix-list): Add suffixes for MS-DOS version
	running on Windows 95 with long file name support.
	(info-insert-file-contents): When the Info file is to be
	uncompressed, insert it literally.

1997-09-15  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* international/quail.el (quail-completion-list-translations): Fix
	and simplify generation of translation list.

	* international/titdic-cnv.el (tit-process-header): Convert
	argument of KEYPROMPT if it contains an escape.
	(tit-process-body): Handle trailing whitespace and multiple spaces
	between phrases.

	* startup.el (initial-major-mode): Fix customize type.

	* gnus/gnus-sum.el (gnus-summary-respool-default-method):
	Likewise.

	* gnus/gnus-score.el (gnus-orphan-score): Likewise.
	(gnus-score-default-header): Likewise.
	(gnus-score-default-type): Likewise.

	* emulation/viper-mous.el (viper-mouse-search-key): Likewise.
	(viper-mouse-insert-key): Likewise.

	* gnus/gnus.el (gnus-valid-select-methods): Likewise.

	* gnus/gnus-art.el (gnus-article-x-face-too-ugly): Likewise.
	(gnus-saved-headers): Likewise.
	(gnus-article-time-format): Doc fix.

1997-09-15  Simon Marshall  <simon@diazepam.gnu.ai.mit.edu>

	* font-lock.el (tex-font-lock-keywords-2): Don't treat \item like \it.

1997-09-15  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* international/kkc.el (kkc-mode-map): Bind all control keys to
	kkc-non-kkc-command.

1997-09-14  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs-lisp/edebug.el (edebug-enter): Save, and bind to nil,
	overriding-local-map and overriding-terminal-local-map.

	* textmodes/fill.el (canonically-space-region): Doc fix.
	(fill-context-prefix): If the second line has the first line prefix,
	plus whitespace, use the part that the first line shares.
	(fill-individual-paragraphs): When prefix changes,
	usually get the new prefix from just one line,
	with an exception for indented first lines of paragraphs.
	Start a new paragraph when a line has extra indentation
	after the fill prefix.
	
	* international/mule-util.el (truncate-string-to-width): Doc typo fix.

1997-09-14  Hrvoje Niksic  <hniksic@srce.hr>

	* arc-mode.el: Customized.

1997-09-13  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* disp-table.el (standard-display-european):
	Do something useful where AUTO is t or a symbol.

1997-09-13  Erik Naggum  <erik@naggum.no>

	* ph.el: Require cl at compile-time.

	* cl-macs.el (cl-loop-let): Use `last', not `last*'

1997-09-13  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* language/english.el (setup-english-environment): Don't set
	the terminal and keyboard coding systems.

	* international/mule-util.el (truncate-string-to-width):
	Rename arg WIDTH to END-COLUMN.  Fix the case when START-COLUMN
	is after END-COLUMN.  Doc fixes.

	* mail/sendmail.el (mail-do-fcc): When writing to an Rmail file,
	use rmail-file-coding-system or else emacs-mule.

	* gnus/gnus-start.el (gnus-default-subscribed-newsgroups):
	Fix custom type.  Doc fix.
	(gnus-init-file): Doc fix.

1997-09-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* startup.el (normal-top-level-add-to-load-path):
	Try looking for the unmodified default-directory in load-path.

	* gud.el (perldb): Fix paren error in call to read-from-minibuffer.

	* emacs-lisp/debug.el (debug): Allow recursive minibuffers
	if we're in a minibuffer already.

	* simple.el (next-history-element):
	Cope if minibuffer-text-before-history is nil.

	* cus-edit.el (customize-group): Handle groups not yet loaded.
	
1997-09-12  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* ph.el (ph-server): Fix customize type.

	* emulation/viper-cmd.el (viper-smart-suffix-list): Likewise

	* emulation/viper.el (viper-non-vi-major-modes): Likewise.

	* emulation/viper-macs.el (viper-repeat-from-history-key):
	Likewise.

	* emulation/viper-mous.el (viper-mouse-search-key): Likewise.
	(viper-mouse-insert-key): Likewise.

	* emulation/viper-ex.el (ex-unix-type-shell): Likewise.

	* add-log.el (add-log-current-defun-function): Likewise.

	* cal-china.el (chinese-calendar-time-zone): Likewise.
	(chinese-calendar-standard-time-zone-name): Likewise.

	* gnus/gnus-start.el (gnus-site-init-file): Likewise.

	* gnus/gnus-group.el (gnus-permanently-visible-groups): Likewise.

	* gnus/gnus-sum.el (gnus-summary-thread-gathering-function):
	Likewise.

1997-09-12  Erik Naggum  <erik@naggum.no>

	* cal-menu.el, cal-move.el: Require calendar.el.

1997-09-12  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* cus-edit.el (hook) [:value-to-internal]: Use a nil value
	unchanged.

	* completion.el (save-completions-flag): Doc fix.

	* indent.el (tab-stop-list): Doc fix.

	* strokes.el (strokes-click-command): Doc fix.

	* progmodes/make-mode.el
	(makefile-pickup-everything-picks-up-filenames-p): Doc fix.
	(makefile-mode): Doc fix.

	* solar.el (calendar-location-name): Doc fix.

1997-09-12  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper-keym.el (viper-want-ctl-h-help): Updated doc string.
	(viper-vi-basic-map,viper-insert-basic-map,viper-replace-map):
	added binding for backspace.
	* viper-cmd.el (viper-adjust-keys-for): Separated backspace and C-h.

1997-09-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cal-french.el (french-calendar-accents): Change variable to function.
	Uses changed.  Test that we can display multibyte chars.
	(french-calendar-day-name-array, french-calendar-month-name-array):
	New functions.  Use them instead of directly using these variables.
	(french-calendar-multibyte-month-name-array): New variable.
	(french-calendar-multibyte-special-days-array): New variable.
	(calendar-print-french-date): Bind enable-multibyte-characters to t.

	* cus-edit.el (custom-face-menu): Use custom-face-save-command.
	not custom-face-save.
	(custom-face-save-command): New function.
	(custom-variable-save): Fix error message.

1997-09-12  Inge Frick  <inge@nada.kth.se>

	* compile.el (compilation-parse-errors): Fixed two bugs that
	could make compilation-parse-errors loop infinitely.  Each round
	of the parsing loop now either moves point ahead at least a line
	or sets `found-desired' to true to stop the loop.

1997-09-11  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* international/quail.el (quail-translation-keymap): Fix previous
	change.

	* mail/sendmail.el (sendmail-send-it): If both
	buffer-file-coding-system and sendmail-coding-system are nil, use
	iso-latin-1 for encoding.

1997-09-11  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* ps-print.el (ps-emacs-face-kind-p): Function deleted.
	(ps-face-bold-p, ps-face-italic-p):
	Check ps-bold-faces or ps-italic-faces.
	(ps-zebra-stripes, ps-zebra-stripe-height): Doc fixes.
	(ps-line-lengths, ps-nb-pages-buffer, ps-nb-pages-region, ps-setup): 
	Doc fixes.

	* international/quail.el (quail-update-translation):
	Fix previous change.

	* term/internal.el: Use raw-text as coding system.

1997-09-11  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/mule-diag.el (describe-coding-system): Describe
	coding systems of type 5, raw-text.

	* hexl.el (hexlify-buffer): Bind coding-system-for-write to
	raw-text with eol-type derived from the buffer-file-coding-system.

1997-09-11  Michael Kifer  <kifer@cs.sunysb.edu>

	* ediff-util.el (ediff-good-frame-under-mouse): new function.
	(ediff-really-quit): now uses ediff-good-frame-under-mouse instead 
	of testing a whole bunch of conds in-line.

1997-09-11  Kenichi Handa  <handa@etl.go.jp>

	* international/kkc.el (kkc-mode-map): Bind meta-prefix-char to a
	map which only has default key binding to
	quail-execute-non-quail-command.
	(kkc-non-kkc-command): Handle the key sequence as the same way as
	universal-argument-other-key.

	* international/quail.el (quail-translation-keymap):
	Make the default binding with define-key.
	(quail-simple-translation-keymap):
	Handle meta-prefix-char the way isearch does.
	Make the default binding with define-key.
	(quail-conversion-keymap): Likewise.
	(quail-execute-non-quail-command): Handle the key sequence as the
	same way as universal-argument-other-key.
	(quail-make-guidance-frame): Don't dedicate the guidance buffer window.
	(quail-show-guidance-buf): Likewise.
	(quail-hide-guidance-buf): Delete code to turn off window dedication.

1997-09-11  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* startup.el (initial-scratch-message): New variable.
	(command-line-1): Use initial-scratch-message.

	* international/quail.el (quail-translation-keymap):
	Handle meta-prefix-char the way isearch does.

	* international/mule-cmds.el (select-input-method):
	No error if enable-multibyte-characters is nil.

1997-09-11  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* gnus/gnus-mule.el: Set no-conversion for network communication
	with nntpd.
	(gnus-mule-initialize): For safety, set no-conversion for network
	communication with nntpd.

1997-09-10  Michael Ernst  <mernst@cs.washington.edu>

	* uniquify.el (uniquify-ignore-buffers-re): Added.

1997-09-10  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper-keym.el (viper-help-modifier-map): deleted; help mode map is 
	no longer modified. 
	* viper.el (viper-set-hooks): make help buffers come up in emacs state.
	
1997-09-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs-lisp/eval-reg.el (elisp-eval-buffer):
	New arg FILENAME is ignored.

1997-09-10  Kenichi Handa  <handa@etl.go.jp>

	* language/ethio-util.el (setup-ethiopic-environment): Don't bind
	keys in global-map, don't add a hook to rmail-mode-hook and
	mail-mode-hook.
	(ethio-mode): New buffer local variable.
	(ethio-mode-map): New variable.
	(ethio-mode): New function.
	(ethio-sera-to-fidel-mail-or-marker): New function.
	(ethio-fidel-to-sera-mail-or-marker): New function.
	(ethio-find-file): Do nothing if not in ethio-mode.
	(ethio-write-file): Likewise.
	(ethio-prefer-ascii-space): Moved from leim/quail/ethiopic.el.
	(ethio-toggle-space): Likewise.
	(ethio-insert-space): Likewise.
	(ethio-insert-ethio-space): Likewise.
	(ethio-prefer-ascii-punctuation): Likewise.
	(ethio-toggle-punctuation): Likewise.
	(ethio-gemination): Likewise.

	* mail/sendmail.el (sendmail-send-it): The priority of coding
	system for encoding outgoing mails is (1) local value of
	buffer-file-coding-system, (2) sendmail-coding-system,
	(3) default-buffer-file-coding-system.

1997-09-10  Kenichi Handa  <handa@etl.go.jp>

	* language/japan-util.el (setup-japanese-environment): Give
	iso-2022-jp to set-default-coding-system if not running on DOS.
	(read-hiragana-string): Use input method "japanese-hiragana".

	* gnus/gnus-mule.el: Add coding system specification for several
	news groups.

1997-09-09  Dave Love  <d.love@dl.ac.uk>

	* lisp-mode.el (lisp-imenu-generic-expression):
	Recognize `defcustom' and `defgroup".

1997-09-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* disp-table.el (standard-display-european): Doc fix.

1997-09-09  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* international/mule-cmds.el (input-method-verbose-flag):
	Doc-string fixed.

	* international/quail.el (quail-simple): New function.
	(quail-require-guidance-buf): New function.
	(quail-show-guidance-buf): Do not show guidance buffer if simple
	input method is used in the minibuffer.
	(quail-update-guidance): Likewise.

1997-09-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* disp-table.el (standard-display-european):
	If AUTO is non-nil, intern it.
	Don't call set-terminal-coding-system if noninteractive.
	
	* international/quail.el (quail-translation-keymap)
	(quail-simple-translation-keymap, quail-conversion-keymap):
	Don't define escape.

	* ps-print.el (ps-face-bold-p): Use face-bold-p.
	(ps-face-italic-p): Use face-italic-p.

	* comint.el (comint-file-name-chars): Doc fix.
	(comint-word): Treat all non-ASCII chars as "part of word".

1997-09-09  Michael Ernst  <mernst@cs.washington.edu>

	* uniquify.el: use uniquify-file-name-nondirectory throughout;
	documentation tweaks.

1997-09-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* view.el (view-end-message): Don't mention q if it really do anything.

	* dired.el (dired-get-filename): Don't call encode-coding-string
	if file-name-coding-system is non-nil.

	* emacs-lisp/find-func.el: New file.

1997-09-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-edit.el (custom-variable-save): Fixed doc string.

	* cus-edit.el (custom-variable-menu): Make it clear that `Lisp
	mode' edit the initial lisp expression.

1997-09-08  Eli Zaretskii  <eliz@is.elta.co.il>

	* info.el (info-insert-file-contents): Bind
	coding-system-for-write to no-conversion.

1997-09-08  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* dabbrev.el (dabbrev-case-fold-search): Remove extra quote in
	customize constant.
	(dabbrev-case-replace): Likewise.

	* ispell.el (ispell-personal-dictionary): Fix customize type.

	* shell.el (shell-chdrive-regexp): Likewise.

	* progmodes/executable.el (executable-chmod): Likewise.

	* emacs-lisp/lisp.el (defun-prompt-regexp): Likewise.

	* progmodes/f90.el (f90-break-before-delimiters): Likewise.

	* progmodes/hideshow.el (hs-minor-mode-hook): Likewise.

	* progmodes/icon.el (icon-tab-always-indent): Likewise.

	* browse-url.el (browse-url group): Remove autoload cookie.

	* diff.el (diff group): Remove autoload cookie.

1997-09-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* files.el (insert-directory): Encode the file name.

	* startup.el (command-line): Pass charset to
	standard-display-european.

	* disp-table.el (standard-display-european): Arg AUTO
	specifies coding system for terminal output (if needed).

1997-09-08  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* international/quail.el (quail-translation-keymap): Bind C-space
	to quail-select-current.

1997-09-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* textmodes/fill.el (fill-individual-paragraphs): Don't include
	paragraph-separate lines in any paragraph; just skip them.

	* telnet.el (telnet-initial-filter): Temporarily go to proper buffer.

1997-09-07  Barry A. Warsaw  <cc-mode-help@python.org>

	* progmodes/cc-mode.el (c-version): Updated.

	* progmodes/cc-cmds.el (c-beginning-of-statement):
	Fixes in sentence movement to properly
	handle M-e moving forward into a comment when looking at preceding
	whitespace, and M-a moving backward into comment when looking at
	following whitespace.

	* progmodes/cc-cmds.el (c-comment-line-break-function):
	Don't break line in the middle of a string.

	* progmodes/cc-langs.el (c-mode-base-map): Don't define C-c C-e here.
	(c-mode-map, c++-mode-map): Define C-c C-e here.
	(objc-mode-map): Define C-c C-e, not /.
	(java-mode-map, idl-mode-map): Don't define /.

	* progmodes/cc-engine.el (c-end-of-statement-1):
	Wrap backward-up-list in a c-safe call so no error results when
	buffer contains only a comment and point is at eob.

	* progmodes/cc-engine.el (c-inside-bracelist-p):
	Add a test to the enum list test so that enum in a k&r
	arg decl doesn't confuse handling of the function body.

	* progmodes/cc-styles.el (c-style-alist) <python>:
	knr-argdecl-intro == +, fill-column = 78,
	arglist-intro <= +, inextern-lang <= 0.
	Set c-comment-continuation-stars to "".

1997-09-07  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* mail/sendmail.el (mail-mode): Allow dash in citation prefixes
	in adaptive-fill-regexp and adaptive-fill-first-line-regexp.

	* cus-edit.el (custom-file): Now nil stands for "use the init file".
	(custom-save-delete): If custom-file is nil, use user-init-file.
	(custom-save-all): Likewise.

	* international/mule.el (load-with-code-conversion):
	Use third arg to eval-buffer and don't set buffer-file-name.

	* disp-table.el (standard-display-european): Set or clear
	the terminal coding system.

	* version.el (emacs-version): If HERE, add a newline.

	* startup.el (command-line-1): Update copyright year in string.

	* international/mule-cmds.el (universal-coding-system-argument):
	Improve prompt strings.

	* time-stamp.el (time-stamp-time-zone): Allow nil as alternative.

1997-09-06  Michael Ernst  <mernst@cs.washington.edu>

	* uniquify.el: Rename uniquify-fix-list-* to uniquify-fix-item-*.
	All callers changed.
 	(uniquify-rationalize-file-buffer-names):
	Use directory-file-name for directories (eliminate trailing slash).
	Call uniquify-fix-item-unrationalized-buffer.
	(uniquify-buffer-file-name): Use directory-file-name.
	(uniquify-fix-item-unrationalized-buffer): New function.
	(uniquify-unrationalized-buffer): Function deleted.

1997-09-06  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* font-lock.el (font-lock-comment-face, etc.):
	defvars moved up to avoid warnings.
	(font-lock-face-attributes, global-font-lock-mode): Add defvars.

	* ps-print.el (ps-setup): ps-zebra-stripe => ps-zebra-stripes.
	ps-number-of-zebra =>  ps-zebra-stripe-height.

	* international/quail.el (quail-execute-non-quail-command):
	Call quail-terminate-translation.

	* emacs-lisp/lisp.el (move-past-close-and-reindent):
	Don't move closeparen back onto the end of a comment.

	* dired.el (dired-flag-garbage-files): Move interactive flag
	across doc string.

	* progmodes/m4-mode.el (m4-mode): Add autoload cookie.

	* files.el (auto-mode-alist): Handle .m4 and .mc files.

1997-09-06  Simon Marshall  <simon@diazepam.gnu.ai.mit.edu>

	* font-lock.el (global-font-lock-mode): When turning off
	Global Font Lock mode, turn off Font Lock mode everywhere.

	* menu-bar.el (menu-bar-options-menu): Simplify global-font-lock-mode
	entry using enhanced global-font-lock-mode function.

	* emacs-lisp/regexp-opt.el (regexp-opt): Doc fix.

1997-09-06  Michael Kifer  <kifer@cs.sunysb.edu>
	
	* ediff-ptch.el (ediff-patch-buffer-internal):
	now behaves uniformely, whether the buffer
	visits a file or not.
	* ediff-util.el (ediff-other-buffer): smarter selection of
	suitable other buffer. 
	Moved binding of backspace after the binding for C-h.
	Makes a difference in XEmacs. 
	* ediff.el (ediff-patch-buffer): smarter selection of the defaults.
	* ediff-mult.el (ediff-meta-session-p): new function
	(ediff-operate-on-marked-sessions): now recursively descends into
	subdirectories.
	
1997-09-05  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* faces.el (set-face-font-auto):
	instanciate-fontset renamed to instantiate-fontset.

	* international/fontset.el (uninstantiated-fontset-alist): 
	Variable name spelling fixed, and doc fix.  All uses fixed.
	(instantiate-fontset): Function name spelling fixed.

	* isearch.el (search-whitespace-regexp): Doc fix.

	* international/mule.el (load-with-code-conversion):
	Don't bind enable-multibyte-characters; set it in the temp buffer.

	* compile.el (compilation-ask-about-save): Add autoload cookie.

	* progmodes/simula.el (simula-emacs-features):
	Treat Emacs 20 like Emacs 19.

1997-09-05  Vinicius Jose Latorre  <vinicius@cpqd.br>

	* ps-print.el: Some comment and doc fixes.
	(ps-print-version): New version number (3.05.1).
	(ps-adobe-tag): Replace defvar by defcustom, and doc fix.
	(ps-print-with-faces, ps-print-without-faces)
	(ps-spool-with-faces, ps-spool-without-faces): Add arg REGION-P.
	(ps-print-region-with-faces, ps-print-region)
	(ps-spool-region, ps-spool-region-with-faces): Fix calls to
	the functions above.
	(ps-setup): Print value of ps-zebra-stripe, ps-number-of-zebra,
 	ps-line-number, ps-print-background-image,
	and ps-print-background-text.
	(ps-print-prologue-1): Bug fix in PostScript programming:
	/BeginDSCPage, /BeginPage.
	(ps-showpage-count, ps-ref-bold-faces, ps-ref-italic-faces)
	(ps-ref-underlined-faces, font-lock-face-attributes)
	(ps-initialize-faces): Vars deleted.
	(ps-override-list, ps-extension-to-bit-face)
	(ps-extension-to-screen-face, ps-initialize-faces, ps-header-height)
	(ps-hard-lf, ps-soft-lf, ps-get-face, ps-map-font-lock): Fn deleted.
	(ps-extend-face-list, ps-extend-face): Doc fix.
	(ps-print-face-alist): New var to handle face alist.
	(ps-printing-region): New var and fn.
	(ps-header-page, ps-set-face-bold, ps-set-face-italic)
	(ps-set-face-underline, ps-set-face-attribute, ps-map-face): New fn.
	(ps-rmail-mode-hook, ps-rmail-print-message-from-summary)
	(ps-print-message-from-summary, ps-vm-print-message-from-summary):
	Fns moved.
	(ps-background): New argument PAGE-NUMBER.
	(ps-begin-file): Bug fix and print proper line number in a region.
	(ps-begin-page): Call ps-header-page.
	(ps-get-buffer-name): Indicates in the header when printing a region.
	(ps-end-page): Delete ps-showpage-count.
	(ps-dummy-page): Calls ps-header-page.
	(ps-set-color): Programming improvement.
	(ps-plot-region): Doc fix.
	(ps-face-attributes): Same functionality as deleted ps-get-face.
	(ps-build-reference-face-lists): Do the job by calling
	ps-set-face-bold and ps-bold-faces, and friends.

1997-09-05  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* language/japan-util.el (setup-japanese-environment): Set
	coding-category-iso-8-else to japanese-iso-8bit.

1997-09-05  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs-lisp/easymenu.el (easy-menu-create-keymaps):
	If two distinct items have the same string, make different
	key events for them.

	* international/mule.el (charset-quoted-standard-p): New function.
	Use it instead of quoted-symbol-p.
	(charset-id): Use charset-quoted-standard-p.
	(quoted-symbol-p): Function deleted.

	* ispell.el (ispell-command-loop):
	Restore dedicated flg of selected window.
	(ispell-overlay-window): Move dedicated flag of old window
	into the bottom of the two windows made from it.

	* international/mule-cmds.el (read-language-name): Doc fix.
	(set-language-environment): Improve prompt.

	* international/mule.el (set-terminal-coding-system):
	Specify default to read-coding-system.
	(set-keyboard-coding-system): Likewise.

1997-09-05  Paul Eggert  <eggert@twinsun.com>

	* gnus/message.el (message-unix-mail-delimiter): Initialize
	to the same value that rmail-unix-mail-delimiter is initialized to.

1997-09-05  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper-init.el (viper-replace-region-start-delimiter):
	Improved the default.
	* viper-mous.el (viper-mouse-click-search-word):
	(viper-mouse-click-insert-word):
	Fixed to not react when click is not over a text area.
	* viper.el (read-file-name): Unadvised.
	* viper-cmd.el (viper-insert-state-post-command-sentinel)
	(viper-save-last-insertion):
	Check if args and viper-insert-point are markers.
	(viper-minibuffer-trim-tail): New function.
	
1997-09-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* international/mule.el (set-buffer-file-coding-system): 
	Improve prompt.

	* international/mule-cmds.el (toggle-input-method):
	No error if enable-multibyte-characters is nil.
	(read-input-method-name): Specify the input history properly.
	(select-input-method): Improve prompt.

	* international/mule-util.el (string-to-sequence):
	Work usefully when enable-multibyte-characters is nil.

	* international/quail.el (quail-update-translation):
	Do insert translated char when enable-multibyte-characters is nil.

1997-09-03  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* international/mule-cmds.el (read-language-name): Use a default,
	not an initial input.

	* international/mule-conf.el (file-coding-system-alist):
	Match `loaddefs.el' more accurately.

	* rect.el (operate-on-rectangle): If we overshoot when looking
	for endcol, back up.

	* menu-bar.el (menu-bar-help-menu):
	Rename info item to "Info (Browse Manuals)".

	* menu-bar.el (menu-bar-options-menu): String now "Global Options".
	Rewrite the font lock toggle to turn off font lock on all buffers.
	Choose lazy-lock by setting font-lock-support-mode.

	* ispell.el (ispell-overlay-window): Undo previous change;
	in other words, don't bind inhibit-frame-unsplittable.

	* international/mule-cmds.el (mule-menu-keymap): 
	Define only as a variable; specify a name for the keymap.
	(mule-keymap): Define only as variable.

	* mail/sendmail.el (mail-mode): Set adaptive-fill-first-line-regexp
	specially, not same as adaptive-fill-regexp.

1997-09-03  Kenichi Handa  <handa@etl.go.jp>

	* international/quail.el (quail-update-guidance): If PROMPTKEY is
	specified in the original CXTERM dictionary, show also candidates
	in Quail guidance buffer.
	(quail-show-translations): Likewise.

1997-09-02  Andrew Innes  <andrewi@harlequin.co.uk>

	* term/w32-win.el (w32-handle-scroll-bar-event): On up and
	down events, place point at window start position.
	Bind f10 to menubar.
	Move keypad key definitions to w32-fns.el.

	* dos-w32.el (file-name-buffer-file-type-alist): Add more
	extensions for binary files.
	
	* w32-fns.el: Don't unset C-mouse-down bindings.
	Ignore "Windows" keys by default.
	Move keypad key definitions from term/w32-win.el.
	(convert-standard-file-name): New function.
	(make-auto-save-file-name): Use convert-standard-file-name.

1997-09-02  Michael Welsh Duggan  <md5i@schenley.com>

	* term/w32-win.el (mouse-wheel-scroll-amount): New variable.
	(mouse-wheel-scroll-line, mouse-wheel-scroll-screen): New functions.
	Bind mouse-wheel events to mouse-wheel functions.

1997-09-02  Geoff Voelker  <voelker@cs.washington.edu>

	* w32-fns.el: Update doc strings.
	(w32-startup): Deleted function.
	(w32-check-shell-configuration, w32-init-info): New functions.
	(w32-system-shell-p): Renamed from w32-using-system-shell-p.
	Added shell name argument.

1997-09-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* progmodes/etags.el (find-tag-tag): Pass default to completing-read.

	* dired.el (dired-get-filename): Don't call encode-coding-string
	if FILE is nil.

1997-09-02  Andrew Innes  <andrewi@harlequin.co.uk>

	* comint.el (comint-file-name-chars): Use separate sets for ms-dos
	and windows-nt.

	* disp-table.el (standard-display-european): Map \222 to apostrophe.

	* files.el (file-truename) [windows-nt]: Use the canonicalized
	long file name as the truename.
	(auto-mode-alist): Use archive-mode for Java JAR files.
	(recover-file) [windows-nt]: Don't try to list directory.

	* frame.el (other-frame) [windows-nt]: Use w32-focus-frame.

	* gud.el (gud-gdb-marker-regexp): Allow for drive letter and colon.

	* scroll-bar.el (scroll-bar-maybe-set-window-start): Change window
	if current start is equal to start of next portion.
	
1997-09-02  Geoff Voelker  <voelker@cs.washington.edu>

	* cus-edit.el (custom-display): Use w32 instead of win32.
	* browse-url.el (browse-url-netscape): Check for w32 window-system
 	symbol.

1997-09-02  Boris Goldowsky  <boris@gnu.ai.mit.edu>

	* enriched.el (enriched-decode-foreground,
	enriched-decode-background): Test of facemenu-get-face return
	value no longer needed.

	* facemenu.el (facemenu-get-face): Just warn when given an
	undefined color, no error, still return face.

1997-09-02  Kenichi Handa  <handa@etl.go.jp>

	* mail/rmail.el (rmail): Reset enable-multibyte-characters to the
	default value to enable message decoding if the default value is
	non-nil.

	* international/quail.el (quail-keyboard-layout-alist): Add an
	entry for "atari-german".
	(quail-keyboard-translate): If CH is not in the keyboard location
	covered by quail-keyboard-layout-standard, return CH.
	(quail-show-kbd-layout): Show keyboard layout based on
	quail-keyboard-layout-standard if the current input method
	requires keyboard translation.

1997-09-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* international/mule-cmds.el (set-coding-system-map):
	Add an item for universal-coding-system-argument.

1997-09-01  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* userlock.el (ask-user-about-lock): Abbreviate file name
	and locking user's name.

	* international/mule.el (set-auto-coding): Recognize coding: in first
	line even if not the first variable.

	* language/european.el (setup-8-bit-environment):
	Inhibit message about loading latin-N.el.

1997-09-01  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* international/quail.el (quail-translation-keymap): Fix prev change.
	(quail-conversion-keymap): Likewise.

	* international/mule-cmds.el (describe-input-method): Fix prev change.
	(read-multilingual-string): Likewise.
	(describe-language-environment): Prompt modified.

	* ispell.el (ispell-region): Take account of the fact that `ispell'
	will return OFFSET by counting non-ASCII characters as one.
	(ispell-dictionary-alist-1): Add coding systems to each entry.
	(ispell-dictionary-alist-2): Likewise.
	(ispell-get-coding-system): New function.
	(ispell-decode-string): New function.
	(ispell-get-casechars): Decode the string if necessary.
	(ispell-get-not-casechars, ispell-get-otherchars): Likewise.

1997-09-01  Naoto TAKAHASHI  <ntakahas@etl.go.jp>

	* language/ethio-util.el (ethio-sera-to-fidel-region,
	ethio-sera-to-fidel-buffer, ethio-fidel-to-sera-region,
	ethio-fidel-to-sera-buffer): Doc-string fixed.

1997-09-01  Kenichi Handa  <handa@etl.go.jp>

	* international/quail.el (quail-translation-keymap): Do not bind
	"\C-c" to quail-abort-translation.
	(quail-mode-map): Bind key codes 128 through 256 to
	quail-start-translation.
	(quail-translation-keymap): Bind key codes 128 through 256 to
	quail-self-insert-command.
	(quail-conversion-keymap): Bind key codes 128 through 256 to
	quail-start-translation-in-conversion-mode.

	* international/mule-cmds.el (get-language-info): Accept a symbol
	as the arg LANGUAGE-NAME.
	(set-language-info): Likewise.
	(set-language-info-alist): Likewise.
	(register-input-method): Accept a symbol as the args INPUT-METHOD
	and LANGUAGE-NAME.
	(activate-input-method): Accept a symbol as the args INPUT-METHOD.
	(describe-input-method): Likewise.
	(read-multilingual-string): Likewise.
	(set-language-environment): Accept a symbol as the arg LANGUAGE-NAME.
	(describe-language-environment): Likewise.

	* files.el (hack-local-variables-prop-line): Ignore coding: tag.
	(hack-one-local-variable): Likewise.

	* international/mule.el (set-auto-coding): Name changed from
	auto-file-coding-system.  The argument STRING is now a
	concatination of the heading 1K-byte and the tailing 3K-byte of a
	file.
	(set-auto-coding-function): Set it to `set-auto-coding'.
	
1997-08-31  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* emacs-lisp/bytecomp.el (byte-compile-output-file-form): Handle
	custom-declare-variable.

	* international/mule-diag.el (describe-current-coding-system): Add
	missing newline in output.

1997-08-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* gnus/pop3.el (pop3-md5): New function.
	(pop3-apop): Use pop3-md5, not md5.
	(pop3-md5-program): New variable.

	* gnus/md5.el: File deleted.

	* gnus/gnus-soup.el: Require cl at compile time.
	* gnus/gnus-move.el, gnus/gnus-uu.el: Likewise.

	* add-log.el (change-log-font-lock-keywords): Add more to prev change.

1997-08-30  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* dired.el (dired-get-filename): Encode file name
	using the buffer's coding system.

	* mail/sendmail.el (mail-send): Complain about invalid header line.

1997-08-30  Jerry James <jerry@cs.ucsb.edu>

	* format.el (format-subtract-regions): New function.
	(format-property-increment-region): New function.

	* format.el (format-deannotate-region): When multiple annotations
	go into a single text property, split the outer annotations (with
	format-subtract-regions) instead of resetting them; use lists of
	regions instead of a single number for the text property start.

	* format.el (format-deannotate-region): Don't change extents of
	enclosing annotations of the same kind.

	* format.el (format-deannotate-region): Use
	property-increment-region to add to numeric properties.

1997-08-29  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* dos-w32.el (find-buffer-file-type): Don't check for untranslated
	file systems here.
	(find-buffer-file-type-coding-system): For reading a file,
	check for binary file, then text file, then existing file,
	then whether file name is translated.

	* textmodes/text-mode.el (text-mode-hook-identify): New function,
	put on text-mode-hook.  Set text-mode-variant here.
	(text-mode): Don't set it here.

	* disp-table.el (standard-display-european): Doc fix.

1997-08-29  Carsten Dominik  <dominik@strw.LeidenUniv.nl>

	* reftex.el (reftex-customize): Added call to customize browse.
	(reftex-show-commentary): New function.
	(reftex-label-alist): Prefix may contain % escapes.  Nth macro
 	argument may be context. May give two different context methods.
	(reftex-default-label-alist-entries): Customization type changed.
	(reftex-label-menu-flags): Extra flag for searches.
	(reftex-cite-format): Changed completely, % escapes are now used.
	(reftex-comment-citations): New variable.
	(reftex-cite-comment-format): New variable.
	(reftex-cite-punctuation): New variable.
	(reftex-make-master-buffer): Changed name of master buffer,
 	removed interactive.  Runs a hook on the buffer. Interprete
 	TEXINPUTS environment variable.  Allow naked argument for \input.
	Master buffer is now in fundamental mode.
	(reftex-access-scan-info): Name of master buffer changed.
	(reftex-section-regexp): Is now computed from section levels,
	not set	independantly.
	(reftex-section-levels): Made customizable.
	(reftex-label): Interpret % escapes in prefix.  Use label format
 	if given.
	(reftex-replace-prefix-escapes): New function.
	(reftex-uniquify-label): New function.
	(reftex-next-label-number): Function definition removed.
	(reftex-reference): Use reftex-uniquify-label.  Allow more general
 	label commands.
	(reftex-offer-label-menu):
	Interpret new flag in reftex-label-menu-flags.
	(reftex-make-and-insert-label-list): Use text properties to record
 	label index.
	(reftex-find-nearby-label): Allow more general label commands.
	(reftex-scan-buffer-for-labels): Allow more general label commands.
	(reftex-init-section-numbers): New function.
	(reftex-allow-for-ctrl-m): New function.
	(reftex-label-info-update): Allow more general label commands.
	(reftex-label-info): New parameter derive.
	(reftex-short-context): Interprete integer parse as nth arg of macro.
	(reftex-nth-parens-substring): New function.
	(reftex-select-item): Interprete the new 'cnt text property.
	(reftex-pop-to-label): Allow more general label commands.
	(reftex-nicify-text): Allow more general label commands.
	(reftex-toc): Remember previous window configuration.  Use text
 	properties to store info.  Bind mouse-2.
	(reftex-make-master-buffer): New Hook.
	(reftex-last-window-height): New variable.
	(reftex-toc-show-help): New function.
	(reftex-toc-help): New constant.
	(reftex-nearest-section): Use text properties to store info.
	(reftex-empty-toc-buffer): New function.
	(reftex-re-enlarge): New function.
	(reftex-toc-goto-line): New function.
	(reftex-toc-mouse-goto-line-and-hide): New function.
	(reftex-cite-format-builtin): New constant.
	(reftex-cite-format-default): Constant removed.
	(reftex-cite-format-1-author-simple): Constant removed.
	(reftex-cite-format-2-authors): Constant removed.
	(reftex-get-bib-names): New function.
	(reftex-get-bib-authors) Function removed.
	(reftex-format-bib-entry): Use now reftex-get-bib-names.
	(reftex-citation): Completely rewritten. Offers selection of
 	different cite macros first, then the reference menu.  Works with
 	the various new variables mentioned above.  Accept the `a' key to
 	use all selected citations.
	(reftex-insert-bib-matches): New function.
	(reftex-format-citation): Now interpretes % escapes.
	(reftex-select-item): Emulate a search in the menu buffer.
  	Interpret the 'cnt text property.
	(reftex-view-crossref): Allow more general label, cite and ref macros.
	(reftex-highlight-overlays): Add third overlay for search
	in menu buffer.
	(reftex-label-alist-builtin): xalignat and xxalignat environments
 	added.  Slightly reorganized.
	(reftex-reset-scanning-information): Just empty *toc* buffer, do
 	not kill it.
	(reftex-compute-ref-cite-tables): Read the new options in
	`reftex-label-alist' and store them.  Calculate the section regexp.

1997-08-28  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* compile.el (compilation-error-regexp-alist): 
	Allow spaces in file names for Microsoft C;
	check more carefully for the rest of the error message.

	* international/mule-cmds.el (set-terminal-coding-system): 
	Enable for menus whenever not using X.
	(set-keyboard-coding-system): Likewise.

	* international/quail.el (quail-define-package): New arg SIMPLE.
	(quail-simple-translation-keymap): New keymap.

	* textmodes/texnfo-upd.el, textmodes/texinfmt.el:
	(defgroup, defcustom): Add Emacs 19 compatibility definitions.
	* textmodes/texinfo.el:
	(defgroup, defcustom): Add Emacs 19 compatibility definitions.

1997-08-28  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el (make-coding-system): Make TYPE 5 means
	raw-text.
	(after-insert-file-set-buffer-file-coding-system): Set
	enable-multibyte-characters to nil if we read a file with
	no-conversion or raw-text-XXXX.

	* international/mule-conf.el (raw-text): New coding system.  Set
	coding-category-raw-text to raw-text.

	* language/english.el (setup-english-environment): Set
	coding-category-raw-text to raw-text.

	* language/viet-util.el (setup-vietnamese-environment): Set
	coding-category-raw-text to vietnamese-viscii.

	* language/cyril-util.el (setup-cyrillic-alternativnyj-environment):
	Set coding-category-raw-text to cyrillic-alternativnyj.

	* international/mule-cmds.el (update-leim-list-file): Make it
	handle multiple directories.
	(update-all-leim-list-files): Deleted.

	* international/quail.el (quail-update-leim-list-file): Make it
	handle multiple directories.

1997-08-28  Kenichi Handa  <handa@etl.go.jp>

	* earcon.el: Require cl at compile time before loading gnus, etc.

1997-08-28  Tomohiko Morioka  <tmorioka@mule.etl.go.jp>

	* nnfolder.el (nnfolder-request-list): Override
	'nnmail-file-coding-system' by 'nnmail-active-file-coding-system'.
	(nnfolder-request-list, nnfolder-possibly-change-group): Protect
	from conversion by `pathname-coding-system' for XEmacs/mule.
	(nnfolder-group-pathname): Encode pathname for Emacs 20.

	* nnmh.el (nnmh-request-list, nnmh-active-number): Protect from
	conversion by `pathname-coding-system' for XEmacs/mule.

	* nnml.el (nnml-possibly-change-directory): Likewise
	(nnml-retrieve-headers, nnml-request-article,
	nnml-request-group, nnml-request-list): Likewise

	* nnmail.el (nnmail-active-file-coding-system): New variable.
	(nnmail-insert-xref): Encode pathname for Emacs 20.
	(nnmail-write-region, nnmh-retrieve-headers, nnmh-request-article,
	nnmh-request-group, nnmh-possibly-change-directory): Protect from
	conversion by `pathname-coding-system' for XEmacs/mule.
	(nnmail-pathname-coding-system): New variable.
	(nnmail-group-pathname): Encode pathname for Emacs 20.
	nnmail-file-coding-system): New variable.
	(nnmail-find-file): Bind `coding-system-for-read' with
	`nnmail-file-coding-system' for Emacs/mule and XEmacs/mule.
	(nnmail-write-region): Bind `coding-system-for-write' with
	`nnmail-file-coding-system' for Emacs/mule and XEmacs/mule.

	* nnheader.el (nnheader-pathname-coding-system): New variable.
	(nnheader-file-coding-system): New variable.
	(nnheader-group-pathname): Encode pathname for Emacs 20.
	(nnheader-find-file-noselect): Bind `coding-system-for-read' with
	`nnheader-file-coding-system' for Emacs/mule and XEmacs/mule.
	(nnheader-insert-file-contents): Bind `coding-system-for-read'
	with `nnheader-file-coding-system' for Emacs/mule and XEmacs/mule.

	* nntp.el (nntp-coding-system-for-read): New variable.
	(nntp-open-connection): Bind `coding-system-for-read' with
	`nntp-coding-system-for-read' for Emacs/mule and XEmacs/mule.

	* nnspool.el (nnspool-file-coding-system): New variable.
	(nnspool-retrieve-headers, nnspool-retrieve-headers-with-nov,
	nnspool-find-file): Override `nnheader-file-coding-system' by
	`nnspool-file-coding-system' for gnspool on Windows 95/NT.

	* gnus-sum.el (gnus-structured-field-decoder): New variable.
	(gnus-unstructured-field-decoder): New variable.
	(gnus-get-newsgroup-headers, gnus-nov-parse-line): Use
	`gnus-structured-field-decoder' and
	`gnus-unstructured-field-decoder' for Subject field.

1997-08-28  Miyashita Hisashi  <himi@etl.go.jp>

	* pop3.el (pop3-movemail-file-coding-system): Append it for
	assigning a coding system to receive mail with pop3.
	(pop3-movemail): Modify for writing messages with
	pop3-movemail-file-coding-system.

1997-08-27  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* textmodes/text-mode.el (text-mode-hook): New defvar.
	(text-mode-variant): New variable.
	(text-mode): Set that variable locally.
	(toggle-text-mode-auto-fill): New command.

	* timer.el (timer-event-handler): Reactivate timer first,
	then run the handler function.

	* isearch.el (isearch-printing-char): Handle nonascii-insert-offset.

	* emacs-lisp/cl.el (last*): Definition deleted.

	* subr.el (last): Accept optional second argument.

	* progmodes/sh-script.el (sh-indent-line): Delete debugging code.

1997-08-27  Dave Love  <d.love@dl.ac.uk>

	* browse-url.el	(browse-url-mail): Use compose-mail[-other-window],
	not always `mail'.

1997-08-27  Eli Zaretskii  <eliz@is.elta.co.il>

	* ps-print.el (ps-print-region-with-faces): Don't call
	ps-generate.

	* term/pc-win.el (msdos-color-aliases): Add missing colors.
	(msdos-color-translate): Handle "deep" and "pale" color
	varieties.

1997-08-27  Dave Love  <d.love@dl.ac.uk>

	* browse-url.el: Change the custom group to `hypermedia'.
	(browse-url-netscape-version): New variable.
	(browse-url-netscape-reload): Use it to account for reported
 	backwards incompatibility.

1997-08-27  Eli Zaretskii  <eliz@psilocin.gnu.ai.mit.edu>

	* term/internal.el: Add coding: emacs-mule tag, to prevent
	interpreting this as sjis-encoded file.

1997-08-27  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* forms.el (forms-read-only): Un-customize, and doc fix.

	* mail/rmailsum.el (rmail-summary-get-new-mail):
	Handle args like rmail-get-new-mail, and pass them to that function.

	* winner.el: Many changes by Ivar Rummelhoff.

1997-08-26  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* language/european.el (setup-8-bit-environment): Load the latin-N
	file again each time.

	* files.el (find-file-literally): Doc fix.

	* help.el (help-with-tutorial): Doc fix.

1997-08-26  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* mail/mail-utils.el (mail-strip-quoted-names): 

	* ps-print.el (ps-rmail-mode-hook): New function.
	(ps-print-message-from-summary): New function.
	(ps-vm-print-message-from-summary): Use that.
	(ps-gnus-print-article-from-summary): Likewise.
	(ps-rmail-print-message-from-summary): New function.

	* emacs-lisp/lisp-mode.el (emacs-lisp-mode-syntax-table):
	Give formfeed whitespace syntax.

	* international/mule-diag.el (mule-diag): Add save-excursion calls.

1997-08-26  Michael Ernst  <mernst@cs.washington.edu>

	* mail-utils.el (mail-strip-quoted-names): Retain one whitespace
	character between addresses.

1997-08-26  Boris Goldowsky  <boris@gnu.ai.mit.edu>

	* facemenu.el (facemenu-unlisted-faces): Expand variable
	definition to allow regexps; add regexps for some packages that
	define a lot of faces.
	(facemenu-add-new-face): Test new face against regexps.
	(list-colors-display): Rather than creating a zillion faces, use
	new (foreground-color . COLOR) and (background-color . COLOR)
	face properties.

1997-08-26  Kenichi Handa  <handa@etl.go.jp>

	* files.el (revert-buffer): Read a file without any code
	conversion if we are reverting from an auto-saved file.

	* language/japanese.el (set-language-info-alist): Change
	iso-2022-7bit to iso-2022-jp.

	* replace.el (query-replace-read-args): Locally bind
	minibuffer-inherit-input-method to t to make a minibuffer inherit
	the current input method.
	(map-query-replace-regexp, keep-lines, flush-lines): Likewise.
	(how-many, occur): Likewise.

	* international/mule-cmds.el
	(inactivate-current-input-method-function): Doc-string modified.
	(input-method-activate-hook): Likewise.
	(input-method-inactivate-hook): Likewise.
	(activate-input-method): Document it.
	(inactivate-input-method): Document it.

	* language/tibet-util.el (tibetan-composition): Add autoload
	cookies.

1997-08-26  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* gnus/gnus-nocem.el: Require cl at compile time.

	* gnus/gnus.el (gnus-select-method): Change the other ignore-errors.

	* gnus/gnus-group.el (gnus-group-make-useful-group):
	Don't use caddr in interactive.

	* gnus/gnus-art.el (gnus-emphasis-alist): Don't use caddr.

	* mail/rmail.el (rmail-mode-1):
	Update the value for mode-line-modified.

1997-08-25  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* custom.el (custom-declare-variable): Use custom-initialize-reset
	by default, rather than custom-initialize-set.
	(custom-initialize-reset, custom-initialize-set): Doc fixes.

	* gnus/gnus-int.el, gnus/gnus-msg.el, gnus/gnus-undo.el: 
	Require cl at compile time.

	* progmodes/cmacexp.el (c-macro-expand): Add autoload cookie.

	* cus-dep.el (custom-make-dependencies): Don't print each file name.

1997-08-24  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* custom.el (custom-declare-variable): Rename 2nd arg to DEFAULT.

	* emacs-lisp/easymenu.el (easy-menu-create-keymaps): If nil is
	given as the enable condition, always disable the command.

	* comint.el (comint-preoutput-filter-functions): New variable.
	(comint-output-filter): Call those functions.
	(comint-output-filter-functions, comint-mode): Doc fix.

	* faces.el (modify-face): Fix previous change.

	* add-log.el (change-log-font-lock-keywords):
	Match "Patches by".  Match all kinds of acks after `  '.

	* mail/rmail.el (rmail-view-buffer): Doc fix.
	(rmail-summary-buffer, rmail-summary-vector): Mark as permanent local.
	(rmail-buffer): Add defvar and mark as permanent local.

1997-08-24  Erik Naggum  <erik@naggum.no>

	* simple.el (eval-expression): Prefix arg means insert value in
	current buffer.

1997-08-23  Kenichi Handa  <handa@etl.go.jp>

	* international/quail.el (quail-terminate-translation): Doc-string
	fixed.  Set quail-prefix-arg to nil after handling it.
	(quail-self-insert-command): Set overriding-terminal-local-map to
	nil when thrown for `quail-tag' by value nil.

1997-08-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* tmm.el (tmm-get-keymap): Ignore any command now disabled for menus.

	* textmodes/texinfo.el (texinfo-mode): Turn off adaptive-fill-mode.

	* winner.el: Doc fixes.

	* gnus/messcompat.el (message-signature-file): Delete autoload cookie.

	* gnus/nnvirtual.el (nnvirtual-merge-sorted-lists):
	Use sort, not merge.
	(nnvirtual-partition-sequence): use mapcar, not mapc.
	(nnvirtual-create-mapping): Don't use delete-if-not.

	* gnus/nnfolder.el (nnfolder-generate-active-file): Don't use remove.

	* gnus/gnus-start.el: Require cl at compile time.
	(gnus-site-init-file): Use condition-case.

	* gnus/gnus-art.el: Require cl at compile time.
	* gnus/gnus-async.el: Likewise
	* gnus/gnus-cite.el, gnus/gnus-kill.el, gnus/gnus-logic.el: Likewise.
	* gnus/gnus-group.el, gnus/gnus-salt.el, gnus/gnus-score.el: Likewise.
	* gnus/gnus-spec.el, gnus/gnus-srvr.el, gnus/gnus-start.el: Likewise.
	* gnus/gnus-sum.el, gnus/gnus-topic.el, gnus/gnus-win.el: Likewise.
	* gnus/nnweb.el, gnus/gnus-bcklg.el: Likewise.
	* gnus/gnus-cache.el, gnus/gnus-demon.el, gnus/gnus-dup.el: Likewise.
	* gnus/gnus-range.el, gnus/nnheader.el: Likewise.

	* gnus/parse-time.el: Require cl only at compile time.
	* gnus/gnus-setup.el, gnus/nneething.el, gnus/nnmail.el: Likewise.
	* gnus/nnmh.el, gnus/nnml.el, gnus/nnoo.el: Likewise.
	
	* gnus/gnus-util.el: Require cl only at compile time.
	(gnus-parent-id): Don't use last with 2 args.

	* gnus/gnus.el: Require cl at compile time.
	(gnus-select-method): Use condition-case, not ignore-errors.
	(gnus-check-backend-function): Definition moved up.

	* gnus/message.el: Require cl only at compile time.
	(message-user-agent): Use condition-case, not ignore-errors.
	(message-talkative-question): Doc fix.
	
	* subr.el (caar, cadr, cdar, cddr): Definitions moved here
	and changed into defsubsts.
	(last): New function.

	* emacs-lisp/cl.el (caar, cadr, cdar, cddr): Moved to subr.el.
	(last): Function renmed to last*.
	* emacs-lisp/cl-macs.el (cl-loop-let): Use last*.

	* time.el (display-time-hook): Minor doc fix.

	* ps-print.el (ps-zebra-stripes): Renamed from ps-zebra-stripe.
	(ps-zebra-stripe-height): Renamed from ps-number-of-zebra.

	* vc.el (vc-version-diff): Mention that default file is visited file.

	* textmodes/sgml-mode.el (sgml-mode-common):
	Set paragraph-start like paragraph-separate.
	Do match a line which is just a <...> construct after whitespac.e
	Set adaptive-fill-regexp to match whitespace only.

	* emacs-lisp/autoload.el (update-file-autoloads):
	Be careful about which directory to find loaddefs.el in.

	* gnus/message.el (message-user-agent): Add autoload cookie.

	* progmodes/sh-script.el (sh-indent-line): Avoid infinite loop
	on indented line at start of buffer, when calculating PREVIOUS.

1997-08-22  Stephen Gildea  <gildea@intouchsys.com>

	* time-stamp.el (time-stamp-time-zone): New variable.
	(time-stamp-string): Use that time zone.
	(time-stamp-active, time-stamp-warn-inactive)
	(time-stamp-old-format-warn): Definitions moved.
	
1997-08-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* faces.el (modify-face): New arg INVERSE-P.
	Clear the inverse-video flag before installing new colors.
	(face-spec-set): Pass INVERSE-P arg, and use (nil) for colors
	when calling modify-face.

	* add-log.el (change-log-font-lock-keywords): Recognize "Patch by".

	* textmodes/paragraphs.el (use-hard-newlines): Un-customized.

	* menu-bar.el (menu-bar-make-toggle): New macro.
	(menu-bar-options-menu): New submenu of Help menu.
	Define several menu items for it.
	
	* shell.el (shell-snarf-envar, shell-copy-environment-variable): 
	New functions.

	* progmodes/hideif.el (hif-greater, hif-less, hif-greater-equal)
	(hif-less-equal): New functions.
	(hif-tokenize): Handle new tokens >, <, >=, <=.
	(hif-eq-expr): Handle parsing these new tokens.
	(hif-token-regexp): Match >, <. >=, <=

	* delsel.el (delete-selection-mode): Put back :initialize keyword.
	At the end of the file, test this variable, and turn on the mode
	if it is non-nil.

1997-08-22  Olivier Lecarme  <ol@aiguemarine.unice.fr>

	* textmodes/paragraphs.el: Customized.
	* textmodes/nroff-mode.el: Customized.
	
1997-08-22  Karl Fogel  <kfogel@floss.red-bean.com>

	* bookmark.el (bookmark-load): Use `bookmark-import-new-list' to
	load the new list carefully, renaming bookmarks as necessary.
	In docstring, mention new renaming behavior.
	Optional arg OVERWRITE replaces inaccurately-named REVERT.
	If file loaded was bookmark-default-file, then set
	bookmarks-already-loaded to t.
	(bookmark-import-new-list): New func.
	(bookmark-maybe-rename): New func, helper to above.
	(bookmark-set-name): Accept bookmark as either string (behaves
	same as before) or list (treat it as a bookmark record).

	(bookmark-set, bookmark-maybe-load-default-file)
	(bookmark-jump-noselect, bookmark-rename)
	(bookmark-show-annotation): Discard pointless `progn's.
	
	(bookmark-bmenu-mark, bookmark-bmenu-unmark)
	(bookmark-bmenu-backup-unmark, bookmark-bmenu-delete-backwards):
	Renormalize position after all else is done.
	
	(bookmark-edit-annotation-mode, bookmark-bmenu-list)
	(bookmark-show-annotation, bookmark-show-all-annotations):
	Use `x' instead of `(not (eq x nil))'.
	
	(bookmark-yank-word): Inner save-excursion changed to progn.
	(bookmark-send-annotation, bookmark-send-edited-annotation)
	(bookmark-insert): Use buffer-string instead of buffer-substring.
	(bookmark-make-cell): Make sure annotation and info-node strings
	contain no text properties.
	(bookmark-relocate): Remember to rebuild bmenu buffer after a
	bookmark has been relocated.
	(bookmark-bmenu-check-position): Return a meaningful value --
	callers have apparently been assuming this anyway.
	(bookmark-build-xemacs-menu): Unused function deleted.
	(bookmark-version): Removed this variable; the Emacs version suffices.
	
1997-08-22  Simon Marshall  <simon@gnu.ai.mit.edu>

	* shell.el (shell-mode): Make shell-last-dir buffer-local.

1997-08-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* indent.el (indent-relative, insert-tab):
	Don't call expand-abbrev unless preceding character is a word char.

1997-08-21  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper.el (viper-set-hooks): new advices and hooks for mule.
	(toggle-viper-mode): new function.
	* viper-util.el (viper-set-syntax-preference,
	viper-update-syntax-classes): new functions. 
	(viper-looking-*,viper-skip-*) revamped to work better with syntax 
	tables.
	* viper-cmd.el (viper-replace-char-subr,viper-word-*,
	viper-separator-skipback-special): made to work with mule and syntax 
	tables.
	(viper-change-state): moved iso-accents-mode handling here from
	viper-change-state-to-vi/insert/etc. Also now toggles MULE.
	
1997-08-21  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* textmodes/bibtex.el: Many doc strings.

1997-08-21  Olivier Lecarme  <ol@aiguemarine.unice.fr>

	* textmodes/bibtex.el: Customized.

1997-08-21  Kenichi HANDA  <handa@etl.go.jp>

	* language/cyril-util.el (setup-cyrillic-environment): Deleted.
	(setup-cyrillic-iso-environment): New function.
	(setup-cyrillic-koi8-environment): New function.
	(setup-cyrillic-alternativnyj-environment): New function.

	* language/cyrillic.el: Make describe-cyrillic-environment-map and
	setup-cyrillic-environment-map prefix commands and bind [Cyrillic]
	to them in describe-environment-map and setup-environment-map
	respectively.  Divide language environemnt "Cyrillic" into three:
	"Cyrillic-ISO", "Cyrillic-KOI8", and "Cyrillic-ALTERNATIVNYJ".

	* international/mule.el (auto-file-coding-system): New function.
	(auto-file-coding-system-function): Set this variable to
	`auto-file-coding-system'.

	* international/quail.el (quail-terminate-translation): Run
	input-method-after-insert-chunk-hook only when the current input
	method doesn't require conversion.
	(quail-no-conversion): Run input-method-after-insert-chunk-hook.

	* international/mule-util.el (coding-system-unification-table):
	Deleted.
	(coding-system-unification-table-for-decode): New function.
	(coding-system-unification-table-for-encode): New function.

	* international/mule.el (make-coding-system): Doc-string fixed.

	* international/fontset.el (register-alternate-fontnames): New
	function.
	(x-complement-fontset-spec): Register alternate fontnames by
	calling register-alternate-fontnames.
	(instanciate-fontset): Likewise.

1997-08-20  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* ps-print.el (ps-print-face-extension-alist): Doc fix.
	(ps-new-faces): Function deleted.

1997-08-20  Dave Love  <d.love@dl.ac.uk>

	* browse-url.el: Minor doc fixes.
	(browse-url-temp-dir): New variable.
	(browse-url-of-buffer): Use browse-url-temp-dir.  Don't construct
 	a temporary file name which includes an arbitrary buffer name to
 	avoid losing on non-unixy systems.

1997-08-20 22:06:10 1997  Vinicius Jose Latorre  <vinicius@cpqd.br>

	* ps-print.el: A lot of comment and doc fixes.
	Replace: 'nil by nil, '() by nil, 't by t.
	(ps-print-version): New version number (3.05).
	(ps-zebra-stripe, ps-number-of-zebra, ps-line-number)
	(ps-print-background-image, ps-print-background-text): New variables
	to customize zebra stripes, line number, image background and text
	background features, respectively.
	(ps-adobe-tag): Tagged to PostScript level 3.
	(ps-print-buffer, ps-print-buffer-with-faces)
	(ps-print-region, ps-print-region-with-faces)
	(ps-spool-buffer, ps-spool-buffer-with-faces)
	(ps-spool-region, ps-spool-region-with-faces): Call more primitive
	functions for PostScript printing (functions below).
	(ps-print-with-faces, ps-print-without-faces)
	(ps-spool-with-faces, ps-spool-without-faces): More primitive
	functions for PostScript printing.
	(ps-line-lengths, ps-nb-pages-buffer, ps-nb-pages-region)
	(ps-line-lengths-internal, ps-nb-pages): Doc fixes.
	(ps-print-prologue-1): a lot of PostScript programming:
	/dobackgroundstring, /dounderline, /UL: Postscript functions deleted.
	/reencodeFontISO, /F, /BG, /HL, /W, /S, /BeginDSCPage, /BeginPage,
	/EndPage: adjusted for new effects (outline, shadow, etc).
	/PLN, /EF, /Hline, /doBox, /doRect, /doShadow, /doOutline,
	/FillBgColor, /doLineNumber, /printZebra, /doColumnZebra,
	/doZebra, /BeginBackImage, /EndBackImage, /ShowBackText: New procedures.
	(ps-current-underline-p, ps-set-underline): Var and fn deleted.
	(ps-showline-count, ps-background-pages, ps-background-all-pages)
	(ps-background-text-count, ps-background-image-count): New variables.
	(ps-header-font, ps-header-title-font)
	(ps-header-line-height, ps-header-title-line-height)
	(ps-landscape-page-height): Set initial value to nil.
	(ps-print-face-extension-alist, ps-print-face-map-alist): 
	New variables for face remapping.
	(ps-new-faces, ps-extend-face-list, ps-extend-face):
	New functions for face remapping.
	(ps-override-list, ps-extension-to-bit-face)
	(ps-extension-to-screen-face, ps-extension-bit)
	(ps-initialize-faces, ps-map-font-lock, ps-screen-to-bit-face):
	New internal functions for face remapping.
	(ps-get-page-dimensions): Fix error message.
	(ps-insert-file): Doc fix and programming enhancement.
	(ps-begin-file, ps-end-file, ps-get-buffer-name, ps-begin-page)
	(ps-next-line, ps-plot-region, ps-face-attributes)
	(ps-face-attribute-list, ps-plot-with-face)
	(ps-generate-postscript-with-faces): Handle new output features.
	(ps-generate): save-excursion inserted to return back point at
	position before calling ps-print.
	(ps-do-spool): Access dos-ps-printer variable through symbol-value.
	(ps-prsc, ps-c-prsc, ps-s-prsc): Use backquote.
	(ps-basic-plot-whitespace, ps-emacs-face-kind-p): Internal blank
	line eliminated.
	(ps-float-format, ps-current-effect): New internal variables.
	(ps-output-list, ps-count-lines, ps-background-pages)
	(ps-get-boundingbox, ps-float-format, ps-background-text)
	(ps-background-image, ps-background, ps-header-height)
	(ps-get-face): New internal functions.
	(ps-control-character): Handle control characters.
	(ps-gnus-print-article-from-summary): Updated for Gnus 5.
	(ps-jack-setup): Replace 'nil by nil, 't by t.

1997-08-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* mail/sendmail.el (mail-yank-original): Bind mark-even-if-inactive 
	around the indentation and citation hooks code.

	* mail/sendmail.el (mail-send-nonascii): Make the default t.

	* calendar.el (calendar-julian-date-string): Mark not interactive.

1997-08-19  Kenichi Handa  <handa@etl.go.jp>

	* files.el (append-to-file): Doc-string fixed.

	* international/quail.el (quail-exit-from-minibuffer): Call
	inactivate-input-method instead of (quail-mode -1).
	(quail-kill-guidance-buf): New function.
	(quail-mode): Doc-string and comments modified.  Make this
	function non-interactive.  Add quail-kill-guidance-buf to
	kill-buffer-hook locally.
	(quail-start-translation): Check if the current Quail package
	requires keyboard tranlation feature.
	(quail-start-translation-in-conversion-mode): Likewise.
	(quail-terminate-translation): Run hooks in
	input-method-after-insert-chunk-hook.
	(quail-update-translation): Don't run hooks in
	input-method-after-insert-chunk-hook here.
	(quail-setup-completion-buf): New function.
	(quail-show-guidance-buf): Create completion buffer by calling
	quail-setup-completion-buf.
	(quail-completion): Create completion buffer if it is not alive.

	* international/encoded-kb.el (encoded-kbd-mode): Doc-string
	modified.  Make this a non-interactive function.
	(encoded-kbd-iso2022-designation): Do not enter recursive edit twice.
	(encoded-kbd-iso2022-non-ascii-map): Bind 8-bit keys to
	encoded-kbd-handle-8bit.

	* international/titdic-cnv.el (tit-process-body): Handle `\' used
	for quoting the following digits correctly.

	* international/isearch-x.el
	(isearch-process-search-multibyte-characters): If
	read-multilingual-string returns null string, just call isearch-update.

1997-08-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* language/china-util.el: Don't set primary-language.

	* language/ethio-util.el (setup-ethiopic-environment): 
	Don't set primary-language.

	* language/cyril-util.el (setup-cyrillic-environment):
	Don't set primary-language.

	* international/mule-cmds.el (primary-language): Variable deleted.
	* international/mule-diag.el (mule-diag): Don't print primary-language.

	* help.el (help-with-tutorial): Use current-language-environment.

1997-08-18  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* calendar.el: Add an autoload form for calendar-print-julian-date.

	* international/encoded-kb.el (encoded-kbd-iso2022-designations): 
	(encoded-kbd-iso2022-invocations): Don't make these vars buffer-local.
	(encoded-kbd-mode): Don't make encoded-kbd-iso2022-designations
	or encoded-kbd-iso2022-invocations buffer-local.

	* textmodes/fill.el (fill-individual-paragraphs): Fix handling
	of adaptive-fill.  Call fill-context-prefix, but bind
	adaptive-fill-first-line-regexp to a null string.

1997-08-18  Olivier Lecarme  <ol@aiguemarine.unice.fr>

	* forms.el, hscroll.el, indent.el, server.el, sort.el: Customized.

1997-08-18  Mark Mitchell  <mmitchell@usa.net>

	* font-lock.el (c++-font-lock-keywords-2):
	Ensure that public and private are not fontified as labels.

1997-08-18  Kenichi Handa  <handa@etl.go.jp>

	* international/kkc.el (kkc-region): New arg
	kkc-mode-exit-function.

	* international/quail.el (quail-inactivate): Turn Quail mode off
	by itself.
	(quail-translation-keymap): Don't bind thee key "C-\".
	(quail-conversion-keymap): Likewise.
	(quail-define-package): Indentation fixed.
	(quail-setup-overlays): New arg conversion-mode.  Pay attention to
	input-method-highlight-flag.
	(quail-mode-line-format): Deleted.
	(quail-generate-mode-line-format): Deleted.
	(quail-mode): Don't handle input-method-inactivate-hook and
	input-method-activate-hook here.  Delete code setting
	quail-mode-line-format.
	(quail-saved-current-map): Name changed from
	quail-saved-overriding-local-map.
	(quail-toggle-mode-temporarily): Completely re-written.
	(quail-execute-non-quail-command): Use
	quail-toggle-mode-temporarily.
	(quail-conv-overlay-modification-hook): Deleted.
	(quail-suppress-conversion): Deleted.
	(quail-start-translation): Completely re-written.
	(quail-start-translation-in-conversion-mode): Likewise.
	(quail-delete-region): Check if quail-overlay is active.
	(quail-get-current-str): Don't call throw.  Set
	overriding-terminal-local-map correctly.
	(quail-update-translation): Run hooks in
	input-method-after-insert-chunk-hook.
	(quail-self-insert-command): Catch 'quail-tag here.
	(quail-conversion-delete-char): Don't call throw.  Set
	overriding-terminal-local-map to nil.
	(quail-conversion-backward-delete-char): Likewise.
	(quail-no-conversion): Likewise.
	(quail-help-insert-keymap-description): Bind
	overriding-terminal-local-map instead of overriding-local-map.

	* international/mule-cmds.el (previous-input-method): This
	variable deleted.
	(input-method-history): New variable.
	(read-input-method-name): Bind minibuffer-history to
	input-method-history.
	(activate-input-method): Delete codes handling
	previous-input-method.  Run hooks in input-method-activate-hook.
	(inactivate-input-method): Update input-method-history.  Run hooks
	in input-method-inactivate-hook.
	(select-input-method): Doc-string modified.  Use
	input-method-history instead of previous-input-method.  Set
	default-input-method to input-method.
	(toggle-input-method): Doc-string modified.  Use
	input-method-history instead of previous-input-method.
	(read-multilingual-string): Bind minibuffer-setup-hook correctly.
	(input-method-exit-on-invalid-key): New variable.

	* isearch.el (isearch-multibyte-characters-flag): Deleted.
	(isearch-mode): Do not bind isearch-multibyte-characters-flag and
	isearch-input-method.
	(isearch-printing-char): Use current-input-method instead of
	isearch-input-method.
	(isearch-message-prefix): Likewise.

	* international/isearch-x.el (isearch-input-method): Deleted.
	(isearch-input-method-title): Deleted.
	(isearch-toggle-specified-input-method): Call toggle-input-method.
	(isearch-toggle-input-method): Likewise.
	(isearch-process-search-multibyte-characters): Use
	current-input-method instead of isearch-input-method.

1997-08-17  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* faces.el: Faces now have 2 more elements, bold-p and italic-p.
	(internal-facep, make-face, x-create-frame-with-faces): 
	Create frames with those elements.
	(face-bold-p, face-italic-p): Just fetch those elements.
	(set-face-italic-p, set-face-bold-p): Doc fixes.
	(make-face-bold, make-face-italic, make-face-bold-italic)
	(make-face-unbold, make-face-unitalic): Set those new elements.

Sat Aug 16 21:50:45 1997  Geoff Voelker  <voelker@cs.washington.edu>

	* dos-w32.el: Set default coding system to undecided-dos.
	(find-buffer-file-type-coding-system):
	For writing, use buffer-file-coding-system if set, otherwise
	buffer-file-type.
	(find-file-not-found-set-buffer-file-coding-system):
	Renamed from find-file-not-found-set-buffer-file-type.
	Set buffer-file-coding-system as well as buffer-file-type.

1997-08-16  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* international/mule.el (load-with-code-conversion):
	Bind enable-multibyte-characters to t.

	* international/mule-cmds.el (toggle-input-method)
	(select-input-method): Always set default-input-method.
	Show default in the prompt only if there is one.

	* language/european.el (setup-latin1-environment): Don't set
	special-microsoft-code-table here.

	* international/mule-cmds.el (activate-input-method):
	Handle the new rule that default-input-method is now global only.

	* international/isearch-x.el (isearch-process-search-multibyte-characters):
	Bind input-method-verbose-flag, not input-method-tersely-flag.

	* international/mule-cmds.el (input-method-verbose-flag): Renamed
	from input-method-tersely-flag and sense inverted.
	(input-method-highlight-flag): New variable.
	(toggle-input-method): Pass missing arg to read-input-method-name.
	
	* international/quail.el (quail-guidance-buf): Now a permanent local.
	(quail-update-guidance, quail-show-guidance-buf):
	Test input-method-verbose-flag.
	(quail-setup-overlays): Underline quail-conv-overlay
	only if input-method-highlight-flag is non-nil.

1997-08-16  Kenichi Handa  <handa@etl.go.jp>

	* language/china-util.el (setup-chinese-gb-environment): Delete
	a code setting default value of default-input-method.
	(setup-chinese-big5-environment): Likewise.
	(setup-chinese-cns-environment): Likewise.

	* language/ethio-util.el (setup-ethiopic-environment): Likewise.

	* language/european.el (setup-8-bit-environment): Likewise.

	* language/japan-util.el (setup-japanese-environment): Likewise.

	* language/korean.el (setup-korean-environment): Likewise.

	* language/tibet-util.el (setup-tibetan-environment): Likewise.

	* international/mule.el (make-coding-system): Add a new FLAGS
	element ACCEPT-LATIN-EXTRA-CODE.

	* international/mule-conf.el: Set 146th element of
	latin-extra-code-table to `t'.

1997-08-15  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* progmodes/etags.el (tags-verify-table): Obey revert-without-query.

	* loadup.el (loaddefs.el): Load that file much later, almost last.
	Delete most calls to garbage-collect.

1997-08-15  Barry A. Warsaw  <cc-mode-help@python.org>

	* cc-styles.el (c-style-alist):
	"python" style requires c-comment-continuation-stars be "".

	* cc-engine.el (c-end-of-statement-1):
	Eliminate false hits on important characters
	inside literals (strings, comments).

	* cc-cmds.el (c-comment-line-break-function):
	In this function, and the defadvice,
	call indent-new-comment-line if not in a comment.

	* cc-cmds.el (c-fill-paragraph):
	Remove conditional on obsolete variable
	c-double-slash-is-comments-p.

	* cc-vars.el (c-buffer-is-cc-mode): Definition moved to cc-mode.el

	* cc-mode.el (c-buffer-is-cc-mode):
	Definition moved here from cc-vars.el.  Also,
	put permanent-local property on variable so it's value won't get
	killed by kill-all-local-variables.

	* cc-mode.el (c++-mode, java-mode, objc-mode, idl-mode):
	Remove obsolete variable c-double-slash-is-comments-p.

	* cc-langs.el (c-double-slash-is-comments-p): Remove obsolete variable.

1997-08-15  Boris Goldowsky  <boris@gnu.ai.mit.edu>

	* simple.el (shell-command-on-region): New argument ERROR-BUFFER.

	* format.el (format-alist): Typo fix.
	(format-encode-run-method, format-decode-run-method): Put error
	output from shell command in temp buffer, not data buffer.

1997-08-14  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* format.el (format-annotate-atomic-property-change): Fix prev change.

1997-08-13  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* simple.el (do-auto-fill): Better handling of a very long word
	after a fill-prefix.  Don't break right after the prefix and
	don't break at the end of the line.

	* emacs-lisp/lucid.el (extent-properties, extent-at): New functions.

1997-08-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* international/mule-cmds.el (default-input-method):
	Variable no longer automatically local.

	* language/european.el (setup-8-bit-environment):
	Use `require' to load the latin-N file.

	* international/quail.el (quail-start-translation):
	Use an explicit loop, not recursive edit.
	(quail-suppress-conversion): Doc fix.

	* international/mule-cmds.el (read-input-method-name):
	Replace INITIAL-INPUT arg with DEFAULT arg.
	Substitute it into to the prompt, if it is non-nil.
	(select-input-method): Call read-input-method-name the new way.
	(toggle-input-method): Likewise.

	* simple.el (forward-visible-line): Handle nil value from
	next-single-property-change or previous-single-property-change.

	* diary-lib.el (diary-entry-time): Bind case-fold-search to nil.

1997-08-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* wid-edit.el (widget-before-change): Obey `inhibit-read-only'.

1997-08-12 +03  Eli Zaretskii  <eliz@is.elta.co.il>

	* add-log.el (change-log-font-lock-keywords): Don't consider
	a closeparen as part of a function or variable name.

1997-08-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* progmodes/etags.el (verify-tags-table-function): Doc fix.

	* emacs-lisp/lucid.el (set-extent-property): Don't allow
	multiple extents with a mouse-face property to run together.

	* textmodes/fill.el (fill-region-as-paragraph):
	When justifying, cope if line ends in spaces and no newline.

1997-08-12  Eli Zaretskii  <eliz@psilocin.gnu.ai.mit.edu>

	* cus-edit.el (custom-file): Run ".emacs" through
	convert-standard-filename before using it.

1997-08-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs-lisp/shadow.el (list-load-path-shadows): Exclude, from the
	path we search, all but the first set of directories that include
	the standard Emacs Lisp files.

	* mail/sendmail.el (mail-send): Ask for confirmation if
	message contains non-ASCII characters.
	(mail-send-nonascii): New variable.

	* compile.el (compilation-error-regexp-alist): New regexp for Caml.

1997-08-11  Paul Eggert  <eggert@twinsun.com>

	* rmail.el (rmail-make-in-reply-to-field): Don't cause an
	error if the `From:' line has no valid email addresses.

1997-08-11  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cal-tex.el (cal-tex-latexify-list):
	Put the elements of RESULT in the proper order.
	(cal-tex-list-diary-entries): Bind diary-list-include-blanks to nil.

	* progmodes/cc-cmds.el (c-electric-brace): Make preserve-p nil at BOB.

	* files.el (insert-file-literally): New command.

	* progmodes/cc-styles.el (c-style-alist) <gnu>:
	Set c-comment-continuation-stars and c-hanging-comment-ender-p.

	* language/european.el (setup-latin1-environment):
	Set code 222 in special-microsoft-code-table.

1997-08-11 Dan Nicolaescu <done@ece.arizona.edu>

	* abbrev.el: Customized. 
	(only-global-abbrevs): Doc fix.

	* dabbrev.el (dabbrev-abbrev-skip-leading-regexp): Doc fix. 

1997-08-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-face.el (custom-face-attributes): Don't initialize fg/bg fields. 

1997-08-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* gnus/nnheaderxm.el: File deleted--not really needed.

	* avoid.el (mouse-avoidance-timer): New variable.
	(mouse-avoidance-mode): Create or cancel a time,
	instead of using post-command-idle-hook.

1997-08-10  Eli Zaretskii  <eliz@is.elta.co.il>

	* term/pc-win.el (msdos-color-aliases): Remove color names which
	end with a number.
	(msdos-color-translate): Handle color names which end with a
	number, like gray85 and purple3.
	(msdos-face-setup): Call `face-set-after-frame-default', so
	default faces are correctly set.
	Do not set background of the region face (it is set by
	`face-set-after-frame-default').

	* dos-fns.el (dos-print-region-function): Force EOL conversion to
	DOS CR-LF pairs.

1997-08-10  Barry A. Warsaw  <cc-mode-help@python.org>

	* Release 5.15

	* cc-align.el (c-lineup-java-throws):
	Change the `when' clause to an `if-progn'.

	* cc-cmds.el (indent-new-comment-line): On older Emacs versions,
	add advice, to work around lack of comment-line-break-function.

	* cc-cmds.el (c-electric-slash):
	Make this work as the final slash in a */ block
	oriented comment closing token.

	* cc-cmds.el (c-comment-line-break-function): New function.

	* cc-vars.el (c-buffer-is-cc-mode): New variable.

	* cc-vars.el (c-comment-continuation-stars): New variable.

	* cc-mode.el (c-initialize-cc-mode): Set c-buffer-is-cc-mode to t.

	* cc-mode.el (c-initialize-cc-mode): Require 'cc-mode-19
	if functionp is not bound.  Check cc-mode-19 interface requirements.

	* cc-mode.el (c-mode, c++-mode, objc-mode, java-mode, idl-mode):
	Don't set comment-multi-line here.

	* cc-mode.el (c-mode): c-comment-start-regexp uses
	c-C++-comment-start-regexp to support line oriented comments.

	* cc-langs.el (c-mode-base-map, c++-mode-map):
	Move `/' as an electric character
	from c++-mode-map to c-mode-base-map for all languages.

	* cc-langs.el (c-common-init): Set comment-multi-line and
	comment-line-break-function here for all modes.
	Make comment-line-break-function buffer local iff it's boundp.

	* cc-langs.el (c-C-comment-start-regexp): Obsolete.

	(c-comment-start-regexp): Initialize from c-C++-comment-start-regexp.

	(c-populate-syntax-table, c-setup-dual-comments): Merge both functions
	into c-populate-syntax-table.  With the new 9X draft C standard, both
	line and block oriented comments are supported in all modes, so always
	set up the syntax tables to support both comment styles.

	(c-enable-//-in-c-mode): Obsolete.

	* cc-langs.el (c++-mode-syntax-table, java-mode-syntax-table)
	(objc-mode-syntax-table, idl-mode-syntax-table): Added autoload
	cookies.  c-mode-syntax-table already has one.  Use the new syntax
	table initialization idioms.

	* cc-engine.el (c-guess-basic-syntax):
	CASE 5D.4: template argument continuation
	lines are now analyzed as template-args-cont.

	* cc-styles.el (c-offsets-alist):
	Added template-args-cont syntactic symbol.

	* cc-styles.el (c-styles-alist):
	In "java" style, set c-hanging-comment-starter-p to
	nil to preserve Javadoc starter lines.

1997-08-10 Dan Nicolaescu <done@ece.arizona.edu>

	* emulation/pc-select.el: Customized. 

1997-08-10  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* language/japanese.el: Make coding system iso-2022-jp instead of
	declaring it as an alias of iso-2022-7bit.

1997-08-10  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el (make-coding-system): Add a new FLAGS
	elements SAFE.  Use it for terminal coding system if some other
	coding system is specified explicitly.
	(ignore-relative-composition): Initialize
	ignore-relative-composition.

	* international/mule-util.el(prefer-coding-system): Moved to
	mule-util.el.

	* international/mule-cmds.el (set-default-coding-systems):
	Doc-string modified.
	(prefer-coding-system): Moved from mule-util.el.  Call
	set-default-coding-systems.

	* international/mule-conf.el (iso-safe): New coding system.

	* international/mule-diag.el (print-fontset): Don't hang even if a
	fontset name doesn't confirm to XLFD.
	(describe-current-coding-system): Do not show the same coding
	system twice in the list of priority order.

	* international/encoded-kb.el (saved-input-mod): New variable.
	(encoded-kbd-mode): Doc-string fixed.  Save current-input-mode
	when turning on Encoded-kbd mode, and recover it when turning off
	Encoded-kbd mode.  Set encoded-kbd-iso2022-designations correctly.
	(encoded-kbd-self-insert-iso2022-7bit): Call charset-dimension
	instead fo charset-bytes.
	(encoded-kbd-self-insert-iso2022-8bit): Likewise.

	* language/china-util.el (setup-chinese-gb-environment): Do not
	change sendmail-coding-system and rmail-file-coding-system.
	(setup-chinese-big5-environment): Likewise.
	(setup-chinese-cns-environment): Likewise.

	* language/english.el (setup-english-environment): Likewise.

	* language/european.el (setup-8-bit-environment): Likewise.

	* language/japan-util.el (setup-japanese-environment): Likewise.

	* language/tibet-util.el (setup-tibetan-environment): Likewise.

	* language/lao.el: Set t for Rao-SEMIVOWEL-SIGN-LO in
	ignore-relative-composition.

	* language/lao-util.el: Correct setting of char-code-property `name'.

1997-08-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* dired.el (dired-font-lock-keywords): Don't specially highlight
	files that are writable by others.

	* cus-face.el (custom-declare-face):
	Call make-face-x-resource-internal.

	* progmodes/awk-mode.el (awk-mode): Require cc-mode, not cc-langs.

	* wid-edit.el (widget-single-line-display-table): Variable
	commented out; don't use it either.

	* case-table.el: Delete autoload cookies (file is preloaded).

	* format.el (format-alist): Doc fix.

	* help.el (describe-key): Don't put a colon after the command name.

1887-08-09  Barry A. Warsaw  <cc-mode-help@python.org>

	* progmodes/cc-engine.el (c-beginning-of-statement-1):
	When checking for bare semi, don't match
	on a semi following a close brace.

	* progmodes/cc-vars.el (idl-mode-hook): New variable.

	* progmodes/cc-vars.el (c-initialization-hook): New variable.

	* progmodes/cc-mode.el (idl-mode): Support for CORBA's IDL language.

	* progmodes/cc-mode.el (c-initialize-cc-mode): move the calling of
	c-make-styles-buffer-local into c-initialize-builtin-style.

	* progmodes/cc-mode.el (c-initialize-cc-mode): Run the
	c-initialization-hook, but only once per Emacs session.

	* progmodes/cc-styles.el (c-styles-alist): In "java" style, set
	c-hanging-comment-starter-p to nil to preserve Javadoc starter lines.

	* progmodes/cc-styles.el (c-set-style-2):
	Fixed broken implementation of inherited styles.

	* progmodes/cc-styles.el (c-set-style):
	Call c-initialize-builtin-style.
	(c-initialize-builtin-style): Handle c-style-variables-are-local-p.

	* progmodes/cc-engine.el (c-guess-basic-syntax):
	CASE 5I: When adding 'inclass syntax, use the
	relpos pointing to the class opening brace, unless that hangs on the
	right side, in which case, use the start of the class/struct keyword.

	* progmodes/cc-langs.el (c-symbol-key):
	First character must be a letter or underscore.
	(c-styles-are-initialized): Variable deleted.
	(c-common-init): Don't initialize styles here.

	* progmodes/cc-langs.el (idl-mode-abbrev-table): New variable.
	(idl-mode-map, idl-mode-syntax-table): New variables.
	(c-idl-menu): New menu.
	
1997-08-09  Erik Naggum  <erik@naggum.no>

	* telnet.el (telnet-host-properties): Initialize it properly.

1997-08-09  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper-init.el: More defface work.
	* ediff-init.el: Converted to use defface instead of make-face.
	
1997-08-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* textmodes/fill.el (enable-kinsoku): Doc fix.

	* emulation/viper-init.el (viper-replace-overlay-pixmap)
	(viper-search-face-pixmap): Variables deleted.
	(viper-replace-overlay-face, viper-search-face):
	Use "gray3" explicitly.

	* help.el (help-mode): Set view-no-disable-on-exit.

	* view.el (view-just-bury): New variable.
	(view-mode-exit): Obey it.

	* emacs-lisp/shadow.el: Renamed from shadow.el.

	* simple.el (completion-setup-function): Don't set completion-base-size
	when completing in a non-minibuffer.

	* shadow.el (find-emacs-lisp-shadows): Don't mention `subdirs.el'.
	(list-load-path-shadows): When noninteractive, if there are shadows,
	start with a message explaining what this is a problem.

	* files.el (find-file-noselect):
	Clear enable-multibyte-characters if RAWFILE.
	(find-file-literally): Don't do that here.
	(find-file-literally): New variable.  Mark it with permanent-local.
	(find-file-noselect): If RAWFILE, set find-file-literally locally.
	Warn if file was already visited and RAWFILE was different.

	* startup.el (command-line-1): Don't let type-ahead inhibit the
	initial contents of *scratch*.

1997-08-08  Boris Goldowsky  <boris@gnu.ai.mit.edu>

	* format.el (format-annotate-single-property-change,
	format-annotate-atomic-property-change): move code that interprets
	nil as 0 inside test that property is numeric.

1997-08-08  Valery Alexeev  <valery@math.uga.edu>

	* language/cyril-util.el (cyrillic-language-alist): Fix punctuation.

1997-08-07  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* textmodes/fill.el (fill-region-as-paragraph): Don't do kinsoku
	if the region is all ASCII.

1997-08-08 Dan Nicolaescu <done@sydney.ece.arizona.edu>

	* progmodes/hideshow.el: Correct the autoload cookies. 

1997-08-07 Dan Nicolaescu <done@ece.arizona.edu>

	* term.el (term-default-fg-color): 
	(term-default-bg-color): Default to nil. 

1997-08-07  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* progmodes/cc-styles.el (c-set-offset): Add autoload cookie.

	* term/pc-win.el (x-list-fonts): Return "default" when appropriate.
	(query-fontset): Add (alternative) alias definition.

1997-08-07  Roland McGrath  <roland@beet-chex.ai.mit.edu>

	* emacs-lisp/autoload.el (update-file-autoloads): Use anchored regexp
 	search instead of requiring leading newline before
 	generate-autoload-cookie, which gave false negative if sole cookie in
 	file was at bob.

1997-08-07  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs-lisp/elint.el: New file.

	* language/cyril-util.el (cyrillic-language-alist): Add one language.

1997-08-07  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper-util.el: Moved faces to viper-init.el
	* viper-init.el: Converted faces to use defface.
	* viper.el (viper-set-hooks): Bug fixed.
	
1997-08-07  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* mail/sendmail.el (sendmail-send-it): Bind sendmail-coding-system
	to buffer-file-coding-system if it is non-nil.

1997-08-06  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* term/iris-ansi.el: New file.

	* calendar.el: Fix previous change.

	* files.el (insert-file-contents-literally): Doc fix.

	* international/quail.el (quail-update-leim-list-file):
	Use insert-file-contents instead of find-file-noselect
	and in the process avoid the RAWFILE feature.

	* ispell.el (ispell-dictionary-alist): Doc fix.

1997-08-05  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* compile.el (compilation-parse-errors): Fix previous change.

	* vc.el (vc-version-diff): Change the Newer version prompt.

	* subr.el (read-quoted-char): Fix handling of meta-chars.
	(functionp): Use byte-code-function-p, not compiled-function-p.

	* faces.el (set-face-doc-string): Define once again, as alias.

	* mail/sendmail.el (mail-mode): Allow TAB after prefix
	in previous change.

	* Makefile (updates): Add missing semicolons.

	* finder.el (finder-compile-keywords): Don't process file names
	that start with `.'.

	* emacs-lisp/autoload.el (update-autoloads-from-directories):
	Don't process file names that start with `.'.
	
	* gud.el (gud): Fix defgroup doc.

	* compile.el (compilation-error-regexp-alist): Make the
	MIPS/DEC pattern more specific at the start; accept warnings
	as well as errors.

	* term/x-win.el (x-cut-buffer-or-selection-value): Fix previous change.

	* mail/sendmail.el (mail-mode): Fix previous change.
	Treat a supercite prefix not followed by text
	as a paragraph separator.

	* term/lk201.el: Undo previous change.

	* simple.el (comment-line-break-function): New variable.
	(do-auto-fill): Use that variable.

	* files.el (cd-absolute): Add missing arg to `error'.

	* Makefile (dontcompilefiles): Delete cyril-util.el.

	* language/cyril-util.el (standard-display-cyrillic-translit):
	Set standard-display-table here, not when loading the file.
	Read argument properly with `interactive'.

	* format.el (format-annotate-atomic-property-change):
	Look thru all elements of PROP-ALIST for a number,
	if OLD and NEW are numbers.

	* international/mule.el: Doc fixes.
	
1997-08-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* time-stamp.el (time-stamp): Use insert-and-inherit for new stamp.

1997-08-04  Valery Alexeev  <valery@math.uga.edu>

	* language/cyril-util.el (cyrillic-language-alist): New variable.
	(standard-display-cyrillic-translit): Add autoload cookie.

1997-08-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* select.el (x-get-selection): Change default for data-type
	back to `STRING'.

1997-08-04  Espen Skoglund  <espensk@odslab5.cs.uit.no>

	* pascal.el (pascal-mode-syntax-table): _ is now a symbol constituent.
	(pascal-indent-case): Removed unnecessary calls to marker-position.
	(pascal-indent-declaration): Editing a parameterlist at the end of
 	a buffer does not hang.  Removed unnecessary call to marker-position.
	(pascal-get-lineup-indent): Removed unused variable.
	Indent parameterlist correctly.
	(pascal-completion-response): Removed unused variable.

1997-08-04  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* files.el (basic-save-buffer-1): Add missing argument for error.

	* isearch.el (isearch-quote-char): Fix handling of control
	characters, copied from quoted-insert.

	* emacs-lisp/pp.el (pp-to-string): Use
	emacs-lisp-mode-sytax-table.

	* international/quail.el (quail-update-leim-list-file): Go to the
	beginning of the package file, in case it was already visited.

1997-08-04  Kenichi Handa  <handa@etl.go.jp>

	* language/english.el (setup-english-environment): Call
	set-default-coding-systems.

	* language/china-util.el (setup-chinese-gb-environment): Do not
	call set-terminal-coding-system and set-keyboard-coding-system,
	instead call set-defualt-coding-systems.
	(setup-chinese-big5-environment): Likewise.
	(setup-chinese-cns-environment): Likewise.

	* language/european.el (setup-8-bit-environment): Likewise.

	* language/japan-util.el (setup-japanese-environment): Likewise.

	* language/korean.el (setup-korean-environment): Likewise.

	* international/mule-cmds.el (set-default-coding-systems): New
	function.

	* international/mule.el (default-terminal-coding-system): New var.
	(set-terminal-coding-system):
	Use default-terminal-coding-system as default.
	(default-keyboard-coding-system): New variable.
	(set-keyboard-coding-system):
	Use default-keyboard-coding-system as default.

1997-08-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* delsel.el (delete-selection-mode): Delete the :initialize keyword.
	Don't explicitly check the value and call delete-selection-mode.
	Don't put on a custom-loads property.

	* emacs-lisp/autoload.el (make-autoload): For a defcustom,
	generate custom-add-to-group and custom-add-load if needed.

	* progmodes/cpp.el (cpp-create-bg-face): Don't really make a face.
	Just make (background-color . COLOR).
	(cpp-highlight-buffer): Don't die if buffer-invisibility-spec is t.
	(cpp-face-default-list): Doc fix, fix custom type.
	(cpp-edit-reset): Add a close-quote after the file name.

	* isearch.el (isearch-other-meta-char): Don't switch windows to exit
	if that would switch to an inactive minibuffer.

	* progmodes/meta-mode.el: Moved from textmodes/meta-mode.el.
	
	* vc.el (vc-version-diff): Use defaults, not initial input,
	for reading the arguments.

	* faces.el (internal-face-interactive): Handle default in usual way,
	Provide completion for color reading.
	(set-face-foreground, set-face-background): Specify `color'
	when reading the color name interactively.

1997-08-03  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* help.el (describe-function): Use " is " instead of colon.

	* uniquify.el (delay-uniquify-rationalize-file-buffer-names):
	Don't delete this function from kill-buffer-hook, if it is disabled.

	* textmodes/fill.el (fill-context-prefix): Accept a whitespace
	prefix from the second line, regardless of the first line.

	* shell.el (shell): Doc fix.

	* faces.el: Alternative colors for standard faces if dark background.

	* hexl.el (hexlify-buffer, dehexlify-buffer):
	Pay attention to buffer-file-type.
	(hexl-save-buffer): Don't bind buffer-file-type around save-buffer.

	* term/x-win.el (x-cut-buffer-or-selection-value): Try both
	COMPOUND_TEXT and STRING as types for the selection.

	* simple.el (shell-command-on-region, shell-command): Doc fixes.
	(do-auto-fill): Don't break the line right after a comment starter.

	* emacs-lisp/copyright.el (copyright-regexp): Recognize the Latin-1
	copyright symbol.  Also @copyright{}.

	* mail/rmailsum.el (rmail-summary-mouse-goto-message): New function.
	(rmail-summary-mode-map): Bind it to Mouse-2.
	
	* files.el (insert-file-contents-literally):
	Bind coding-system-for-read and coding-system-for-write,
	and bind jka-compr-compression-info-list instead of
	file-name-handler-alist.
	(find-file-literally): Simplify and use insert-file-contents-literally.

1997-08-03  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-hooks.el (vc-menu-map): Replace entries for "Check In" and
 	"Check Out" with new entry "Check In/Out" (calling
 	vc-next-action).

1997-08-03  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cus-edit.el (custom-face-value-create): Take account
	of changes in the frame made outside of customize.

1997-08-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* faces.el (face-attr-match-p): New function.
	(face-attr-match-1, face-spec-match-p, face-attr-construct): Likewise.
	(face-spec-choose): New function.
	(face-spec-set): Use face-spec-choose.

1997-08-03  Kenichi Handa  <handa@etl.go.jp>

	* term/x-win.el: Fix previous change.

	* international/quail.el (quail-next-translation): Call
	quail-execute-non-quail-command when no current translations.
	(quail-prev-translation): Likewise.
	(quail-next-translation-block): Likewise.
	(quail-prev-translation-block): Likewise.

	* language/china-util.el (setup-chinese-gb-environment): Set
	default value of default-input-method.
	(setup-chinese-big5-environment): Likewise.
	(setup-chinese-cns-environment): Likewise.  Correct input method
	name.

	* language/ethio-util.el (setup-ethiopic-environment): Bind
	correct commands in global-map, rmail-mode-map, and mail-mode-map.

	* language/ethiopic.el (ccl-encode-ethio-font): Fix typo in
	doc-string.  Set default value of default-input-method.

	* language/european.el (setup-8-bit-environment): Likewise.

	* language/japan-util.el (setup-japanese-environment): Likewise.

	* language/korean.el (setup-korean-environment): Likewise.

	* language/tibet-util.el (setup-tibetan-environment): Likewise.

1997-08-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* international/mule-cmds.el: Doc fixes; fix error message text.

	* timezone.el (timezone-parse-date): Handle additional style (9).

	* term.el (term-ignore-error): Fix foolish errors.

	* strokes.el (strokes): New file.

	* international/mule-diag.el (describe-current-coding-system):
	Clean up output format.

1997-08-02  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper.el (toggle-viper-mode): New function.
	* viper-mouse.el (viper-mouse-search-key,viper-mouse-insert-key): 
	New variables.
	(viper-bind-mouse-search-key,viper-bind-mouse-insert-key,
	viper-unbind-mouse-search-key,viper-unbind-mouse-insert-key):
	New functions.
	* viper*el: vip-style names changed to viper-style names.
	
1997-08-01  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* mail/sendmail.el (mail-mode): Recognize foo> prefix
	even without leading space.

	* hexl.el (hexl-find-file): Use find-file-literally.
	(hexlify-buffer): Bind coding-system-for-write.
	(dehexlify-buffer): Bind coding-system-for-read.

	* isearch.el (isearch-hide-immediately): Doc fix.

1997-08-01  Valery Alexeev  <valery@math.uga.edu>

	* language/cyril-util.el (standard-display-cyrillic-translit):
	New function.

1997-07-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* startup.el (command-line): Pass t for AUTO arg to
	standard-display-european.

	* disp-table.el (standard-display-european): New arg AUTO.
	Normally, set enable-multibyte-characters to nil.

Thu Jul 31 16:26:05 1997  Geoff Voelker  <voelker@cs.washington.edu>

	* term/w32-win.el:  Set mode-line-frame-identification
	to remove frame name from mode-line instead of 
	mode-line-buffer-identification.

1997-07-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* calendar.el (diary-face, calendar-today-face, holiday-face):
	Use defface to define them.

	* term/lk201.el (function-key-map): Map to ASCII DEL, not to delete.

	* emacs-lisp/lisp-mode.el (eval-last-sexp): Ignore `...' around sexp.

1997-07-31  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* international/mule-util.el (prefer-coding-system): Change also
	default value of buffer-file-coding-system.

1997-07-31  Kenichi Handa  <handa@etl.go.jp>

	* faces.el (set-face-font-auto): Create a fontset if FONT is a
	fontset not instanciated fontset.

	* international/fontset.el (fontset-name-p): New function.
	(uninstanciated-fontset-alist): New variable.
	(create-fontset-from-fontset-spec): Delete arg STYLE.  Register
	style-variants of FONTSET in uninstanciated-fontset-alist.
	(create-fontset-from-x-resource): Call
	create-fontset-from-fontset-spec correctly.

	* international/mule-util.el (reference-point-alist): Doc-string
	modified.

	* term/x-win.el: Do not create style-variants of fontset.  They
	are just registered in uninstanciated-fontset-alist.

1997-07-31  Michael Kifer  <kifer@cs.sunysb.edu>

	* ediff*el: (ediff-eval-in-buffer): changed macro and renamed
	ediff-with-current-buffer.
	Eliminated inefficient calls to `intern'.
	* ediff-diff.el: (ediff-exec-process): changed to work with buffers
	whose names have spaces. 
	(ediff-wordify): use buffer-substring-no-properties.
	
1997-07-30  Andre Spiegel  <spiegel@inf.fu-berlin.de>

        * vc-hooks.el (vc-checkout-model): For CVS, look at
        permissions to see if a file is "watched".

        * vc.el (vc-backend-checkin): For CVS, forget the checkout model 
        after commit.
        (vc-backend-checkout): Use "cvs edit" for files with manual checkout.
        (vc-minor-part, vc-previous-version): New functions.
        (vc-diff): Don't ask or guess version numbers.
        (vc-version-diff): Suggest default versions based on the file state.

1997-07-30  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* uniquify.el (uniquify-buffer-name-style): Fix typo.

	* info.el (info-node, info-xref, info-menu-5):
	Define faces with defface.
	(Info-mode): Don't define faces here, and don't alter Info-fontify.
	Locally set line-move-ignore-invisible.
	(Info-fontify-node): Test type of frame here.

1997-07-30  Stephen Eglen  <stephene@cogs.susx.ac.uk>

	* mspools.el (mspools-using-vm): Better handling of VM initialization.
	(mspools-size-folder): Allow symbolic links to spool files.

1997-07-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-edit.el (hook): Support hooks whose value is just a symbol.
	(custom-magic-value-create): Support `mismatch'	form. 
	(custom-variable-value-create): Ditto.
	(custom-variable-set): Ditto.
	(custom-variable-save): Ditto.
	(custom-variable-menu): Ditto.
	(custom-load-symbol): Check that `preloaded-file-list' is bound.
	(custom-group-value-create): Comment out `indent'.

1997-07-30  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* bindings.el (mode-line-mule-info): Delete the conditional
	on enable-multibyte-characters.

	* international/mule-cmds.el (mule-menu-keymap): Fix menu item names.

1997-07-29  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* textmodes/fill.el (adaptive-fill-first-line-regexp): Fix regexp.

1997-07-29  Simon Marshall  <simon@diazepam.gnu.ai.mit.edu>

	* font-lock.el: Don't add indicator " Font" to minor-mode-alist entry.

1997-07-29 Oscar Figueiredo <<Oscar.Figueiredo@di.epfl.ch>

	* ph.el: Many doc strings and messages changed.

1997-07-28  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* mail/rmail.el (rmail-resend): Use user-mail-address.

	* bindings.el (debug-ignored-errors): Delete ^Quit$ element.

1997-07-28  Olivier Lecarme  <ol@aiguemarine.unice.fr>

	* progmodes/make-mode.el (makefile-space-face): Add defface.
	(makefile-define-space-face): Function deleted.
	(makefile-mode): Don't call makefile-define-space-font.

1997-07-28 Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-edit.el (customize-save-variable): New command.

	* wid-edit.el (widget-move): Use `previous-overlay-change' and
	`next-overlay-change'. 
	(widget-use-overlay-change): New option to control it.

	* cus-edit.el (custom-save-all): Inhibit read only.

	* wid-edit.el (regexp): Outcomment :value-face.
	(file): Ditto.

	* wid-edit.el (widget-add-change): Use local hooks.
	(widget-before-change): Ditto.

	* wid-edit.el (set-text-properties): Don't define.
	(widget-specify-none): Delete.
	(widget-specify-text): Delete.
	(widget-field-use-before-change): Don't enable for XEmacs.
	(widget-specify-field): Don't use text properties.
	(widget-specify-field): Ditto.
	(widget-specify-doc): Ditto.
	(widget-specify-insert): Ditto.
	(widget-insert): Ditto.
	(widget-convert-text): Ditto.
	(widget-leave-text): Ditto.
	(widget-setup): Ditto.
	(widget-before-change): Ditto.
	(widget-default-create): Ditto.
	(widget-default-delete): Ditto.
	(widget-editable-list-insert-before): Ditto.
	(widget-editable-list-entry-create): Ditto.
	(widget-add-change): New function.

	* cus-edit.el (custom-file): Use same logic as startup.el

	* wid-edit.el (widget-field-use-before-change): Doc fix.

	* cus-edit.el (custom-group-members): New function.
	(custom-group-value-create): Use it rather than get.

	* wid-edit.el (emacs-library-link): New widget.
	(widget-emacs-library-link-action): New function.

	* wid-edit.el (widget-beginning-of-line): Preserve zmacs region.
	(widget-end-of-line): Ditto.

	* wid-edit.el (widget-color-sample-face-get): Kludge to make it
	work before widget is fully created.
	(widget-color-action): Try to use same relative position of point
	in minibuffer as it had in the field.

	* cus-edit.el (custom-mode): Document `M-TAB'.

1997-07-28  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* international/mule-util.el (prefer-coding-system): Fix doc, prompt.

1997-07-27  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs-lisp/autoload.el (update-autoloads-from-directories):
	Always update loaddefs.el in the source-directory.

	* progmodes/make-mode.el: Doc fixes.

	* compile.el (compile-command): More doc fix.

1997-07-24  Olivier Lecarme  <ol@aiguemarine.unice.fr>
	
	* progmodes/make-mode.el, progmodes/cpp.el: Customized.
	* facemenu.el: Customized.
	
1997-07-26  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* mail/mail-extr.el (mail-extr-voodoo): Handle unmatched quotes
	in the comment-deletion loop.

	* jka-compr.el (jka-compr-added-to-file-coding-system-alist): New var.
	(jka-compr-insert-file-contents): Set coding-system-for-read
	according to file name after removing compression suffix.
	(jka-compr-install): Add elemets to file-coding-system-alist.
	(jka-compr-uninstall): Remove elements from file-coding-system-alist.

	* international/mule-conf.el (file-coding-system-alist):
	Use no-conversion for tar files.

	* subr.el (read-quoted-char): Consistently downcase letter "digits".

	* mail/sendmail.el (mail-mode): Make adaptive-fill-regexp
	match more values.  Bind adaptive-fill-first-line-regexp too.

1997-07-26  Eric Raymond  <esr@snark.thyrsus.com>

	* telnet.el (telnet): Handle multiple telnet programs better.
	(telnet-host-properties): New variable.

1997-07-25  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* progmodes/awk-mode.el (awk-mode): Call c-initialize-cc-mode.

1997-07-25  Stephen Eglen  <stephene@cogs.susx.ac.uk>

	* replace.el (occur): Local variable line-start redundant.
	`occur-marker' extends to the end of the line rather than one char
	before end.

1997-07-25  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* international/quail.el (quail-update-leim-list-file): Call
	find-file-noselect with t for arguments NOWARN and RAWFILE.

	* international/mule-cmds.el (leim-list-entry-regexp): Make this
	match only at beginning of line.

1997-07-25  Erik Naggum  <erik@naggum.no>

	* compile.el (compile-command): Doc fix.

1997-07-25  Jonathan I. Kamens  <jik@kamens.brookline.ma.us>

	* rmail.el (rmail-pop-password-error): New variable.
	(rmail-insert-inbox-text): If there's an error getting mail from
	the POP server, and the error matches rmail-pop-password-error or
	we prompted for the POP password, assume that the password is
	incorrect and erase it so that the user will be prompted again the
	next time he gets mail.

1997-07-25  Simon Marshall  <simon@frobnitz.gnu.ai.mit.edu>

	* complete.el: Customise; as subgroup of minibuffer.
	(partial-completion-mode): New option to toggle mode.
	(partial-completion-mode): New command to toggle mode.
	Add and remove hooks here, i.e., not at the top-level.
	(PC-bindings): New function to install/restore minibuffer bindings.
	This is called by partial-completion-mode, i.e., not at the top-level.
	(PC-temp-minibuffer-message): Use unread-command-events, as
	unread-command-char is obsolete.

	* font-lock.el: Add new C++ type specifiers.

	* lazy-lock.el (lazy-lock-fontify-after-idle): Wrap
	minibuffer-auto-raise to prevent stealth messages raising the frame.

1997-07-25  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* international/mule-cmds.el (read-input-method-name): Show more
	appropriate error message.

1997-07-25  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-cmds.el: Typo in comment fixed.

	* language/thai-util.el (setup-thai-environment): Add correct
	autoload cookie.

	* language/tibet-util.el (setup-tibetan-environment): Correct
	coding system names.  Set default-input-method to "tibetan-wylie".

	* language/viet-util.el (setup-vietnamese-environment):  Add
	autoload cookie.

1997-07-25  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* mail/metamail.el (metamail-region): Don't bind kanji-fileio-code
	or file-coding-system.  Don't call define-program-kanji-code
	or define-program-coding-system.  Instead, bind coding-system-for-read.

1997-07-24  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* mail/metamail.el (
	* Makefile (ETAGS): New variable.
	(TAGS): Use ${ETAGS}.

	* emacs-lisp/bytecomp.el (byte-compile-output-docform):
	Bind print-gensym-alist; bind print-gensym to a cons cell.

	* winner.el (custom-print-functions): Add defvar.

1997-07-24  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper.el (viper-non-vi-major-modes): New variable.
	(vip-set-hooks): Changed so it'll update viper-non-vi-major-modes.
	(viper-mode): Now checks viper-non-vi-major-modes.
	
1997-07-24  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* ange-ftp.el: Doc fixes.

	* mail/sendmail.el (mail): Improve confirmation questions
	for file-visiting mail buffers.

	* simple.el (line-move): If intangibility moves us to a different line,
	adjust the hpos nicely in that line.

	* ediff-util.el (ediff-update-diffs): Change error message.

	* play/landmark.el (landmark-repeat, landmark): New aliases.
	Add autoload cookies.

	* play/handwrite.el: Many doc fixes.
	(handwrite): Add autoload cookie.
	(menu-bar-handwrite-map): Comment out the code to put this
	in the menu bar.

	* cus-face.el (custom-declare-face): Use [set-]face-documentation.

	* faces.el (face-documentation): Renamed from face-doc-string.
	(set-face-documentation): Renamed from set-face-doc-string.
	(face-doc-string): Make this an alias.

	* term/bg-mouse.el (bg-yank-or-pop): Changed eql to eq.

	* international/mule-cmds.el (read-input-method-name): Fix error msg.

	* terminal.el (te-newline): Change eql to eq.
	(te-insert-lines, te-delete-lines, te-process-output): Likewise.
	(te-parse-program-and-args, te-get-char): Likewise.

	* textmodes/tex-mode.el (tex-categorize-whitespace): Use eq, not eql.

	* bindings.el: Don't create C-x r and C-x n submaps here.

1997-07-23  Simon Marshall  <simon@diazepam.gnu.ai.mit.edu>

	* rmail.el (rmail-mime-feature): Doc and custom fix.

1997-07-24  Dan Nicolaescu  <done@ece.arizona.edu>

	* bindings.el (debug-ignored-errors): Update the dabbrev.el errors. 
	Add errors generated by ediff*.el.
	
1997-07-24  Olivier Lecarme  <ol@aiguemarine.unice.fr>
	
	* apropos.el, ange-ftp.el: Customized.

1997-07-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* calendar.el (calendar-day-name): New optional args WIDTH, ABSOLUTE.
	(calendar-month-name): New optional arg WIDTH.
	(generate-calendar-month, calendar-date-string): Pass new args
	instead of using substring here.

	* emacs-lisp/bytecomp.el (eql): byte-defop-compiler definition deleted.

	* mail/mh-e.el: Change eql calls to = or equal.

	* mail/mh-utils.el: Change eql calls to eq.

	* compile.el (compilation-error-regexp-alist): Add elt for EPC F90.

	* diary-lib.el (diary-entry-time): Downcase the am/pm letter.

	* faces.el (set-face-font-explicit): Call internal-set-face-1 properly.

1997-07-23  Stephen Eglen  <stephene@cogs.susx.ac.uk>

	* iswitchb.el (iswitchb-get-bufname): Only add buffer of current
	window  if it is not already in list.

1997-07-23  Ulrik Vieth  <vieth@thphy.uni-duesseldorf.de>

	* textmodes/meta-mode.el (metafont-mode):  Add autoload cookie.
	(metapost-mode): Add autoload cookie.

	* files.el (auto-mode-alist): Add ".mf" and ".mp" for meta-mode.el.
	Add ".clo" for latex-mode.
	
1997-07-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* ph.el: Various error messages fixed.
	(ph-cadr, ph-cadr): New functions.
	All calls to cdar and cadr changed.

	* ph.el: New file.
	
	* international/mule.el (modify-coding-system-alist): Doc fix.

1997-07-22  Geoff Voelker  <voelker@cs.washington.edu>

	* dos-w32.el (find-buffer-file-type-coding-system,
	find-buffer-process-coding-system): Remove second argument.

1997-07-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* textmodes/texinfmt.el (dircategory): Delete obsolete mistaken `put'.
	(texinfo-end-direntry): Output extra newline.
	(texinfo-format-dircategory): Parse the arg and reinsert it by hand.
	
1997-07-22  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper.el: Further twidling with require viper-init.
	
1997-07-21  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* jka-compr.el (jka-compr-call-process): Fix previous change.
	(jka-compr-write-region): Likewise.
	(jka-compr-insert-file-contents): Likewise.
	(jka-compr-file-local-copy): Bind coding-system-for-read and
	coding-system-for-write.

1997-07-21  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* textmodes/texinfmt.el (texinfo-end-direntry): Output two newlines. 

	* simple.el (yank, yank-pop): Bind inhibit-read-only
	just for remove-text-properties, not for insertion.

	* subr.el (read-quoted-char): Convert function keys like Return
	into ASCII equivalents.

	* mail/mh-utils.el (mh-make-folder-list-background):
	Don't call mh-find-path if we were called from there.
	(mh-find-path): Move mh-make-folder-list-background call to the end.

	* language/cyril-util.el (setup-cyrillic-environment): Fix paren error.

	* viper.el: Require viper-init.

1997-07-21  Boris Goldowsky  <boris@gnu.ai.mit.edu>

	* enriched.el (fixed, excerpt): Define with defface.  No longer
	queries X server to find a "fixed" font; that was too slow and
	didn't work for everyone.

1997-07-21  Simon Marshall  <simon@diazepam.gnu.ai.mit.edu>

	* compile.el (compilation-mode-font-lock-keywords): Ensure that each
	regexp generated from compilation-error-regexp-alist begins with "^".

1997-07-21  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* textmodes/fill.el (fill-context-prefix): Be stricter about
	whether first-line prefix is compatible with second-line prefix.

	* files.el (find-file-literally): Temporarily remove tar-mode and
	archive-mode from auto-mode-alist.

	* frame.el (frame-initialize): Don't alter vertical-scroll-bars
	parameter here.

	* scroll-bar.el (scroll-bar-mode-explicit): New variable.
	(set-scroll-bar-mode): Don't alter default-frame-alist
	when just loading this file.
	
	* mail/mh-utils.el (mh-find-path): Handle mh-auto-folder-collect here,
	not when this file is loaded.

1997-07-20  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* mail/sendmail.el (mail-indent-citation): Undo previous change.
	Instead, convert region-end to a marker before the loop.
	(mail-yank-original, mail-yank-region): Undo previous change.

	* custom.el (custom-declare-variable-list): Process already-declared
	custom variables from this list.

	* cus-start.el (debug-on-quit): Define like debug-on-error.
	
	* dired-x.el (dired-omit-new-add-entry): Take new arg RELATIVE
	and pass it to dired-omit-old-add-entry (which is dired-add-entry).

	* jka-compr.el (jka-compr-insert-file-contents): 
	Bind coding-system-for-read.
	(jka-compr-write-region): Bind coding-system-for-write.
	Set buffer-file-type if dos or nt.
	(jka-compr-call-process): Bind coding-system-for-read
	and coding-system-for-write.

1997-07-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* shell.el (shell-mode): Do set list-files-directory locally.

	* uniquify.el (uniquify-buffer-file-name): Minor change.

1997-07-19  Geoff Voelker  <voelker@cs.washington.edu>

	* dos-w32.el (find-buffer-file-type-coding-system):
	Use undecided-dos for dos-text file names.
	Use undecided for non-existing untranslated file names.

	* international/mule.el (modify-coding-system-alist): Added.
	international/mule-util.el (modify-coding-system-alist): Removed.
	
	* loadup.el [windows-nt, ms-dos]: Undo loading 
	of international/mule-utils.
	
1997-07-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* mail/sendmail.el (mail-mode): Set adaptive-fill-regexp specially
	to cater to supercite.
	(mail): Ask a different question, if buffer is visiting a file.

	* faces.el (internal-facep): Length is now 10.
	(make-face, x-create-frame-with-faces): Make a face 10 elements long.
	(internal-set-face-1): Don't call set-face-attribute-internal
	if NAME is nil.
	(set-face-font): Set the auto-flag to t or nil.
	(face-spec-set): Clear out the font at the start,
	if it was set automatically before.
	(face-font-explicit): New function.
	(set-face-font-auto): New function.
	(set-face-font-explicit): New function.
	(copy-face): Copy the face-font-external flag.
	(internal-try-face-font): Use set-face-font-auto.

	* files.el (auto-mode-alist): Recognize .emacs in MSDOG syntax.

1997-07-18  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* dos-w32.el (find-buffer-file-type-coding-system):
	Use emacs-mule-dos for text file names; use undecided-dos
	for the last resort (instead of emacs-mule-dos).

	* vc.el (vc-diff): Turn off previous change.

	* cus-edit.el (custom-group-value-create) <tree>: Don't distinguish
	unloaded groups; use [+] for them.
	(customize-browse): Fix top-of-buffer doc text.

	* mail/sendmail.el (mail-indent-citation): Take region args.
	(mail-yank-original, mail-yank-region): Pass the args.

1997-07-18  Dan Nicolaescu  <done@sydney.ece.arizona.edu>

	* progmodes/hideshow.el (hs-special-modes-alist): Use a regexp
	generated by regexp-opt.
	(hs-life-goes-on): Nullify inhibit-point-motion-hooks as we have
	to move inside intangible overlays.  Enable edebug.

	* isearch.el (search-invisible): Fix typo.
	(isearch-search): Bind inhibit-point-motion-hooks because we might
	have to search inside invisible and intangible text.
	(isearch-open-overlay-temporary): Delete forgoten debug message.
	(isearch-range-invisible): Fix typo in doc-string.

1997-07-18  Stephen Eglen  <stephene@cogs.susx.ac.uk>

	* replace.el (occur): Use text property `occur' to store the
	marker for the occurrence in the source buffer.  This replaces the
	list `occur-pos-list', and fixes the bug for multi-line matches.
	Set up `occur-point' text property for occur-next and occur-prev.
	(occur): occur-num-matches stores the number of matches found.	
	(occur-mode-find-occurrence): Use `occur' text property to find
	marker for locus of the occurrence.
	(occur-next, occur-prev): New commands.
	(occur): Fixed bug preventing line number being displayed if line
	number is less than the number of lines of context.

1997-07-18  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-hooks.el (vc-find-cvs-master): Corrected parsing of
	CVS/Entries, according to CVS docs.
	(vc-toggle-read-only): Also work in vc-dired buffers.

	* vc.el (vc-diff): If file is unchanged, ask for the version
	number to compare with.
	(vc-retrieve-snapshot): If no NAME is specified, check out
	latest versions of all unlocked files.
	(vc-next-action-on-file): For CVS files with implicit checkout: if
	unmodified, don't do anything.
	(vc-clear-headers): Regexp more restricted, so as not to destroy file
	contents by mistake.
	(vc-backend-merge-news): Better analysis of status reported by CVS.
	Set file properties accordingly.

1997-07-17  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper*.el: Adapted to use custom.el
	* ediff*.el: Improved customization.
	* ediff-ptch (ediff-default-backup-extension): New variable.
	(ediff-backup-extension,ediff-backup-specs): Change in initialization.
	
1997-07-17  Geoff Voelker  <voelker@cs.washington.edu>

	* loadup.el [windows-nt, ms-dos]: Load international/mule-utils.

	* dos-w32.el (find-buffer-file-type-coding-system)
	(find-binary-process-coding-system, find-buffer-file-type-match):
	New functions.
	(find-buffer-file-type): Use find-buffer-file-type-match.
	Add find-buffer-file-type-coding-system to file-coding-system-alist
	as the default entry.
	Add find-binary-process-coding-system to process-coding-system-alist
	as the default entry.

1997-07-17  Simon Marshall  <simon@diazepam.gnu.ai.mit.edu>

	* subr.el (functionp): Doc fix.

1997-07-17  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* progmodes/cc-styles.el (c-copy-tree): Function deleted.

	* textmodes/texinfmt.el (texinfo-no-refill-regexp): Add "direntry".
	(texinfo-format-direntry, texinfo-end-direntry): New functions.
	(texinfo-format-dircategory): New function.

	* delsel.el (delete-selection-mode): Add custom-loads property.

	* subr.el (custom-declare-variable-early): New function.
	(custom-declare-variable-list): New variable.
	(read-quoted-char-radix): Use defvar and custom-declare-variable-early.

	* paren.el (show-paren-match-face): Use gray on all non-color screens.

1997-07-17  Barry A. Warsaw  <cc-mode-help@python.org>

	* progmodes/cc-mode.el (c-initialize-cc-mode): New function.
	(c-mode, c++-mode, objc-mode, java-mode): Call it.

	* progmodes/cc-langs.el (c-symbol-key):
	First character must be a letter or underscore.

	* progmodes/cc-langs.el (c-make-inherited-keymap): Change to a defun.

	* progmodes/cc-langs.el: Require 'cc-defs for the definition of
	c-emacs-features.

	* progmodes/cc-langs.el (c-mode-menu): Added uncomment region and
	slight rearrangement of items.

	* progmodes/cc-cmds.el: Require cc-defs for the c-add-syntax macro.

	* progmodes/cc-cmds.el (c-electric-backspace): Must get 'supercede
	property values to work with delsel and pending-del.

	* progmodes/cc-cmds.el (c-electric-brace): Fix ebola eradication
	consequence in the preserve-p test.

	* progmodes/cc-engine.el (c-maybe-labelp): Add defvar.

	* progmodes/cc-styles.el (c-initialize-builtin-style): Use
	copy-sequence instead of c-copy-tree.

	* progmodes/cc-defs.el (c-load-all): Function deleted.
	
1997-07-17  Boris Goldowsky  <boris@gnu.ai.mit.edu>

	* dired-x.el (dired-omit-files): Add ".#foo" lock files to omissions.

1997-07-17  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* international/titdic-cnv.el (batch-titdic-convert): Add optional
	arg FORCE.

1997-07-17  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* subr.el (read-quoted-char): Handle non-character events. 

	* mail/emacsbug.el: Improve text of messages.

	* simple.el (quoted-insert): Doc fix.

	* subr.el (read-quoted-char): Use RET, not SPC, as special terminator.
	Use read-quoted-char-radix as radix for numbers.
	(read-quoted-char-radix): New variable.

1997-07-16  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* dired.el (dired-find-file): Better error message
	for symlink to nonexistent target.

	* simple.el (quoted-insert): Doc fix.

	* subr.el (read-quoted-char): Read any number of octal digits,
	and ignore a space if that terminates the octal digits.

1997-07-15  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* textmodes/texinfmt.el (texinfo-format-buffer-1): Insert, here,
	the info about what file this is and what it was made from,
	just before returning.
	(texinfo-format-setfilename): Generate no output.

	* apropos.el (apropos-print): Use customize-group-other-window,
	not customize-other-window.

	* mail/mail-extr.el (mail-extr-voodoo): Get rid of comments at an
	early stage.

	* files.el (set-auto-mode): If -*- line specifies a mode,
	then even if we don't use it because of just-from-file-name,
	still let it prevent taking the mode from a file name.

	* simple.el (yank, yank-pop): Clear out read-only prop.

	* mail/sendmail.el (mail-mode-auto-fill): Use insert-before-markers.

	* cus-edit.el (custom-unlispify-remove-prefixes): New variable.
	(custom-unlispify-menu-entry): Obey custom-unlispify-remove-prefixes.

	* progmodes/cc-styles.el (c-copy-tree): Fix bugs.

	* international/mule-cmds.el (global-map): Turn off the S-SPC binding.

1997-07-15  Kenichi Handa  <handa@etl.go.jp>

	* international/titdic-cnv.el (tit-process-body): Ignore vacant
	entries.

	* international/quail.el (quail-translate-key): Fix previous change.

	* international/mule.el (make-coding-system): Distinguish
	coding-category-iso-7-else and coding-category-iso-8-else.

	* international/mule-conf.el (coding-category-emacs-mule): Replace
	coding-category-iso-else with coding-category-iso-7-else and
	coding-category-iso-8-else.

	* international/mule-diag.el (describe-current-coding-system): Use
	coding-category-iso-7-else instead of coding-category-iso-else.

	* language/china-util.el (setup-chinese-gb-environment): Adjusted
	for the change of coding category names.  Set default-input-method
	to chinese-py-punct.
	(setup-chinese-big5-environment): Set default-input-method to
	chinese-py-punct-b5.
	(setup-chinese-cns-environment): Set default-input-method
	correctly.
	
	* language/english.el (setup-english-environment):  Adjusted for
	the change of coding category names.

	* language/japan-util.el (setup-japanese-environemnt): Adjusted
	for the change of coding category names.  Set default-input-method
	correctly.

	* language/ethio-util.el (setup-ethiopic-environment): Set
	default-input-method correctly.

	* language/korean.el (setup-korean-environment): Set
	default-input-method correctly.

	* language/tibet-util.el (setup-tibetan-environment: Set
	default-input-method correctly.

	* international/mule-diag.el (list-coding-systems): Fix previous
	change.

	* mail/sendmail.el (mail-setup): Kill the local binding of
	enable-multibyte-characters.  Turn off an input method.

	* mail/emacsbug.el (report-emacs-bug-run-tersely): New variable
	(report-emacs-bug): Insert warnings for novice
	usres in *mail* buffer.  Set enable-multibyte-characters to nil.
	(report-emacs-bug-hook): Check non-English letters.
	Confirm about sending a report to FSF.

	* international/mule-cmds.el (mule-keymap): Bind l to
	set-language-environment.
	(set-language-environment): Remove autoload cookie.  Accept null
	input for resetting to default.
	(select-input-method): Error if enable-multibyte-characters is nil.
	(toggle-input-method): Likewise.
	(global-map): Turn of the S-SPC binding.

1997-07-15  Simon Marshall  <simon@albert.gnu.ai.mit.edu>

	* mouse-sel.el: Customise; create mouse-sel as subgroup of mouse.
	(mouse-sel-mode): New option to toggle mode.
	(mouse-sel-mode): New command to toggle mode.
	(mouse-sel-set-selection-function): If mouse-sel-default-bindings is
	interprogram-cut-paste, default to x-set-selection as before.  Doc fix.
	(mouse-sel-bindings): New function to install/restore mouse bindings.
	This is called by mouse-sel-mode, i.e., not at the top-level.

	* delsel.el: Customise; as part of editing-basics group.
	(delete-selection-mode): Convert to autoloaded option.  Default to nil.
	(delete-selection-mode): Define before option.
	Modify pre-command-hook here, i.e., not at the top-level.
	If enabling Delete Selection mode, also enable Transient Mark mode.

1997-07-14  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* textmodes/texnfo-upd.el (texinfo-all-menus-update)
	(texinfo-master-menu, texinfo-multiple-files-update):
	Search for texinfo-master-menu-header as a string, not a regexp.
	(texinfo-master-menu-header): Move defvar earlier.

	* isearch.el (isearch-char-to-string): Use char-to-string.
	(isearch-quote-char): Add nonascii-insert-offset.

	* files.el (basic-save-buffer-1): Clarify error message.
	(cd-absolute): Likewise.

1997-07-13  Stephen Eglen  <stephene@cogs.susx.ac.uk>

	* iswitchb.el: All user variables now converted to custom.
	(iswitchb): New variable for use by the custom package.
	(iswitchb-default-buffer): Variable deleted.
	(iswitchb-define-mode-map): Addition of keybindings
	for iswitchb-kill-buffer and iswitchb-find-file.
	(iswitchb): When no text typed in, show all buffers.
	(iswitchb-complete): Use equal rather than eq.
	(iswitchb-next-match, iswitchb-prev-match): Use
	iswitchb-chop to handle reordering the buffer list.
	(iswitchb-chop): New function.
	(iswitchb-make-buflist): Rewritten for efficiency.
	(iswitchb-to-end): Operate on a list of buffers, not just one.
	(iswitchb-set-matches): Always return list
	of matching buffers, even in absence of user input.
	(iswitchb-kill-buffer): New function.
	(iswitchb-default-keybindings): Use read-kbd-macro for keys to define.
	(iswitchb-exhibit): Always return list of matching buffers.
	(iswitchb-show-default-buffer): Function deleted.

1997-07-13  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* progmodes/cc-langs.el: Require cc-defs.

	* progmodes/awk-mode.el (awk-mode): Require cc-langs, not cc-mode.

	* progmodes/cc-langs.el (c-make-inherited-keymap): Add autoload cookie.

	* tmm.el (tmm-prompt): Use save-excursion around completing-read code.
	(tmm-add-prompt): Clean up using save-selected-window
	and with-current-buffer.

1997-07-12  Eli Zaretskii  <eliz@is.elta.co.il>

	* term/pc-win.el (msdos-bg-mode): New function.
	(msdos-face-setup, make-msdos-frame): Set background-mode and
	display-type properties for created frames.

1997-07-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* simple.el (forward-visible-line): Correctly handle arg 0
	so that it doesn't mess up handling of nonzero args.

1997-07-10  Rob Riepel  <riepel@Stanford.EDU>

	* emulations/tpu-edt.el (tpu-set-mode-line) Added
	mode-line-mule-info and mode-line-frame-identification.

1997-07-10  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* emacs-lisp/edebug.el (condition-case): Fix edebug-form-spec to
	allow a handler with a list of condition names.

1997-07-11  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cus-start.el: Make it clear that the warning is a warning.

1997-07-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* progmodes/cc-styles.el (c-copy-tree): New function.
	(c-initialize-builtin-style): Use c-copy-tree.

	* cc-align.el, cc-cmds.el, cc-compat.el, cc-defs.el, cc-engine.el:
	* cc-langs.el, cc-menus.el, cc-mode.el, cc-styles.el, cc-vars.el:
	New version of CC mode installed.
	Old files completely replaced.

1997-07-10  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* international/fontset.el (create-fontset-from-fontset-spec):
	Typo in doc-string fixed.

1997-07-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* hilit19.el (hilit-submit-feedback): Change mail address.

1997-07-10  Kenichi Handa  <handa@etl.go.jp>

	* international/fontset.el (create-fontset-from-fontset-spec): Add
	optional arg NOERROR.
	(create-fontset-from-x-resource): Give t as arg NOERROR to
	create-fontset-from-fontset-spec.

	* term/x-win.el: Give t as arg NOERROR to
	create-fontset-from-fontset-spec.

	* bindings.el (mode-line-mule-info): Remove tailing ">" from input
	method indicator.

	* international/isearch-x.el (isearch-input-method): New variable.
	(isearch-input-method-title): New variable.
	(isearch-toggle-specified-input-method): Set the above variables.
	(isearch-toggle-input-method): Likewise.
	(isearch-process-search-multibyte-characters): Give
	iseach-input-method as arg to read-multilingual-string.

	* international/mule-cmds.el (read-multilingual-string): Adjusted
	for the previous change of variables related to input methods.

	* isearch.el (isearch-message-prefix): Likewise.

1997-07-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* mail/sendmail.el (mail-mode): Make fill-paragraph-function local.

	* menu-bar.el (menu-bar-custom-menu): Add several more menu items.
	Rename some.  Delete "Update this menu". 

	* cus-edit.el (customize-browse): Don't take an argument.

1997-07-09  Noah Friedman  <friedman@prep.ai.mit.edu>

	* emacs-lisp/eldoc.el: Add `up-list' and `down-list' to
	eldoc-message-commands.

1997-07-09  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-diag.el (print-fontset): Output format improved.
	(describe-fontset): Likewise.  Doc-string modified.
	(list-fontsets): Likewise.  

	* international/encoded-kb.el (encoded-kbd-mode): Call
	coding-system-XXX instead of coding-vector-XXX.

1997-07-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Makefile (dontcompilefiles): Add cyril-util.el.

	* format.el (format-alist): Don't handle compression here.

1997-07-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cus-edit.el (customize-browse): Improve start-of-buffer message.

	* mouse.el (mouse-undouble-last-event): Fix gross bugs:
	use modifiers, not old-modifiers.

	* cus-edit.el (custom-help-menu): Variable deleted.
	(custom-menu-reset): Function deleted.
	(Custom-menu-update): Likewise.

	* finder.el (finder-list-matches): Create *Finder Category* buffer.

	* mouse.el (mouse-show-mark): Handle switch-frame events in the loop.

1997-07-08  Dave Love  <d.love@dl.ac.uk>

	* thingatpt.el (url): Define end-op property again.  Wrap end-op
	and beginning-op lambdas with `function', not quote.

1997-07-07  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs-lisp/bytecomp.el (char-after): Allow 0 args.

	* progmodes/cc-*.el: New files, totally reorganized.
	
	* dunnet.el: Undo an earlier change:
	(dun-piss): Renamed from dunnet-urinate.
	(dun-verblist): Indecent word added back.
	(dunnet): Delete "censored" message.

	* textmodes/fill.el: Doc fixes.

	* international/mule-conf.el (undecided): Use `-' in mode line.

	* bookmark.el: Make global bindings only via loaddefs.el.

	* help-macro.el (make-help-screen): Clear the prompt
	when we get a real command.

1997-07-07  Kenichi Handa  <handa@etl.go.jp>

	* international/quail.el (quail-conversion-help): Source code
	indentation changed.

	* international/skkdic-utl.el (skkdic-okuri-ari): Doc-string
	modified.
	(skkdic-postfix, skkdic-prefix, skkdic-okuri-nasi): Likewise.
	(skkdic-lookup-key): Add 4th argument PREFER-NOUN.  Arrange order
	of returning list according to this value.

	* international/kkc.el (kkc-region): Call skkdic-lookup-key with
	t for arg PREFER-NOUN while looking up key sequences shorter than
	what a user requested.
	(kkc-next-phrace): Likewise.

	* international/mule-diag.el (print-fontset): Output format tuned.
	(describe-fontset): Likewise.
	(list-fontsets): Likewise.

1997-07-06  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* delsel.el (delete-selection-mode): Doc fix.

	* wid-edit.el (widget-field-use-before-change): Reenable for Emacs 20.

	* files.el (find-file-literally): New function.

1997-07-05  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* menu-bar.el (menu-bar-files-menu): Use make-frame-command
	as in C-x 5 2, rather than make-frame.

	* international/mule-cmds.el (help-map):
	Bind I to describe-input-method.
	(help-map): Bind L to describe-language-environment.

	* international/mule-cmds.el
	(set-language-environment): Do the real work here.
	(current-language-environment): New variable.
	(setup-specified-language-environment): Call set-language-environment.
	Set current-language-environment.
	(describe-language-environment):
	By default, use current-language-environment.

	* help.el (help-for-help): Update help text.

	* faces.el (face-set-after-frame-default): New ubroutine,
	taken from x-create-frame-with-faces.
	(x-create-frame-with-faces): Call it.
	(face-italic-p, face-bold-p): Use equal to compare fonts.
	(frame-update-faces): Function now a no-op.

1997-07-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* simple.el (sendmail-user-agent-compose): New function;
	this has the code that was in sendmail-user-agent.
	(sendmail-user-agent): Use sendmail-user-agent-compose.

	* mail/reporter.el (reporter-compose-outgoing): Use functionp,
	not fboundp, to test validity of COMPOSE.

	* bindings.el (complete-symbol): Accept an argument.
	(debug-ignored-errors): Add ^ to "No tags table loaded".
	Make the etags.el strings correspond to latest etags.el.

	* progmodes/etags.el (next-file, tags-loop-scan): Fix error message.
	(visit-tags-table-buffer, complete-tag): Likewise.

	* language/european.el (latin-1, latin-2. latin-3, latin-4, latin-5):
	Define coding system aliases.

	* wid-edit.el (widget-choose): Using keyboard, if all choices are
	diabled, just report an error.

	* cus-edit.el (custom-load-symbol): Don't reload a preloaded file.

	* term/linux.el: New file.

1997-07-04  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* simple.el (forward-visible-line): Use forward-line, not
	vertical-motion, when moving backwards.

1997-07-04  Anders Lindgren  <andersl@csd.uu.se>

	* compile.el (compilation-error-regexp-alist):
	Support for IAR Systems C compiler added.

1997-07-04  Dave Love  <d.love@dl.ac.uk>

	* browse-url.el: Require thingatpt when compiling.
	(browse-url-url-at-point): Use `thing-at-point' (with URL code
 	moved from here).
	(browse-url-looking-at): Moved to thingatpt.el, renamed and changed.

	* thingatpt.el (thing-at-point): Use `thing-at-point' property, if any.
	(bounds-of-thing-at-point): Use `bounds-of-thing-at-point' property.
	(thing-at-point-bounds-of-url-at-point): New function.
	(thing-at-point-looking-at): New function, adapted from old
 	browse-url-looking-at.
	(thing-at-point-url-at-point): New function, adapted from 
 	browse-url-url-at-point.
	(thing-at-point-url-chars): Variable deleted.
	(thing-at-point-url-path-regexp, thing-at-point-short-url-regexp,
 	thing-at-point-url-regexp, thing-at-point-markedup-url-regexp):
 	New variables.
	(url): `beginning-op' property function changed to use
 	`thing-at-point-bounds-of-url-at-point'.  `end-op' property no
 	longer set -- functionality no longer supported for the more
 	sophisticated treatment of URLs so `forward-thing' no longer works
 	in this case.

1997-07-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cus-edit.el (custom-mode-map): Bind n and p.

	* mail/emacsbug.el (report-emacs-bug): Don't include messages
	in *Messages* generated by report-emacs-bug itself.

	* mail/mailalias.el (mail-complete-alist): Don't use backquote.

1997-07-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* menu-bar.el (menu-bar-custom-menu): Some command names were 
	updated. 

	* widget.el (:sample-overlay): New keyword.
	* wid-edit.el (widget-leave-text): Use it.
	(widget-specify-sample): Use it.
	(widget-default-delete): Ditto.

	* wid-edit.el (color): Make it an editable field.
	(widget-color-value-create): Deleted.
	(widget-color-value-get): Deleted.
	(widget-color-value-set): Deleted.
	(color-item): Deleted.
	(widget-color-item-button-face-get): Renamed to
	`widget-color-sample-face-get'. 
	(color-sample): Delete.
	(editable-color): Delete.
	(widget-editable-color-value-create): Delete.
	* cus-face.el (custom-face-attributes): Use `color' instead of 
	`editable-color'.

	* wid-edit.el (widget-specify-field): Add newline in overlay for
	nil-:sized fields.
	(widget-field-end): Ditto.

	* wid-edit.el (emacs-library-link): New widget.
	(widget-emacs-library-link-action): New function.
	(widgets): Use it.
	(file-link): New widget.
	(widget-file-link-action): New function.

1997-07-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* loadup.el: Some files are in different directories.

	* emacs-lisp/lisp.el, emacs-lisp/lisp-mode.el:
	Moved from parent dir.

	* textmodes/fill.el, textmodes/page.el: Moved from parent dir.
	* textmodes/paragraphs.el, textmodes/text-mode.el: Likewise.
	
	* mail/sendmail.el (mail-do-fcc):
	Pass an arg to verify-visited-file-modtime.

	* textmodes/tex-mode.el (tex-common-initialization):
	Set search-whitespace-regexp locally.

	* simple.el (next-line, previous-line): Doc fixes.

1997-07-03  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* hippie-exp.el (he-dabbrev-skip-space): Fix previous change.
	(he-dabbrev-as-symbol): Likewise.

	* find-dired.el (find-grep-dired): Use -type f.

	* language/japanese.el ("Japanese"): List iso-2022-7bit coding system
	instead of japanese-iso-7bit.

	* delsel.el (delete-selection-mode): Doc fix.

	* gnus/gnus-group.el (gnus-group-set-mode-line):
	Update how mode-line-modified is set.

	* paren.el (show-paren-idle-timer): New defvar.
	(show-paren-mode): Add :initialize attr in the defcustom.
	Test the value at end of file, and turn on the mode if true.
	
	* cus-face.el (custom-face-attributes): Use editable-color widget.

	* wid-edit.el (color-sample, editable-color): New widget types.

	* cus-edit.el (custom-buffer-create-internal): New arg DESCRIPTION
	is inserted in the buffer to describe it.
	(custom-buffer-create-other-window, custom-buffer-create): 
	New arg DESCRIBE; pass it along.
	(customize-group): Pass DESCRIBE argument.
	(custom-face-menu): Improve Set and Save item strings.
	(custom-group-menu): Likewise.

1997-07-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cus-edit.el (custom): Don't set :button-face.
	(custom-mode): Use custom-button-face here
	as buffer-local value of widget-button-face.

	* wid-edit.el (widget-button-face): Default value widget-button-face.
	(widget-default-button-face-get): Use variable widget-button-face.

	* mail/emacsbug.el (report-emacs-bug): Don't assume the exit command
	is mail-send-and-exit for all user agents.

	* autorevert.el: New file.

	* paren.el (show-paren-mode): Add a defvar before first use.

	* desktop.el (desktop-clear-preserve-buffers): New variable.
	(desktop-clear): Kill all buffers except internal ones
	and those listed in desktop-clear-preserve-buffers.

	* time.el (display-time-string-forms): Use %M, not %m.

	* compile.el (compilation-parse-errors): Skip 2 lines
	only for Compilation major mode.

	* international/mule.el (load-with-code-conversion): 
	Don't run kill-buffer-hook or kill-buffer-query-functions.

1997-07-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-edit.el (customize-browse): Use glyphs in description, if
	possible. 

	* wid-edit.el (widget-menu-minibuffer-flag): Default to t on
	XEmacs. 

	* wid-edit.el (widget-field-value-create): Add comment explaining
	why `:field-overlay' contains two markers.

	* cus-edit.el (custom-browse-visibility,
	custom-browse-visibility-action, custom-browse-group-tag,
	custom-browse-group-tag-action, custom-browse-variable-tag-action,
	custom-browse-face-tag, custom-browse-face-tag-action,
	custom-browse-face-tag-action, custom-browse-alist): Changed
	prefix from `custom-tree' to `custom-browse'.
	(custom-variable-value-create, custom-face-value-create,
	custom-group-value-create): Updated caller.

	* cus-edit.el (custom-browse-only-groups): New option.
	(custom-group-value-create): Use it.  Omit non-groups if non-nil.

	* cus-edit.el (custom-help-menu): Renamed "Variable" to "Option".
	Remove "..." from non-prompting entries.

	* wid-edit.el (widget-single-line-field-face): New face.
	(widget-single-line-display-table): New variable.
	(regexp, file): Use `widget-single-line-field-face'.

	* cus-edit.el (custom-unloaded-symbol-p): New function.
	(custom-unloaded-widget-p): New function.
	(custom-group-value-create): Use it.
	(customize-browse): Mention [?].

	* cus-edit.el (custom-toggle-hide): Load dependencies here.

	* wid-edit.el (functionp): New function.

1997-07-02  Kenichi Handa  <handa@etl.go.jp>

	* language/indian.el: Change category 5 to 1.

	* language/european.el (setup-8-bit-environment): New argument
	LANGUAGE. 
	(setup-latin1-environment): Adjusted for the above change.
	(setup-latin2-environment): Likewise.
	(setup-latin3-environment): Likewise.
	(setup-latin4-environment): Likewise.
	(setup-latin5-environment): Likewise.

	* language/greek.el (setup-greek-environment): Likewise.

	* language/hebrew.el (setup-hebrew-environment): Likewise.

	* language/cyril-util.el (setup-cyrillic-environment): Adjusted
	for the change of an input method name.

	* language/devan-util.el (setup-devanagari-environment): Likewise.

	* language/ethio-util.el (setup-ethiopic-environment): Likewise.

	* language/korean.el (setup-korean-environment): Likewise.

	* language/lao-util.el (setup-lao-environment): Likewise.

	* language/thai-util.el (setup-thai-environment): Likewise.

	* language/viet-util.el (setup-vietnamese-environment): Likewise.

	* language/china-util.el: Use true coding system names instead of
	aliases.  Adjusted for the change of an input method name.
	(decode-hz-region): Fix comments. 
	(encode-hz-region): Fix a coding system name.

	* language/misc-lang.el: Call set-language-info-alist for IPA.
	(setup-ipa-environment): New function.

	* international/titdic-cnv.el: Add license note.
	(tit-encode-list): Fix typo (euc-kk -> euc-kr).
	(quail-cxterm-package-title-alist): New variable.
	(tit-make-quail-package-file-name): Name changed from
	tit-make-quail-package-name.
	(tit-process-header): Check quail-cxterm-package-title-alist to
	decide a package name.
	(titdic-convert): Call tit-make-quail-package-file-name.
	(batch-titdic-convert): Likewise.

	* international/skkdic-cnv.el: Coding system name changed to
	iso-2022-7bit-short.
	(skkdic-convert): Fix typo in a comment.
	(skkdic-convert): Save buffer in iso-2022-7bit-short.
	(skkdic-extract-conversion-data): Fix a bug in regular expression
	pattern.

	* international/quail.el (quail-guidance-buf): Make it buffer
	local.
	(quail-guidance-win): New variable.  Make it buffer local.
	(quail-current-translations): Doc-string modified.
	(quail-current-data): Make it buffer local.
	(quail-define-package): Update input-method-alist.
	(quail-defrule): Doc-string modified.
	(quail-defrule-internal): Document it.
	(quail-get-translation): Change the format of DEF part.
	(quail-lookup-key): Make the second argument LEN optional.  Reset
	quail-current-translations to nil.
	(quail-map-definition): New funtion.
	(quail-get-current-str): New function.
	(quail-guidance-translations-starting-column): New variable.
	(quail-update-current-translations): New function.
	(quail-translate-key): Adjusted for the change of DEF format.
	Call quail-update-current-translations
	(quail-next-translation): Call quail-update-current-translations.
	(quail-prev-translation): Likewise.
	(quail-next-translation-block): Likewise.
	(quail-prev-translation-block): Likewise.
	(quail-select-translation): Deleted.
	(quail-make-guidance-frame): New function.
	(quail-show-guidance-buf): Handle the case that minibuffer is in a
	separate frame.
	(quail-hide-guidance-buf): Likewise.
	(quail-show-translations): Call
	quail-update-current-translations.  Check width of a frame to be
	used.
	(quail-completion): Do not supply LEN argument to
	quail-lookup-key.
	(quail-help): Use with-output-to-temp-buffer.
	(quail-translation-help): Likewise.
	(quail-conversion-help): Likewise.
	(quail-update-leim-list-file): Save buffer without making a backup
	file.

	* international/mule.el (charset-bytes, charset-dimension,
	charset-chars, charset-width, charset-direction,
	charset-iso-final-char, charset-iso-graphic-plane,
	charset-reverse-charset, cahrset-short-name, charset-long-name,
	charset-description, charset-plit, set-charset-plist): Document
	them.
	(make-char, charset-list): Doc-string modified.
	(find-new-buffer-file-coding-system): Fix bug of handling the
	coding system undecided.

	* international/mule-diag.el (print-list): Use macro when.
	(sort-charset-list): New function.
	(charset-other-info-func): Delete this variable.
	(list-character-sets): Handle a prefix argument.  If it is nil,
	make the output format less cryptic.
	(print-designation): Use macro when.
	(describe-current-coding-system): Likewise.
	(describe-current-coding-system): Delete unnecessary progn.
	(list-coding-systems): Handle prefix a prefix argument instead of
	checking (interactive-p).  Do not print coding categories.
	(list-coding-categories): New function.
	(print-fontset): Name changed from describe-fontset-internal.
	(describe-fontset): Make the output less cryptic.
	(list-fontsets): New function.
	(list-input-methods): Use macro when.
	(insert-section): Change a name of first argument. 
	(mule-diag): Doc-string modified.  Use with-output-to-temp-buffer.
	 Use insert-buffer-substring instead of insert-buffer.
	 (dump-charsets): Make it callable interactively.
	 (dump-codings): Likewise.

	* international/mule-conf.el: Fix typo in doc-string of charset
	indian-1-column.  Adjust for the name change of
	standard-character-unification-table-for-decode and
	standard-character-unification-table-for-encode.

	* international/characters.el: Modify docstring of char category
	1.  Change char category 5 to symbol.  Adjust category definition
	of Tibetan characters and Thai characters for this change.

1997-07-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* international/mule-conf.el (binary): Define as coding system alias.

1997-07-01  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* desktop.el (desktop-clear): Don't kill buffers here.

	* bindings.el (mode-line-mule-info): Use `%Z' instead of `%z:'.

	* language/devanagari.el (in-is13194-devanagari): 
	Define this name rather than devanagari.
	(devanagari): Make this an alias.

	* international/mule-conf.el: Swap args to define-coding-system-alias.
	* language/vietnamese.el, language/thai.el, language/korean.el: 
	* language/japanese.el, language/hebrew.el, language/greek.el: 
	* language/european.el, language/chinese.el, language/cyrillic.el: 
	Likewise.

	* international/mule.el (define-coding-system-alias): Swap the args.

	* mouse.el (mouse-undouble-last-event): Use reverse, not nreverse.

1997-06-30  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* bibtex.el (bibtex-kill-field, bibtex-find-text):
	Killing a field moves to the next line.

	* diary-lib.el (diary-float): Fix errors in previous change.

	* progmodes/cc-mode.el (c-Java-conditional-key): Put this in the
	right place--it was inside of a defun.
	(c-electric-brace): Eliminate junk mistakenly patched here.

	* simple.el (kill-line): Doc fix.

	* dired-aux.el (dired-do-shell-command): New arg FILE-LIST
	so that we don't recompute it after the user provides the input.

1997-06-29  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* simple.el (forward-visible-line): Handle 0 arg correctly.

1997-06-28  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cus-start.el (enable-multibyte-characters): Customize.

1997-06-28  Michelangelo Grigni  <mic@mathcs.emory.edu>

	* ffap.el: XEmacs compatibility hacks cleaned up.
	(ffap-url-fetcher): If `browse-url' is bound, use that.
	(ffap-locate-file): New optional arg dir-ok.
	(ffap-at-mouse): Fix return value.

1997-06-28  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* window.el (shrink-window-if-larger-than-buffer):
	Use compute-motion, instead of inserting newlines.

1997-06-27  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* menu-bar.el (nonincremental-repeat-search-forward)
	(nonincremental-repeat-search-backward)
	(nonincremental-repeat-re-search-forward)
	(nonincremental-repeat-re-search-backward):
	Special error check for no previous search.

	* Makefile (lisptagsfiles): Look at subdirs only if name
	starts with a letter.
	(dontcompilefiles): Don't compile latin-5.el.
	(updates): Reject subdirs whose names start with =.
	(custom-deps, finder-data, autoloads, update-subdirs): Likewise.

	* scroll-bar.el (toggle-scroll-bar): Moved from frame.el.
	Use scroll-bar-mode to determine which side; if it's nil, use left.
	(set-scroll-bar-mode): New subroutine, taken from scroll-bar-mode.
	(scroll-bar-mode): Use the variable set-scroll-bar-mode.
	(scroll-bar-mode): New variable.  Extra defvar to avoid warning.
	(toggle-horizontal-scroll-bar): Moved from frame.el.

	* frame.el (scroll-bar-side): Variable deleted.
	(toggle-scroll-bar, toggle-horizontal-scroll-bar):
	Moved to scroll-bar.el.
	
	* files.el (file-chase-links): When handling .., make newname absolute.
	Simplify several places.
	(file-relative-name): Handle directory names as well as file names.
	Don't get fooled by empty directory names, etc.

	* word-help.el, term-nasty.el: Files deleted.

1997-06-27  Simon Marshall  <simon@gnu.ai.mit.edu>

	* font-lock.el (font-lock-extra-types-widget): Use regexp widget.
	(scheme-font-lock-keywords-1):
	(scheme-font-lock-keywords-2): New variables based on old variable.
	(scheme-font-lock-keywords): Default to the former.
	(tex-font-lock-keywords-1):
	(tex-font-lock-keywords-2): New variables based on old variable.
	(tex-font-lock-keywords): Default to the former.
	(font-lock-eval-keywords): Don't eval KEYWORDS if nil.
	(font-lock-after-change-function):
	(font-lock-fontify-block): Explicitly wrap inhibit-point-motion-hooks.

	* lazy-lock.el (lazy-lock-fontify-after-scroll):
	(lazy-lock-fontify-after-trigger):
	(lazy-lock-fontify-conservatively):
	(lazy-lock-fontify-chunk): Explicitly wrap inhibit-point-motion-hooks.
	
	* emacs-lisp/regexp-opt.el (regexp-opt-charset): Simplify range search.

1997-06-27  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cus-edit.el (custom-magic-alist):
	Update messages for `modified' and `set' states.

	* files.el (set-auto-mode): Undo previous change.

	* mouse.el (mouse-drag-region): For a click (not a drag),
	let the up-event run normally.

	* cus-edit.el (custom-mode-map):
	Bind Custom-move-and-invoke to mouse-1.
	(Custom-move-and-invoke): New command.
	(custom-buffer-create-internal): Update buffer help text.
	
1997-06-26  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cus-edit.el (custom-variable-menu): Clarify menu item names.
	(custom-buffer-create-internal): Clarify button names.

	* wid-edit.el (widget-choice-action): Use widget-edit-functions.
	(widget-toggle-action): Likewise.

	* wid-edit.el (widget-choose): Use only digits, except for C-g.
	Allocate digits to disabled commands too.
	Don't use a keyboard menu; instead, display a buffer
	listing all the alternatives.  Put cursor in echo area.
	
	* term-nasty.el: File deleted from the distribution.

	* doctor.el: Undo previous censorship changes.

	* paths.el (sendmail-program): Look first in /usr/sbin.

1997-06-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-edit.el (customize-browse): Take a group argument.
	(custom-help-menu): Browse `emacs' group.

	* cus-edit.el (custom-add-parent-links): Simplify mapatoms lambda.
	(custom-browse): New group.
	(custom-buffer-groups-last):
	(custom-menu-groups-first): Options deleted.
	(custom-browse-sort-alphabetically):
	(custom-browse-order-groups):
	(custom-buffer-order-groups):
	(custom-menu-order-groups): New options.
	(custom-browse-sort-predicate):
	(custom-buffer-sort-predicate):
	(custom-menu-sort-predicate): Functions deleted.
	(custom-sort-items): New replacement function; simplification and
	extension of previous predicate functions.
	(customize-face):
	(customize-customized):
	(customize-saved):
	(customize-apropos):
	(custom-menu-create):
	(custom-group-value-create): Use it.

	* cus-edit.el (custom-tree-alist): Use "-\ " instead of "-+ ".
	(custom-group-value-create): Ditto.

	* wid-edit.el (widget-button-click): Steal up event if key is not
	bounbd in `widget-global-map'.

	* cus-edit.el (custom-tree-insert-prefix): Renamed from
	`custom-tree-insert'.
	(custom-group-value-create): Use it.

	* wid-edit.el (widget-field-use-before-change): New option.
	(widget-setup): Obey it.

	* cus-edit.el (custom-help-menu): Add entry for
	`customize-browse'. 

	* wid-edit.el (widget-push-button-value-create): Use :tag-glyph.
	(widget-glyph-insert-glyph): Accept nil widget.
	* cus-edit.el (custom-tree-group-tag): Specify :tag-glyph.
	(custom-tree-variable-tag): Ditto.
	(custom-tree-face-tag): Ditto.
	
1997-06-25  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* help-macro.el (make-help-screen): Clear buffer-read-only.

1997-06-24  Dan Nicolaescu  <done@ece.arizona.edu>

	* bindings.el (debug-ignored-errors): Correct the error messages
	that are supposed to match imenu.el.

1997-06-24  Inge Frick  <inge@nada.kth.se>

	* view.el: Changed some documentation.
	(view-exits-all-viewing-windows): Nev variable
 	replaces view-exit-all-windows-at-exit.
	(view-exit-all-windows-at-exit): Variable deleted.
	(view-mode-enter): Doesn't set view-exit-action	if
	argument exit-action is nil.
	(view-mode-exit): Only restored windows are removed
 	from view-return-to-alist.  Follow chains of old-windows.
	Do not call replace-buffer-in-windows.
	Call exit-action also when a window displays buffer.
	(View-exit-and-edit): Now sets read-only by binding
	view-old-buffer-read-only.
	
1997-06-25  Paul Eggert  <eggert@twinsun.com>

	* replace.el: (perform-replace): When matching lookahead, use
 	markers rather than integers, since a replacement may invalidate
 	integers.  This fixes a bug introduced in the previous change to
 	this file.

1997-06-25  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* facemenu.el (facemenu-add-new-face): Fix comma in backquote.

	* mail/rmail.el (rmail-get-new-mail): If conversion fails,
	delete the text that was inserted.

1997-06-24  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* isearch.el (isearch-search-and-update): When a reverse search
	need not actually search, update isearch-case-fold-search anyway.
	(isearch-mode-map): Define latin-iso8859-9 as self-searching.
	
	* thingatpt.el (buffer): Don't use beginning-of-buffer, end-of-buffer.

	* wid-edit.el (widget-menu-minibuffer-flag): New variable.
	(widget-choose): Alternative method to read one character
	from the keyboard.

	* cus-edit.el (custom-documentation-face): New face.
	(custom-mode): Use custom-documentation-face for doc strings.
	(custom-group-link): Fix the help string.
	(custom-magic-show): Doc fix.

	* wid-edit.el (widget-documentation-face): New variable.
	(widget-specify-doc): Use the variable.

	* cus-edit.el (custom-group-value-create): In links style,
	use Go to Group instead of Show.
	(Custom-goto-parent): New command.
	(custom-mode-map): Bind u to Custom-goto-parent.
	Bind SPC and DEL.
	(custom-buffer-create-internal): Improve help for buttons.
	(custom-button-face): New defface.
	(custom widget-type): Use custom-button-face for buttons.
	(custom-group-tag-faces): Initial value is nil.
	(custom-variable-tag-face): Renamed from custom-variable-sample-face.
	Initialize it like custom-group-tag-face.
	(custom-group-tag-faces): Initialize to nil.
	(custom-state-face): New defface.
	(custom-magic-value-create):
	Use custom-state-face for State descriptions.

	* wid-edit.el (widget-default-button-face-get):
	Try to get it from the parent.
	(widget-default-create): Use :tag-face for tags.

	* cus-edit.el (custom-state-buffer-message): Display the message
	only if the item is modified.  Take widget as arg.
	(custom-mode): Use widget-edit-functions.

	* wid-edit.el (widget-edit-functions): Renamed from widget-edit-hook.
	(widget-field-action): Pass the widget as an arg when running hook.

	* cus-edit.el (Custom-set): Renamed from custom-set.
	(Custom-save): Renamed from custom-save.
	(custom-browse-sort-predicate): Defalias deleted.
	(custom-group-value-create): Don't sort, in tree mode.
	(Custom-mode-menu): Renamed from custom-mode-menu.
	(Custom-reset-current): Renamed from custom-reset-current.
	(Custom-reset-saved): Renamed from custom-reset-saved.
	(Custom-reset-standard): Renamed from custom-reset-standard.
	(Custom-menu-update): Renamed from custom-menu-update.
	(customize-set-value): Renamed from custom-set-value.
	(customize-set-variable): Renamed from custom-set-variable.
	(customize-save-customized): Renamed from custom-save-customized.

	* cus-start.el (double-click-time): Use restricted-sexp.
	(load-path): Make [Current dir?] itself the active button.
	
	* wid-edit.el (character): Doc fix.
	(restricted-sexp): New widget type.
	(integer, number): Use restricted-sexp.

	* cus-start.el (track-mouse): Don't customize it.

1997-06-24  Paul Eggert  <eggert@twinsun.com>

	* replace.el (perform-replace): When matching regexps, if the next
 	match is adjacent to this one, record the next match before
 	replacing this one.  This fixes a bug where (replace-regexp
 	"\\ba " "c") replaced "a a a " with "ca c" instead of "ccc".

1997-06-24  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* thingatpt.el (beginning-of-sexp): New function.
	(bounds-of-thing-at-point): Fix typo in computing real-beg.

1997-06-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cus-edit.el (custom-group-visibility): Widget type
	moved from wid-edit.el and renamed from group-visibility.
	(custom-group-visibility-create): Function renamed
	and moved from wid-edit.el.
	(custom-state-buffer-message): New function.
	(custom-mode): Add custom-state-buffer-message to widget-edit-hook.

	* wid-edit.el (widget-edit-hook): New variable.
	(widget-field-action, widget-choice-action): Run that hook
	instead of displaying an echo area message.
	(widget-toggle-action): Likewise.
	(group-visibility, widget-group-visibility-create):
	Moved to cus-edit.el and renamed.

1997-06-23  Dan Nicolaescu  <done@ece.arizona.edu>

	* textmodes/outline.el (outline-discard-overlays):
	Don't use let inside a cycle. 

	* progmodes/hideshow.el (hs-discard-overlays): Use overlays-in to
	get all the overlays in a range.  Don't use let inside a cycle.

1997-06-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* textmodes/nroff-mode.el (nroff-electric-mode): New defvar.

	* emulation/vip.el (vip-mode-map): Add defvar; move earlier.
	(vip-c-string): Variable renamed and defvar added.
	(vip-save-minibuffer-local-map): Likewise.
	(vip-end-with-a-newline-p): Use STRING (the arg) instead of `text'.

	* emacs-lisp/profile.el (profile-million): Variable moved.

	* informat.el (Info-validate-allnodes): Variable renamed, defvar added.
	(Info-validate-thisnode, Info-validate-lossages): Likewise.
	Change all references.

	* dired-aux.el (dired-add-entry): New optional arg RELATIVE.
	(dired-update-file-line): Pass t for RELATIVE.

1997-06-22  Noah Friedman  <friedman@prep.ai.mit.edu>

	* type-break.el: Do not use defsubst anywhere; use defuns.
	Don't require timer; use autoloaded functions.
	(type-break-warning-message-mode): Variable deleted.
	(type-break-query-mode): New variable and function.
	(type-break-mode): Mention in docstring.
	(type-break-run-at-time): New function.
	All callers of run-at-time changed.
	(type-break-cancel-function-timers): New function.
	All callers of cancel-function-timers changed.
	(type-break-check-post-command-hook): New function.
	(type-break-mode, type-break-schedule, type-break-alarm,
	type-break-time-warning-alarm): Call it.
	(type-break-mode-line-countdown-or-break): New function.
	(type-break): Call it.
	(type-break-time-warning-schedule): Put type-break-time-warning
	on type-break-post-command-hook.
	(type-break-check): Call type-break-mode-line-countdown-or-break.
	(type-break-noninteractive-query): New function.
	(type-break-force-mode-line-update): New function.

1997-06-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* language/japan-util.el (read-hiragana-string):
	Call read-multilingual-string correctly.

1997-06-22  Howard Melman  <melman@absolut.osf.org>

	* picture.el (picture-draw-rectangle): New command.
	(picture-mode-map): Add binding for picture-draw-rectangle.
	(picture-mode): Doc fix.
	(picture-rectangle-ctl): New variable.
	(picture-rectangle-ctr): New variable.
	(picture-rectangle-cbr): New variable.
	(picture-rectangle-cbl): New variable.
	(picture-rectangle-v): New variable.
	(picture-rectangle-h): New variable.
	(move-to-column-force): Function deleted;
	calls changed to use move-to-column.
	(picture-insert): New function.
	(picture-self-insert): Use picture-insert.
	(picture-current-line): New function.
	
1997-06-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* decipher.el (decipher-copy-cons):
	Renamed from decipher-get-undo-copy.  Calls changed.

	* emacs-lisp/lmenu.el (popup-menu): Redefine as macro.
	(popup-menu-popup, popup-menu-internal): New function.

	* mail/reporter.el (reporter-version): Change value.

	* vc-hooks.el (vc-menu-map): Add bindings for 
	vc-retrieve-snapshot and vc-create-snapshot.

	* emacs-lisp/lisp-mnt.el (lm-version, lm-last-modified-date): 
	Clean up strings that looked like RCS headers.

	* ielm.el (ielm-header): Delete version and RCS header.

	* forms.el (forms-version): Deactivate RCS headers.

	* emacs-lisp/edebug.el (edebug-version): Use the Emacs version.

	* compile.el (compilation-error-regexp-alist):
	New item, for Oracle pro*c compiler.

	* startup.el (command-line-1): Don't display startup message
	if the buffer-is nonempty.  Don't make undo entries for it.

	* tex-mode.el (latex-imenu-create-index): Make it much smarter.
	(latex-imenu-indent-string): New variable.

	* bytecomp.el (byte-compile-file): Doc fix.
	(batch-byte-compile-file): Return what byte-compile-file returns.

	* files.el (set-auto-mode): Handle interpreter-mode-alist as regexps.

	* doctor.el (doctor-death): Give serious advice if suicide mentioned.

	* Move many files into new subdirs named play, mail,
	progmodes, textmodes, emulation, emacs-lisp, and international.
	
	* apropos.el, asm-mode.el, autoinsert.el: Add provide call.
	* blackbox.el, cdl.el, copyright.el cplus-md.el, debug.el, disass.el:
	* dissociate.el, doctor.el, dunnet.el, ebuff-menu.el, echistory.el:
	* find-gc.el, ielm.el, informat.el, kermit.el, ledit.el, levents.el:
	* lselect.el, macros.el, mailpost.el, makesum.el, misc.el, modula2.el:
	* mpuz.el, novice.el, nroff-mode.el, options.el, pascal.el:
	* pc-mode.el, profile.el, prolog.el, reposition.el, rlogin.el:
	* rnewspost.el, scribe.el, soundex.el, spell.el, spook.el, studly.el:
	* talk.el, time.el, underline.el, undigest.el, unrmail.el, vi.el:
	* vip.el, vms-pmail.el, vt-control.el, ws-mode.el, x-apollo.el:
	Add provide calls.

	* icon.el: Fix provide call.
	
	* simple.el (current-word): Ignore text properties.

	* edebug.el (edebug-sit-for-seconds): New variable.
	(edebug-display): Use that variable to control amt of time.

1997-06-22  Morten Welinder  <terra@diku.dk>

	* tex-mode.el (latex-imenu-create-index): Make it much smarter.
	(latex-imenu-indent-string): New variable.

1997-06-21  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* uniquify.el (delay-uniquify-rationalize-file-buffer-names): 
	Remove this hook here,
	if we won't call delayed-uniquify-rationalize-file-buffer-names.
	(uniquify-buffer-name-style): Default value is nil.

	* cus-edit.el (custom-buffer-create-internal):
	Insert an explanation of the [Set] [Save]... line.
	Rename Done to Bury Buffer.

	* wid-edit.el (widget-default-value-set): Preserve point here.
	(widget-choice-action, widget-toggle-action): Not here.
	(widget-choice-action, widget-toggle-action):
	Display a message about [State].
	(widget-field-action): Improve message.

	* simple.el (paren-blinking group): Doc fix.

	* cus-edit.el (custom-tree-group-tag): Capitalize the tag.
	(custom-tree-variable-tag, custom-tree-face-tag): Likewise.
	(customize-browse): Corresponding changes.

	* wid-edit.el (widget-file-complete): New function.
	(file): Use widget-file-complete for :completion.  Delete :action.
	(symbol): Use lisp-complete-symbol for :completion.
	(widget-file-action): Function deleted.
	(widget-field-action): Just move to next field.
	(widget-choice-action, widget-toggle-action): 
	Preserve point usefully if it is within the widget.

	* wid-edit.el (group-visibility): Inherit from visibility.

	* cus-edit.el (custom-add-parent-links): New arg INITIAL-STRING.
	(custom-group-value-create): Pass that arg.
	(custom-buffer-create-internal): Clarify initial documentation.

	* cus-edit.el (custom-group-value-create): Use group-visibility widget.
	(custom-add-parent-links): Don't insert anything if no parents.
	Return non-nil iff do have parents.

	* wid-edit.el (group-visibility): New widget type.
	(widget-group-visibility-create): New function.

	* cus-edit.el (custom-magic-value-create):
	In `links' style, don't indent the member groups.
	(custom-group-value-create): Likewise.

	* wid-edit.el (widget-documentation-link-action):
	Use describe-function or describe-variable in simple cases.

1997-06-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-edit.el (custom-buffer-indent): New option.
	(custom-magic-value-create): Use it.
	(custom-group-value-create): Ditto.
	(custom-buffer-create-internal): Don't create parent groups here.
	(custom-group-list): New variable.
	(custom-add-parent-links): New function.
	(custom-variable-value-create): Use it.
	(custom-face-value-create): Use it.
	(custom-group-value-create): Use it.
	(custom-buffer-groups-last): Changed default.

	* wid-edit.el (group-visibility): Deleted.
	(widget-group-visibility-create): Ditto.
	(group-link): Deleted.
	(widget-group-link-create): Ditto.
	(widget-group-link-action): Ditto.

	* cus-edit.el (custom-nest-groups): Delete option.
	(custom-buffer-style): Add `links' style instead.
	(custom-group-link): New widget.
	(custom-group-link-action): New function.
	(custom-group-value-create): Use `custom-group-link'.

	* wid-edit.el (widget-before-change): Fixed comment and debug string. 

	* cus-edit.el (custom-mode-customize-menu): Deleted.
	(custom-mode-menu): Define here.
	(custom-mode): Don't add here.
	(custom-format-handler): Deleted.
	(custom): Don't add here.

	* cus-edit.el (custom-browse-sort-predicate): New alias.
	(custom-group-value-create): Use it.
	(:custom-last): Replace :custom-extra-prefix.
	(customize-browse): Use it.
	(custom-group): Ditto.
	(custom-group-value-create): Ditto.

	* cus-edit.el (face): Fixed format.
	(custom-face-value-create): Browse face, not option.

	* cus-edit.el (custom-group-value-create): Rewrote to replace
	entire format string. 
	(custom-variable-value-create): Ditto.
	(custom-face-value-create): Ditto.
	(custom-group): Delete :format.
	(custom-variable): Ditto.
	(custom-face): Delete :format and :format-handler.
	(custom): Add :format.
	(custom-format-handler): Removed unnecessary code.
	(custom-face-format-handler): Deleted.
	(custom-add-see-also): New function.
	(custom-buffer-style): New option.
	(widget-face-value-create): Use it here instead of :format.
	(:custom-prefix, :custom-extra-prefix): New keywords.
	(custom): Initialize them.
	(custom-redraw-magic): Work with no magic button.
	(customize-browse): New command.
	(custom-tree-visibility): New widget.
	(custom-tree-visibility-action): New function.
	(custom-tree-group-tag): New widget.
	(custom-tree-group-tag-action): New function.
	(custom-tree-group-tag): New widget.
	(custom-tree-group-tag-action): New function.
	(custom-tree-variable-tag): New widget.
	(custom-tree-variable-tag-action): New function.
	(custom-tree-face-tag): New widget.
	(custom-tree-face-tag-action): New function.

	* cus-edit.el (custom-buffer-sort-alphabetically): New option.
	(custom-buffer-groups-last): New option.
	(custom-buffer-sort-predicate): Use them.
	(customize-apropos): Use it.
	(custom-group-value-create): Ditto.
	(custom-menu-sort-alphabetically): New option.
	(custom-menu-groups-first): New option.
	(custom-menu-sort-predicate): Use them.
	(custom-menu-create): Use it.
	(custom-buffer-sort-predicate, custom-buffer-order-predicate,
	custom-menu-sort-predicate, custom-menu-order-predicate): Deleted.

	* wid-edit.el (widget-leave-text): Don't delete nil overlays.

	* wid-edit.el (widget-get-indirect): New function.
	(widget-default-create): Use it.
	(widget-button-insert-indirect): Deleted.

	* wid-edit.el (widget-inactive-face): Use dim gray instead of dark
	gray.

1997-06-21  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cus-edit.el (custom-magic-alist) <hidden>: Don't refer to "dots".
	
	* cus-edit.el (customize-menu-create): Return nil if Emacs.
	(custom-mode): Handle custom-mode-customize-menu being nil.
	(custom-mode-customize-menu): Don't initialize if customize-menu-create
	returns nil.

	* wid-edit.el (boolean): Capitalize "toggle".
	(choice): Capitalize "value menu".
	(visibility): Capitalize "hide" and "show".
	(group-visibility): Likewise.
	(widget-documentation-string-value-create): Capitalize "more".

	* cus-edit.el (custom-nest-groups): New variable.
	(custom-group): Don't insert a space before the group name here.
	(customize-group): If buffer exists, use it unchanged.
	(custom-format-handler) <L>: Maybe make a group-link widget
	instead of a group-visibility widget.
	custom-nest-groups controls this.
	<l, i, e>: Indent differently if custom-nest-groups.
	
1997-06-20   Ryszard Kubiak <rysiek@ipipan.gda.pl>

	* ogonek.el: Doc fixes.
	(ogonek-jak, ogonek-how): Examples of customization fixed. 

1997-06-20  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* wid-edit.el (widget-specify-insert): Bind before-change-functions.
	(widget-insert, widget-setup): Likewise.
	(widget-editable-list-delete-at, widget-default-delete): Likewise.
	(widget-editable-list-insert-before): Likewise.
	(widget-setup): Set up before-change-functions.
	(widget-after-change): Don't apply :notify here.
	(widget-before-change): New function.  Apply :notify here.
	(group-link): New widget type.
	(widget-group-link-action): New function.
	(widget-group-link-create): New function.

	* wid-edit.el (group-visibility): New widget type.

	* cus-edit.el (custom-format-handler) <L>: Use group-visibility.
	<L, i, - cases>: Triple the indentation, use just 2 dashes.

1997-06-21  Kenichi Handa  <handa@etl.go.jp>

	* quail.el (quail-help): Use with-output-to-temp-buffer.
	(quail-translation-help): Likewise.
	(quail-conversion-help): Likewise.

	* fontset.el (x-charset-registries): Name changed for consistency:
	lao.mule -> MuleLao, Mule.Tibetan-X -> MuleTibetan-X.
	(x-complement-fontset-spec): Optimization for latin-iso8859-1.

	* mule-cmds.el: Define mouse-set-font in mule-menu-keymap agian.

1997-06-20  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* tabify.el (untabify): Handle consecutive tabs all at once.
	(tabify-regexp): New var.
	(tabify): Use it.

1997-06-20  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* wid-edit.el (boolean): Display "(nil)" or "(non-nil)".
	Add extra space before the value.
	(widget-documentation-string-value-create): Use [more] to show rest.
	(widget-visibility-value-create): Don't include `...'.

	* cus-edit.el (customize-group): Ignore case in completion.
	(custom-buffer-create-internal): Put parent groups near the top.

1997-06-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* files.el (require-final-newline): Fix custom :type.

1997-06-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* wid-edit.el (widget-leave-text): Don't delete nil overlays.

	* wid-edit.el (widget-inactive-face): Change color.

	* cus-edit.el (custom-reset-saved): Call :custom-reset-saved.
	(custom-reset-standard): Call :custom-reset-standard.

	* cus-edit.el (custom-file): Autoload, and use ~/.xemacs-custom
	for XEmacs.

	* cus-edit.el (custom-buffer-create-internal): Change parent tag.

	* cus-edit.el (custom-buffer-create-internal): Add links to parent
	groups when there is only a single item in the buffer.

	* cus-edit.el (customize-apropos): Extend ALL arg to restrict
	apropos to options, groups and faces.  Doc fix.
	(customize-apropos-options):
	(customize-apropos-faces):
	(customize-apropos-groups): New commands.  Call it.
	(custom-help-menu): Add commands to menu.

	* wid-edit.el (widget-documentation-link-add): Only highlight text
	inside link. 

	* wid-edit.el (widget-specify-field): Place unreadable
 	text-property correctly when `widget-field-add-space' is non-nil.

1997-06-19  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* view.el (view-mode): Add autoload cookie to this variable.
	(View-exit-and-edit): Add autoload cookie.

1997-06-19  Simon Marshall  <simon@gnu.ai.mit.edu>

	* simple.el: Create paren-blinking custom group (as a subgroup of
	paren-matching) and put all blink-matching-paren variables in the
	former (as opposed to the latter) group.

	* paren.el: Customise; paren-showing as a subgroup of paren-matching.
	(show-paren-style): New variable.
	(show-paren-match-face):
	(show-paren-mismatch-face): New faces.
	(show-paren-function): Use them.

	* font-lock.el: Rearrange custom options.
	(global-font-lock-mode): Change defvar to a defcustom, and move after
	global-font-lock-mode defun, so the mode can be enabled via customize.
	(tex-font-lock-keywords): Rewrite.
	
	* fast-lock.el: Rearrange custom options.

	* modula2.el (modula-2-mode): Set font-lock-defaults so that <* and *>
	have comment syntax during fontification.
	(m3-font-lock-keywords-1): Don't fontify <* and *> here.
	(m3-font-lock-keywords-2): Rearrange items and use regexp-opt.

1997-06-18  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* etags.el (esc-map): Delete M-TAB binding of complete-tag.

	* bindings.el (complete-symbol): New function.
	(complete-tag): Definition deleted.
	(esc-map): Bind M-TAB to compete-symbol.

	* info-look.el: Replaces libc.el.
	(info-complete-symbol): If MODE is nil, use the default value.

	* fill.el (fill-context-prefix): Fix previous change.

	* paren.el: Don't enable the mode just because file is loaded.

	* files.el (backup, find-file): Make `files' their parent.
	(ctl-x-map): Delete the C-x C-q binding for toggle-read-only.

	* cus-edit.el (files): New group `files'.
	(auto-save): Make `files' its parent.

	* mpuz.el (mpuz-congratulate): Don't say "1 errors".

1997-06-18  Carsten Dominik  <dominik@strw.LeidenUniv.nl>

	* reftex.el: Changed all doc strings to comply with conventions.
	(reftex-label-alist-builtin) New environment subfigure*.
	(reftex-toc) Introduced key g for revert-buffer.
	(reftex-extract-bib-entries) Allowed round parens as delimiter.
	(reftex-plug-into-AUCTeX) New variable and function.
	(reftex-make-master-buffer) Fixed bug with relative path names.
	
1997-06-18   Ryszard Kubiak <rysiek@ipipan.gda.pl>

	* ogonek.el: Doc Fix.
	(prefix-code): Change the name to `ogonek-prefix-code'. 

1997-06-18  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* mule-util.el (coding-system-parent): Moved to mule.el.

	* mule.el (coding-system-parent): Moved from mule-util.el.

1997-06-18  Kenichi Handa  <handa@etl.go.jp>

	* startup.el (command-line): Load "leim-list.el".

	* subdirs.el: Add "language" in the argument of
	normal-top-level-add-to-load-path.

	* rmail.el (rmail-enable-decoding-message): Deleted.
	(rmail-revert): Bind enable-multibyte-characters to nil before
	calling rmail-convert-file.
	(rmail-convert-to-babyl-format): If enable-multibyte-characters is
	nil, don't convert code.

	* quail.el (quail-current-data): New variable.
	(quail-use-package): Do not reload a package already loaded.
	(quail-define-package): Update TITLE field of input-method-alist.
	(quail-map-p): TRANSLATION may be a cons.
	(quail-define-rules): Add autoload cookie.
	(quail-defrule): Add autoload cookie.  Handle the case that TRANS
	is a cons.
	(quail-get-translation, quail-lookup-key, quail-translate-key,
	quail-show-translations, quail-completion-list-translations,
	quail-show-kbd-layout): Likewise.
	(quail-hide-guidance-buf): Check if window WIN exists before
	deleting it.
	(quail-directory-name): New variable.
	(quail-update-leim-list-file): New function.

	* mule.el (coding-system-type): Doc-string modified.
	(coding-system-category): New function.
	(make-subsidiary-coding-system): Argument BASE deleted.
	(make-coding-system): Put properties no-initial-designation and
	coding-category to a newly created coding system.
	(define-coding-system-alias): Put property 'parent-coding-system
	to a new alias, property 'alias-coding-systems to a parent.

	* mule-util.el (coding-system-parent): New function.
	(coding-system-lessp): New function.
	(coding-system-list): Sort coding systems by coding-system-lessp.
	An element of returned list is always coing system, never be a
	cons.
	(modify-coding-system-alist): Renamed from
	set-coding-system-alist.
	(prefer-coding-system): New function.
	(compose-chars-component): But fix for handling a composite
	character of no compositon rule.

	* mule-diag.el (list-character-sets): Set major mode of *Help*
	buffer to help-mode.
	(describe-coding-system): If user input null for coding system,
	call describe-current-coding-system.
	(describe-current-coding-system-briefly): Doc-string modified.
	(print-coding-system-briefly): Print parent and alises of coding
	system.
	(describe-current-coding-system): Show more information neatly.
	(list-coding-systems): If called interactively, dont' list up
	coding categories.
	(list-input-methods): New function.
	(mule-diag): Call list-input-methods for listing input methods.

	* mule-cmds.el: Define describe-coding-system instead of
	describe-current-coding-system in help-map and mule-menu-keymap.
	In mule-menu-keymap, enable set-buffer-process-coding-system only
	when the current buffer has been associated with some subprocess.
	(set-language-info): Doc-string modified because `input-method' is
	not a valid KEY argument now.
	(leim-list-file-name, leim-list-header, leim-list-entry-regexp):
	New variables.
	(update-leim-list-file, update-all-leim-list-files): New
	functions.
	(current-input-method): Doc-string modified because the value is
	now input method name.
	(defualt-input-method, previous-input-method): Likewise.
	(current-input-method-title): Doc-string modified because now each
	input method doesn't have to set this variable.
	(input-method-alist): New variable.
	(register-input-method): Register input method in
	input-method-alist.
	(read-language-and-input-method-name): Deleted.
	(read-input-method-name): New function.
	(activate-input-method, select-input-method, toggle-input-method):
	Modified for the above change.
	(read-multilingual-string): Likewise.
	(describe-current-input-method): Renamed from
	describe-input-method.
	(describe-input-method): New function.
	(describe-language-environment): Don't put a vacant line at the
	top of *Help* buffer.  Show a title string of each input method.

	* mule-conf.el: Change mnemonic letters for iso-2022-7bit-ss2 and
	iso-2022-7bit-lock.  Set coding-category-iso-8-2 to
	'japanese-iso-8bit.

	* bindings.el (mode-line-mule-info): Change style for showing
	an activated input method.

	* characters.el: Set syntaxes of Ethiopic characters.

	* gnus/gnus-mule.el: Adjusted for the coding system name change.
	Set cyrillic-koi8 for newsgroup "relcom".

	* language/china-util.el, language/cyril-util.el,
	language/devan-util.el, language/ethio-util.el,
	language/japan-util.el, language/lao-util.el,
	language/thai-util.el, language/tibet-util.el,
	language/viet-util.el: Provide XXX-util instead of
	language/XXX-util.  Delete local variable declartion.

	* language/ethio-util.el (ethio-fidel-to-tex-map): Correct several
	elements.

	* language/cyril-util.el (setup-cyrillic-iso-environment,
	setup-cyrillic-koi8-environment,
	setup-cyrillic-alternativnyj-environment): Deleted.
	(setup-cyrillic-environment): New function.

	* language/cyrillic.el: Don't make the keymap
	describe-cyrillic-environment-map and
	setup-cyrillic-environment-map.  Names of coding systems changed.
	Give them more informative doc-string. Make iso-8859-5 alias of
	cyrillic-iso-8bit, alternativnyj alias of
	cyrillic-alternativnyj.  For Cyrillic, provide single langauge
	environment "Cyrillic".

	* language: Delete the code of calling register-input-method form
	all files under this directory.

1997-06-18  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* startup.el: Customize.
	(command-line): Translate iso-8859-9 into latin-5.
	(command-line-1): Recognize setting inhibit-startup-echo-area-message
	with customization buffer.

1997-06-17  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* scheme.el (scheme): Add defgroup.
	Put defcustom's into this group.

	* finder.el (finder-list-keywords): Create *Finder* buffer if nec.

	* fill.el (fill-context-prefix): Fix criteria for first line,
	and for second line; always fetch prefixes from both lines.

	* buff-menu.el (Buffer-menu-mode): Doc fix.
	(Buffer-menu-bury): Move the line to the end.

1997-06-17  Dave Love  <d.love@dl.ac.uk>

	* scheme.el (scheme-mode-commands): Remove keybinding of \t to old
 	`scheme-indent-line'.  Bind \e\C-q to `indent-sexp', not
 	`scheme-indent-sexp'.
	(scheme-mit-dialect): Use defcustom.
	(dsssl-sgml-declaration):  Likewise.  Fix doc string.

1997-06-17  Inge Frick  <inge@nada.kth.se>

	* arc-mode.el (archive-extract): Use second argument of
 	view-buffer instead of setting view-exit-action.

	* tar-mode.el (tar-extract): Use second argument of
 	view-buffer instead of setting view-exit-action.

	* files.el (view-read-only): New option variable.  If
 	non-nil then buffers visiting files read-only, do it in view mode.
	(find-file-read-only, find-file-read-only-other-window)
	(find-file-read-only-other-frame): Call toggle-read-only
	instead of setting buffer-read-only explicitly.
	(toggle-read-only, after-find-file): Changed to be aware
 	of view-read-only.
	(save-some-buffers): Use second argument of view-buffer
	instead of setting view-exit-action.

	* window.el (split-window-save-restore-data): New function that
 	for view mode buffers saves information in view-return-to-alist.
 	(split-window-vertically, split-window-horizontally):
	Call split-window-save-restore-data.
	
1997-06-16  Dan Nicolaescu  <done@ece.arizona.edu>

	* icon.el (icon-indent-line): A comment ends at the end of the
 	line, delete call to inexistent function.

	* icon.el (icon-font-lock-keywords-1): 	Improved regexp.
	(icon-font-lock-keywords-2): Likewise.

1997-06-16  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* buff-menu.el (Buffer-menu-bury): New command.
	(Buffer-menu-mode-map): Put Buffer-menu-bury on `b'.

	* sendmail.el (mail-mode): mail-header-separator affects paragraphs
	only when there is nothing after it on the line.
	(mail-mode-auto-fill, mail-mode-fill-paragraph):
	Look for mail-header-separator only on a line by itself.

	* compile.el (grep-program): Comment out the use of zgrep.

	* help.el (help-map): Make C-i run info-lookup-symbol.

1997-06-16  Simon Marshall  <simon@gnu.ai.mit.edu>

	* icon.el (icon-imenu-generic-expression): Improved regexp.
	(icon-font-lock-keywords-1): Improved regexps.
	(icon-font-lock-keywords-2): Likewise.
	(icon-mode): Don't set font-lock-comment-start-regexp via
	font-lock-defaults; it is not needed anymore.

1996-06-16  Dan Nicolaescu  <done@ece.arizona.edu>

	* icon.el (icon-imenu-generic-expression): Improved regexp.
	(icon-mode): Don't use pushnew.

1997-06-16  Michelangelo Grigni  <mic@mathcs.emory.edu>

	* ffap.el (ffap-soft-value): Make this a function again; the macro
	version does intern-soft too early.  Deleted XEmacs-specific code.

	(ffap-string-at-point-mode-alist): added "=" and
	"&" to the url syntax, as suggested by SJE.
	(ffap-read-file-or-url): fixed the HIST argument to
	completing-read (only visible in XEmacs?), as reported by
	Christoph Wedler <wedler@fmi.uni-passau.de>.
	(ffap-kpathsea-expand-path) New func, replaces ffap-add-subdirs,
	a first attempt at kpathsea emulation.  Also convert "" to "." in
	path lists, for XEmacs. Suggestions from SJE.
	Added mouse-track support (but no binding), as
	suggested by MDB. Moved Emacs mouse bindings from
	"down-mouse" events to ordinary mouse events.
	(ffap-alist): added ffap-fortran-mode, as requested by MDB.
	Rewrote and merged XEmacs support, eliminating file
	ffap-xe.el.  Modified ffap-other-frame to work in dedicated
	frames, fixing a bug reported by JENS.
	(ffap-menu-rescan): avoid modifying the buffer.
	Two bugs reported by Christoph Wedler <wedler@fmi.uni-passau.de>:
	(ffap-fixup-url): avoid autoloading through url-normalize-url.
	(ffap-read-file-or-url): for XEmacs, give extra HACK-HOMEDIR arg
	to `abbreviate-file-name'.
	(ffap-file-at-point): suppress errors from `ffap-alist'.
	(ffap-url-at-point): modified regexp to accept
	mail hostnames ending with a digit.  Fixes bug report of SJE.
	(ffap-url-at-point): use higher level function
	(w3-view-this-url t) suggested by wmperry, instead of
	w3-zone-at/w3-zone-data or widget-at/widget-get.
	(ffap-url-at-point): modified to work with
	w3-version "WWW 2.3.64 1996/06/02 06:20:23" alpha, which
	uses the 'widget package rather than the old w3-zone-at.
	Bug was reported by JENS.
	Adopted comments and doc strings to Emacs coding
	conventions.  Reorganized.  Retired v18 support.
	(ffap-bindings): Offers a default installation.
	(ffap-string-at-point): Modified arguments.
	(ffap-gnus-hook): Updated for Gnus 5.
	(ffap-tex-init): Delayed initialization of `ffap-tex-path'.
	(ffap-dired): New entry in `ffap-alist'.
	(ffap-menu-rescan): May fontify the choices in buffer.
	(ffap-read-file-or-url): `PC-completion-as-file-name-predicate'
	used if available, to work with complete.el.

1997-06-16  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* view.el: Don't globally add to change-major-mode-hook.
	(view-mode-enable): Add to change-major-mode-hook locally here.
	(view-mode-disable): Remove from it locally here.

1997-06-15  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* vc.el (vc-steal-lock): Use yes-or-no-p for confirmation.

	* ogonek.el: New file.

	* texnfo-upd.el: Many doc fixes.
	(texinfo-all-menus-update): Check for @detailmenu.
	(texinfo-master-menu): Likewise.
	(texinfo-multiple-files-update): Likewise.
	(texinfo-insert-master-menu-list): Put in @detailmenu if appropriate.

1997-06-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-face.el (custom-face-attributes): Use booleans.

	* cus-edit.el (custom-variable-menu): Rearranged lisp support.
	(custom-face-menu): Ditto.

	* wid-edit.el (boolean): Add explicit toggle button.
	(choice): Add explicit value menu button.
	* cus-face.el (custom-face-attributes): Use booleans.

	* cus-edit.el (custom-format-handler): Handle %i escape.
	(custom-face): Use it.
	(custom-magic-value-create): Add spaces for groups.
	(custom-format-handler): Add spaces for groups.

	* widget.el (:documentation-indent): New keyword.
	* wid-edit.el (widget-default-format-handler): Obey it.
	(widget-documentation-link-add): Add indentation.
	(widget-documentation-string-value-create): Ditto.

	* cus-edit.el (widget-glyph-insert-glyph): Make the invisible
	extent open ended.

	* cus-edit.el (custom-format-handler): Added :echo-help to
	visibility widget.
	(custom-variable-value-create): Ditto, also for tag.
	* wid-edit.el (widget-documentation-string-value-create): Ditto.
	(widget-documentation-link-help-echo): New function.
	(documentation-link): Use it.  Make untabable.

	* wid-edit.el (widget-apply-action): Don't bind
	`after-change-functions' here.

	* cus-edit.el (custom-toggle-hide): Call `widget-setup'.

	* wid-edit.el (widget-setup): Cleanup.

	* wid-edit.el (widget-tabable-at): New function.
	(widget-move): Use it.
	* wid-edit.el (widget-after-change): Reimplemented :secret.

	* wid-edit.el (widget-field-add-space): New option.
	(widget-specify-field): Use it.
	(widget-field-end): Ditto.

	* wid-edit.el (widget-leave-text): New function.
	(widget-convert-text): Use it.
	(documentation-link): New widget.
	(widget-documentation-link-action): New function.
	(widget-documentation-links): New option.
	(widget-documentation-link-regexp): New option.
	(widget-documentation-link-p): New option.
	(widget-documentation-link-type): New option.
	(widget-documentation-link-add): New function.
	(widget-documentation-string-value-create): Use it.

1997-06-15  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* sendmail.el (mail-mode): Let all-white lines separate paragraphs.

	* text-mode.el (text-mode): Let all-white lines separate paragraphs.

	* generic.el: New file.

1997-06-14  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* icomplete.el: Don't call icomplete-mode; let the user do that.
	(icomplete-show-key-bindings): Doc fix.
	(icomplete-mode): Doc fix.
	(icomplete-get-keys): Make it actually work.
	(icomplete-mode): Doc fix.
	(icomplete-completions): Doc fix.

	* view.el: Many doc fixes.
	(view-mode-enable): New function, split from view-mode-enter.
	(view-mode-enter): Use view-mode-enable.
	(view-mode-disable): New function, split from view-mode-exit.
	(view-mode-exit): Use view-mode-disable.
	(view-mode): Use view-mode-enable and view-mode-disable;
	don't do all of what view-mode-enter and view-mode-exit do.
	(change-major-mode-hook): Use view-mode-disable, not view-mode-exit.

1997-06-14  Inge Frick  <inge@nada.kth.se>

	* view.el: Make view mode more similar to `less'.
	Changed documentation for most commands.
	(view-scroll-auto-exit): New variable, replaces view-mode-auto-exit.
	(view-mode-auto-exit): Variable deleted.
 	(view-mode): Doesn't only toggle `view-mode', it also calls
 	view-mode-enter or view-mode-exit.
	(view-buffer, view-buffer-other-window): New argument exit-action.
	(view-file, view-file-other-window, view-buffer-other-window)
 	(view-buffer, view-mode-enter): Changed method used to restore
 	windows when leaving view mode.
	(view-mode-exit): New function.
	(view-return-to-alist): New variable.	
 	(view-return-here, view-exit-position): Variables deleted.
 	(view-remove-frame-by-deleting, view-exit-all-windows-at-exit):
 	New option variables.
 	(view-page-size, view-half-page-size): New variables.
	(view-scroll-size): Var deleted; replaced by the previous two.
	(view-mode-map): Make the bindings inside defvar.
	Added new commands and new key bindings.
	Added view-mode-exit to `change-major-mode-hook' to always leave
	view mode when changing major mode.
 	(view-file-other-frame,	view-buffer-other-frame): New commands.
 	(View-leave, View-kill-and-leave, View-exit, View-exit-and-edit)
 	(View-quit, View-quit-all): new commands for leaving view mode.
	(view-exit): Function deleted.
	(View-goto-percent, View-scroll-to-buffer-end): New commands.
	(view-try-extend-at-buffer-end): New option variable.
		
	(View-scroll-page-forward, View-scroll-page-backward)
	(View-scroll-page-forward-set-page-size)
	(View-scroll-page-backward-set-page-size, View-scroll-line-forward)
	(View-scroll-line-backward, View-scroll-half-page-forward)
	(View-scroll-half-page-backward)
	(View-revert-buffer-scroll-page-forward): New commands.

	(View-scroll-lines-forward, View-scroll-lines-backward)
	(View-scroll-lines-forward-set-scroll-size)
 	(View-scroll-one-more-line): Commands deleted.
	
	(view-scroll-lines, view-end-message, view-page-size-default)
 	(view-set-half-page-size-default, view-really-at-end)
	(view-recenter): New functions.
 	(view-scroll-size): Function deleted.

	(View-search-regexp-forward, View-search-regexp-backward)
	(View-search-last-regexp-forward, View-search-last-regexp-backward)
	(view-search): ! and @ are special at beginning of regexp.
	(view-search-no-match-lines): New function.

1997-06-14  Per Abrahamsen  <abraham@dina.kvl.dk>

        * wid-edit.el: Add widget `coding-system' for mule.

	* wid-edit.el (widget-convert-text): New function.
	(widget-convert-button): Ditto.

	* wid-edit.el (widget-field-buffer): Don't assume an overlay
	exists. 
	(widget-field-start): Ditto.
	(widget-field-end): Ditto.

	* cus-face.el (custom-face-attributes-get): Protect against
	missing w3 font functions.

	* cus-edit.el (custom-magic-faces): New group.
	Added magic faces.
	
	* cus-edit.el (custom-buffer): New group.
	(custom-menu): New group
	Updated options.
	* wid-edit.el (widget-faces): New group.
	Updated all faces.

	* wid-edit.el (widget-map-buttons): New function.

	* cus-edit.el (custom-buffer-sort-predicate):
	(custom-menu-sort-predicate): Default to ignore.  Rewrite :type form.
	(custom-buffer-order-predicate):
	(custom-menu-order-predicate): New variables.
	(custom-buffer-sort-alphabetically):
	(custom-menu-sort-alphabetically): Functions deleted.
	(custom-sort-items-alphabetically): New function.  Like deleted
	functions, except that A and B must be the same custom type.
	(custom-sort-groups-first):
	(custom-sort-groups-last): New functions.  Like deleted functions,
	except that only A and B custom types are compared. 
	(custom-group-value-create):
	(custom-menu-create): Also sort members using custom-*-order-predicate.
	But sort the copy of the stored sequence to prevent changing the stored
	value, and don't store the sorted copy.

	* wid-edit.el (widget-specify-inactive): Don't set `mouse-face'.
	(widget-setup): Don't use markers.

	* wid-edit.el (widget-default-format-handler): Cleanup.
	(widget-documentation-string-value-create): Also use documentation
 	properties on single line documentation strings.

	* wid-browse.el (widget-minor-mode): Fixed mistake in
	widget-minor-mode - it had semantics of non-interactive calling
	reveresed.

1997-06-14  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* language/european.el (Latin-2):
	List Croatian as alternative name for Serbo-Croatian.

1997-06-13  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* add-log.el (add-log-time-format): New variable.
	(add-log-iso8601-time-string): New function.
	(add-change-log-entry): Use add-log-time-format.
	(add-log-iso8601-time-zone): Renamed from iso8601-time-zone.

1997-06-13  Dan Nicolaescu  <done@ece.arizona.edu>

	* isearch.el (isearch-hide-immediately): New variable.
	(isearch-close-unecessary-overlays): New function.
	(isearch-range-invisible): Use them.

	* isearch.el (search-invisible): Changed the semantics,
	the default value and updated the doc string. 
	(isearch-opened-overlays): New variable.
	(isearch-mode): Initialize it.
	(isearch-switch-frame-handler): Call isearch-clean-overlays.
	(isearch-exit, isearch-cancel, isearch-abort): Likewise. 
	(isearch-other-meta-char, isearch-search):
	Support the new meaning for search-invisible.
	(isearch-open-necessary-overlays, isearch-open-overlay-temporary)
	(isearch-clean-overlays): New functions.
	(isearch-range-invisible): If we are inside overlays that can be
	opened, open them, add them to isearch-opened-overlays and say
	that the range is visible.

	* hideshow.el (hideshow): Added a :prefix.
	(hs-isearch-open): New variable.
	(hs-flag-region): Use that variable.
	Changed the semantics of the FLAG parameter and updated the docs.
	(hs-isearch-open-invisible): New function to be set as a
	`isearch-pent-invisible' property for hidden overlays, so that
	isearch can use it.
	(hs-hide-block-at-point): Tell if we are hiding a comment or a block. 

1997-06-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* latin-5.el: Latin-5 is ISO-8859-9, not ISO-8859-5.

	* fill.el (fill-context-prefix): Don't crash if RESULT is nil
	when AT-SECOND is t.

	* bytecomp.el (byte-save-current-buffer): Change to code 114 (0162).

	* sendmail.el (mail-mode): Change paragraph-start and
	paragraph-separate not to match leading spaces.

	* vc.el (vc-annotate-mode-variables): Init vc-annotate-mode-menu
	and put it into vc-annotate-mode-map.
	(vc-annotate-add-menu): Don't init vc-annotate-mode-menu,
	just add the bindings to it.  Display progress messages.
	(vc-annotate-mode-menu): New defvar.
	(vc-annotate-ratio): Move defvar, add initial value.
	(vc-annotate-display-default): Display progress messages.
	(vc-annotate-display): Use vc-annotate-color-map.
	
1997-06-11  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* finder.el (finder-mode): Don't switch buffers or change text here.
	(finder-by-keyword): Don't call finder-mode here.
	(finder-list-matches): Call finder-mode here.
	Switch to a buffer called *Finder Category*.
	(finder-list-keywords): Call finder-mode here.
	Switch to the buffer *Finder*.
	If the buffer already exists, don't reinitialize it or move point.

	* bindings.el (esc-map): Delete spurious wrong binding for M-TAB.

	* forms.el (forms-mode, forms--process-format-list)
	(forms--make-parser-elt, forms-search-forward, forms-search-backward): 
	Fix error messages.
	
	* text-mode.el (paragraph-indent-text-mode):
	Renamed from spaced-text-mode.
	(text-mode-map): Bind TAB to indent-relative.
	(indented-text-mode-map): Variable deleted.
	(indented-text-mode): Now an alias for text-mode.

1997-06-11  Johan Vromans  <jvromans@squirrel.nl>

	* forms.el (forms-save-buffer):
	Do not run the `write-file-filter' hooks
	explicitly since they are run via `local-write-file-hooks'.
	(forms-search-forward, forms-search-backward): 
	Wrap the search.  Use `error' to signal failure.

1997-06-11  Stefan Schoef  <schoef@OFFIS.Uni-Oldenburg.DE>

	* bibtex.el (bibtex-delete-whitespace, bibtex-current-line)
	(bibtex-assoc-of-regexp, bibtex-skip-to-valid-entry)
	(bibtex-map-entries):
	Renamed from delete-whitespace, current-line, assoc-of-regexp,
	skip-to-valid-bibtex-entry, and map-bibtex-entries, respectively.

1997-06-11  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fill.el (fill-context-prefix): If we get a prefix from the
	second line of the paragraph, verify the first line has it too.

	* reftex.el (tex-main-file, outline-minor-mode): Add defvars.

1997-06-10  Carsten Dominik  <dominik@strw.LeidenUniv.nl>

	* reftex.el: Updated documentation at several points in the file.
	(reftex-label-alist-builtin): New default environment subfigure.
	(reftex-find-duplicate-labels): Temporary buffer is now 
	"*Duplicate Labels*" instead of "*Help*".
	(reftex-bibtex-selection-callback): Renamed variable found-list.
	(reftex-found-list): Added defvar for this variable.
	(TeX-master): Added defvar for this variable.
	(reftex-reset-mode): Kill temporary buffers associated with RefTeX.
	
1997-06-10  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* mule-cmds.el (view-hello-file): Adjusted for the changes of
	coding system names.

1997-06-10  Terrence Brannon  <brannon@sand.usc.edu>

	* landmark.el (lm-display-statistics): Display stats in mode line.
	(lm-number-of-trials, lm-sum-of-moves): New vars.
	Various doc fixes.

1997-06-10  Michael Staats  <michael@thp.Uni-Duisburg.DE>

	* pc-select.el (pc-select-selection-keys-only): New variable.
	(pc-select-meta-moves-sexps): New variable.
	(exchange-point-and-mark-nomark): New function.
	(forward-sexp-mark, forward-sexp-nomark): New functions.
	(backward-sexp-mark, backward-sexp-nomark): New functions.
	(pc-selection-mode): Doc fix.
	Bind exchange-point-and-mark-nomark, C-escape.
	Honor pc-select-meta-moves-sexps, pc-select-selection-keys-only.
	Unset highlight-nonselected-windows.

1997-06-10  Johan Vromans  <jvromans@squirrel.nl>

	* forms.el: Use `error' where possible to signal errors.
	Remove (beep)s for warnings.
	Change comment about the iif hook to reflect the actual reason.
	Correct error in field numbering.

1997-06-10  Flemming Hoejstrup Hansen  <hovpfl@unidhp.uni-c.dk>

	* forms.el (forms-mode): Make `forms--elements' local before calling
	`forms--process-format-list'.

1997-06-10  Olivier Laurens  <laurens@tcc.bc.ca>

	* forms.el (forms-save-buffer): `forms-write-file-filter' and
	`forms-read-file-filter' were not called correctly.

1997-06-10  Torbjorn Einarsson  <T.Einarsson@clab.ericsson.se>

	* f90.el (f90-looking-at-where-or-forall): Recognize where/forall
	only if it's a block, not a one-line statement.

1997-06-10  Stefan Schoef  <schoef@OFFIS.Uni-Oldenburg.DE>

	* bibtex.el (bibtex-mode-map): Changed the binding of the C-TAB
	key, such that XEmacs will understand it, too.

	* bibtex.el (bibtex-format-entry, bibtex-end-of-entry): Give specific
	error message if not on valid BibTeX entry.

	* bibtex.el (bibtex-field-string-quoted): Small bug fix.  Allow
	backslash followed by newline.

	* bibtex.el (bibtex-reposition-window, bibtex-mark-entry): Two new
	functions, bound to M-C-l and M-C-h, respectively.

	* bibtex.el
	(bibtex-reformat-previous-options, bibtex-reformat-previous-labels):
	New internal variables used by bibtex-reformat.

	* bibtex.el (bibtex-clean-entry-hook): New hook to be called after
	entry has been cleaned.
	(bibtex-clean-entry): Run the hook bibtex-clean-entry-hook.

	* bibtex.el (bibtex-entry-field-alist): Small bug fix.
	(bibtex-autokey-title-terminators): Made -- a terminator instead
	of ---.
	(bibtex-font-lock-keywords): Don't treat ALT prefixed entries as
	comments.
	(bibtex-entry): Fixed parameter list.  This function is not
	intended to be called with required and optional fields as
	optional arguments anymore.

	* bibtex.el (bibtex-generate-autokey): Now split into various
	small functions.
	(bibtex-autokey-names-stretch, bibtex-autokey-additional-names):
	New variables used by bibtex-generate-autokey.
	(bibtex-autokey-get-namefield, bibtex-autokey-get-names)
	(bibtex-autokey-demangle-name, bibtex-autokey-get-namelist)
	(bibtex-autokey-get-yearfield, bibtex-autokey-get-titlestring)
	(bibtex-autokey-get-titles, bibtex-autokey-get-titlelist):
	New helper functions for bibtex-generate-autokey.

	* bibtex.el (bibtex-submit-bug-report): Report all variables.

	* bibtex.el (bibtex-contline-indentation): New user option.
	(bibtex-entry-offset): Renamed from bibtex-entry-indentation.

	* bibtex.el (bibtex-entry-field-alist): Used different order for
 	some fields (as documented in btxdoc.tex).  Changed one of the
 	comment strings.

	* bibtex.el (bibtex-mode-hook, bibtex-add-entry-hook): Add var doc.
	(bibtex-autokey-before-presentation-hook): New variable to be
	called before autokey presentation.
	(bibtex-generate-autokey):
	Call bibtex-autokey-before-presentation-hook.  Doc fix.

	* bibtex.el (bibtex-reference-key): Reincluded parentheses.
	Parentheses should be disallowed only in field constants.

	* bibtex.el (bibtex-autokey-transcriptions): Fixed bug (two
	entries for `\o' while `\oe' entry was missing).

	* bibtex.el (bibtex-entry-indentation): New variable to determine
	the indentation of all entries.
	(bibtex-move-outside-of-entry): Use `skip-chars-forward' instead
	of `re-search-forward'.
	(bibtex-beginning-of-first-entry, bibtex-beginning-of-last-entry):
	Renamed from beginning-of-first-bibtex-entry and
	beginning-of-last-bibtex-entry.  Go to beginning of line, return point.
	(bibtex-do-auto-fill, bibtex-make-field, bibtex-entry)
	(bibtex-String, bibtex-Preamble): Respect `bibtex-entry-indentation'.
	(bibtex-beginning-of-entry, bibtex-end-of-entry): Make it work
	with indented entries.
	(bibtex-count-entries, bibtex-sort-buffer, bibtex-validate,
	bibtex-kill-entry, bibtex-reformat): Use return value from
	bibtex-beginning-of-first-entry.
	(bibtex-clean-entry): Use `bibtex-reference-maybe-empty-head'
	instead of a fixed string.

	* bibtex.el (bibtex-beginning-of-entry, bibtex-end-of-entry): Now
	return point if called from a program.
	(bibtex-enclosing-field, bibtex-format-entry,
	bibtex-generate-autokey, bibtex-parse-keys, bibtex-mode,
	bibtex-ispell-entry, bibtex-narrow-to-entry, bibtex-sort-buffer,
	bibtex-find-entry-location, bibtex-validate, bibtex-clean-entry,
	bibtex-fill-entry): Use new return values of these functions.
	(bibtex-ispell-abstract): Bug fix (inherently by the change to
	bibtex-end-of-entry).

	* bibtex.el (bibtex-field-history): New variable for history
	buffer of field name reading.
	(bibtex-make-field): Use completion.  Object to completion are all
	standard fields defined for the current entry.  Bound to `C-c C-f'.
	(bibtex-mode): Set `comment-start' and `comment-start-skip' to
	"@Comment ", `comment-column' to 0.

	* bibtex.el (bibtex-autokey-transcriptions): New variable.
	(bibtex-autokey-name-change-strings)
	(bibtex-autokey-titleword-change-strings):
	Use bibtex-autokey-transcriptions as default value.

	* bibtex.el (bibtex-find-entry-location): Handle empty buffer.

	* bibtex.el (bibtex-entry-delimiters): New variable to determine
 	if entries shall be delimited by braces or parentheses.
	(bibtex-entry-left-delimiter, bibtex-entry-right-delimiter): New
	helper functions.
	(bibtex-entry, bibtex-String, bibtex-Preamble): Respect
	`bibtex-entry-delimiters'.
	(bibtex-entry-format): Doc fix.
	(bibtex-reference-key, bibtex-field-const): Removed parentheses
 	from allowed characters.
	(bibtex-end-of-entry): Better handling of incorrect preambles.

	* bibtex.el (bibtex-validate): Small change to avoid reparsing of
	errors, if you enter `compile-goto-error' in compilation buffer.

	* bibtex.el (bibtex-progress-message): New function to show
	progress of some long-lasting functions in BibTeX mode by
	indicating percentage of done work.
	(bibtex-progress-lastperc, bibtex-progress-lastmes)
	(bibtex-progress-interval):
	New internal variables for `bibtex-progress-message'.
	(bibtex-parse-keys, bibtex-reformat, bibtex-validate): Use new
	function `bibtex-progress-message'.
	(current-line): New helper function to calculate current
	linenumber.  Something like this should really be defined somewhere
	else in Emacs. 
	(bibtex-validate): Changed to show all errors in buffer in a
	`compilation mode' buffer.  If there are syntax errors, it aborts
	after the syntax check, since higher-level check functions rely on
	the syntactical correctness of buffer.  If called from another lisp
	function (as `bibtex-convert-alien') the return value shows
	whether validating has been successful.  Fixed bug which made
	checking for absent required fields work incorrectly.
	(bibtex-parse-keys-timeout): Set to a value reasonable higher
	(twice as high) than `lazy-lock-stealth-time'.
	(bibtex-member-of-regexp, assoc-of-regexp): Small cosmetic changes.

	* bibtex.el (bibtex-buffer-last-parsed-tick): Renamed from
 	bibtex-buffer-last-parsed-for-keys-tick and made it really
 	buffer-local (bug fix).
	(bibtex-parse-keys): Make it use bibtex-buffer-last-parsed-tick.
	(bibtex-parse-buffers-stealthily): New function which parses all
	BibTeX buffers if emacs has been idle an efficient amount of time.
	(bibtex-parse-idle-timer): New variable which stores whether idle
 	timer for parsing already is installed.
	(bibtex-parse-keys): Make it callable verbosely.  Returns now nil
	if it has been aborted.
	(bibtex-mode): Run the new function bibtex-parse-buffers-stealthily.

	* bibtex.el (bibtex-generate-autokey): Changed the name part
 	generation (bugfix).  This function handles now correctly all three
 	forms of BibTeX names, "First von Last", "von Last, First", "von
 	Last, Jr, First".  In every case the "Last" part is correctly
 	extracted.  If the "Last" part consists of more than one token only
 	the first is used.  Name fields spread over more than one line are
 	no problem anymore.

	* bibtex.el (bibtex-entry-format): Changed default value to
 	exclude 'page-dashes.  Modified documentation.
	(bibtex-autokey-name-change-strings)
 	(bibtex-autokey-titleword-abbrevs)
 	(bibtex-autokey-titleword-change-strings, bibtex-entry)
 	(bibtex-validate): Doc fixes.
	(bibtex-mode-map): Bound `C-c $' to bibtex-ispell-abstract.
	(bibtex-generate-autokey): Changed documentation.  Small
 	modification in calculating title field.
	(bibtex-mode): Included bibtex-ispell-entry into the list of
 	`interesting' functions.
	(bibtex-kill-field): Bug fix (killing of first field in entry
	yielded error).

	* bibtex.el (bibtex-string-file-path): New variable which defines
	the path to search for bibtex-string-files.  It defaults to
	contents of environment variable BIBINPUTS.
	(bibtex-mode): Use this variable.

	* bibtex.el (bibtex-next-field, bibtex-find-text): Will now work
	with string entries as well.

	* bibtex.el (bibtex-mode-map): bibtex-complete-key wasn't bound
	correctly.
	(bibtex-complete): Fixed bug (used string entries defined in
	buffer as object to completion).

	* bibtex.el (Menu): Use easymenu.  More menu items for
	`BibTeX-Edit' menu.  Use nested menus.

	* bibtex.el (bibtex-field-kill-ring-max)
	(bibtex-entry-kill-ring-max): Two new variables substituting
	bibtex-kill-ring-max.
	(bibtex-field-kill-ring, bibtex-entry-kill-ring): Two new
	variables substituting bibtex-kill-ring.
	(bibtex-field-kill-ring-yank-pointer)
	(bibtex-entry-kill-ring-yank-pointer): Two new variables
	substituting bibtex-kill-ring-yank-pointer.
	(bibtex-last-kill-command): New variable keeping the type of the
	last kill command.
	(bibtex-insert-current-kill): Clean distinction between the two
	BibTeX kill rings.
	(bibtex-kill-field): Use new variable bibtex-field-kill-ring.
	(bibtex-kill-entry): Use new variable bibtex-entry-kill-ring.

	* bibtex.el (bibtex-kill-ring, bibtex-kill-ring-yank-pointer): New
 	internal variables like kill-ring and kill-ring-yank-pointer, but
 	bibtex-kill-ring holds fields or complete reference entries
 	instead of raw strings.
	(bibtex-kill-ring-max): New user option similar to kill-ring-max.
	(bibtex-kill-field): Renamed from bibtex-delete-field again.  It
	now supports the new variable bibtex-kill-ring.
	(bibtex-copy-field-as-kill, bibtex-kill-entry)
	(bibtex-copy-entry-as-kill, bibtex-yank, bibtex-yank-pop): New
	interactive functions, which work on the bibtex-kill-ring
	variable.
	(bibtex-insert-current-kill): New helper function to insert
	contents of bibtex-kill-ring in an appropriate way.
	(bibtex-make-field): New optional argument to tell the function if
	it was called by bibtex-yank.  It operates slightly different then.
	(bibtex-find-text): New optional argument to tell the function if
	it was called by bibtex-make-field.  It moves in this case to the
	end of the key if it was called on the reference head line.  If it
	is called interactively on the head line, it works in an
	appropriate manner, too.
	(bibtex-enclosing-field): New optional argument to tell
 	bibtex-enclosing-field not to print an error message if enclosing
 	field isn't found, but to return nil in this case (t is returned
 	otherwise).  This is used by bibtex-find-text such that no error
 	message is given if bibtex-find-text is called interactively in
 	the key line of an entry.

	* bibtex.el (bibtex-autokey-year-use-crossref-entry): New variable
	to determine if crossreferenced entry should be used for autokey
	generation, if year field of current entry is absent.
	(bibtex-generate-autokey): Use this new variable.

	* bibtex.el (bibtex-include-OPTannote): Deleted (is set in
	bibtex-user-optional-fields).
	(bibtex-entry, bibtex-print-help-message): Removed support for
	bibtex-include-OPTannote.

	* bibtex.el (bibtex-entry-format): New constant
	`inherit-booktitle' allowed.

	* bibtex.el (bibtex-mode): Set value for
 	font-lock-mark-block-function.

	* bibtex.el (bibtex-font-lock-keywords): Changed to distinguish
	optional from ordinary fields.
	(bibtex-format-entry, bibtex-print-help-message)
	(bibtex-remove-OPT-or-ALT, bibtex-pop): Used simpler regexps.

	* bibtex.el (bibtex-delete-field): Changed from
	bibtex-delete-optional-or-alternative-field.  Deletes now mandatory
	fields as well.
	(bibtex-mode): Changed documentation.

	* bibtex.el (bibtex-entry-type-history, bibtex-key-history): New
	variables to use own histories in BibTeX buffers.
	(bibtex-entry, bibtex-clean-entry, bibtex-String): Use these new
	variables.

	* bibtex.el (bibtex-entry, bibtex-make-field): A function can now
	be used to generate a fields init string.
	(bibtex-include-OPTkey, bibtex-include-OPTannote)
	(bibtex-entry-field-alist): Changed documentation accordingly.

	* bibtex.el (bibtex-mode): bibtex-parse-keys on start of mode is
 	now abortable, too.
	(bibtex-entry, bibtex-complete-key, bibtex-String): If bibtex-keys
 	isn't set correctly due to abortion of bibtex-parse-keys, this
 	function is called now non-abortable.

	* bibtex.el (bibtex-entry-field-alist): Small change in comments.

	* bibtex.el (bibtex-find-entry-location): Bug fix: Insertion into
	completely empty buffer didn't work.

	* bibtex.el (bibtex-user-optional-fields): Renamed from
	bibtex-mode-user-optional-fields.
	(bibtex-submit-bug-report, bibtex-entry, bibtex-print-help-message):
	Use bibtex-user-optional-fields.

	* bibtex.el (bibtex-remove-delimiters): Bug fix: Only remove
	delimiting braces and not those inside fields.

	* bibtex.el (skip-to-valid-bibtex-entry, bibtex-parse-keys)
	(bibtex-end-of-entry, bibtex-validate, bibtex-reformat): Calculate
	complex regexps outside of loops.
	(bibtex-mode): Changed documentation on how to convert third party
	buffers.

	* bibtex.el (bibtex-convert-alien): New function to convert a
	buffer not created by BibTeX mode to a format, whichs enables all
	features of BibTeX mode.
	(bibtex-mode): Small bug fix for call to bibtex-parse-keys.

	* bibtex.el (bibtex-mode): Bug fix for using bibtex-parse-keys.

	* bibtex.el (bibtex-mode): Used other policy to initiate the first
	call of bibtex-parse-keys.  This avoids unnecessary double call if
	Font Lock mode is chosen for buffer at startup.

	* bibtex.el (bibtex-String, bibtex-Preamble): Renamed from
	bibtex-string and bibtex-preamble.
	(bibtex-String): If bibtex-maintain-sorted-entries and
	bibtex-sort-ignore-string-entries are both non-nil, read string
	key from minibuffer (with completion) and insert entry at correct
	location (as for normal entries).

	* bibtex.el (bibtex-autokey-titleword-first-ignore)
	(bibtex-autokey-titleword-abbrevs): Changed documentation: case of
	regexps doesn't matter anymore.
	(bibtex-field-const, bibtex-reference-key): Simplified to not
	contain uppercase letters.
	(member-of-regexp, assoc-of-regexp): Ignore case of regexp.
	(map-bibtex-entries): Call function not for every syntactical correct
	entry, but only for entries with known type.
	(map-bibtex-entries, skip-to-valid-bibtex-entry)
	(bibtex-flash-head, bibtex-enclosing-field)
	(bibtex-enclosing-reference-maybe-empty-head, bibtex-format-entry)
	(bibtex-autokey-change, bibtex-generate-autokey, bibtex-parse-keys)
	(bibtex-ispell-abstract, bibtex-sort-buffer)
	(bibtex-find-entry-location, bibtex-validate, bibtex-remove-delimiters)
	(bibtex-delete-optional-or-alternative-field, bibtex-pop)
	(bibtex-clean-entry, bibtex-print-help-message): Make them work
	regardless of user's value of case-fold-search.
	(bibtex-generate-autokey): Use bibtex-cfield for generating the
	year field regexp.
	(bibtex-parse-keys): Only gather keys of known (and not of
	syntactical correct) entries.
	(bibtex-end-of-entry): Only report an "unknown entry" message if
	called interactively.

	* bibtex.el (bibtex-sort-ignore-string-entries): Renamed back from
	bibtex-sort-ignore-string-and-preamble.  Of course, preambles are
	always ignored, since they have no key at all.
	(bibtex-string): Slightly less complex regexp.
	(skip-to-valid-bibtex-entry): New helper function to skip forward
	(or backward) to beginning of next syntactical correct known
	BibTeX entry, if not already there.  Respects
	bibtex-sort-ignore-string-entries.
	(map-bibtex-entries): Bug fix: It wasn't called for string entries
	even if bibtex-sort-ignore-string-entries was nil.
	(beginning-of-last-bibtex-entry): New helper function to go to
	last entry in buffer.
	(bibtex-end-of-entry): Bug fix: Now works with string and preamble
	entries as well.
	(bibtex-sort-buffer): Renamed from bibtex-sort-entries.  Simplified
	by using new function skip-to-valid-bibtex-entry.  Now only known
	entries are checked.
	(bibtex-find-entry-location): Simplified by using new functions
	skip-to-valid-bibtex-entry and beginning-of-last-bibtex-entry.
	Only known entries are used to determine location.
	(bibtex-validate): Now checks string entries, too.
	(bibtex-move-outside-of-entry): Don't use forward-paragraph, but
	bibtex-end-of-entry.

	* bibtex.el (bibtex-end-of-entry): Don't use forward-sexp anymore,
	since this fails on entries with non-escaped souble-quotes.  Use
	search-bibtex-reference instead (though it is slower, it is more
	reliable).
	(bibtex-ispell-abstract): Use normal regexps created by
	bibtex-cfield instead of special ones.

	* bibtex.el (beginning-of-first-bibtex-entry): No warning on
	empty buffer.

	* bibtex.el (bibtex-validate): Bug fix.  Syntactical check didn't
	work, since due to a bug all entries were simply skipped.

	* bibtex.el (bibtex-mode): Doc fix.
	(bibtex-delete-optional-or-alternative-field): Renamed from
	bibtex-kill-optional-or-alternative-field.
	(bibtex-delete-optional-or-alternative-field, bibtex-empty-field):
	Use delete-region, not kill-region.
	(bibtex-clean-entry): New second argument called-by-reformat
	indicates if bibtex-clean-entry was called by reformat.  Don't try
	to find correct buffer position for newly generated key and don't
	call bibtex-parse-keys in this case.

	* bibtex.el (map-bibtex-entries): Bugfix (missed first entry in
	buffer, died on entries with `@' in other than first column).
	(beginning-of-first-bibtex-entry, bibtex-format-entry)
	(bibtex-beginning-of-entry, bibtex-validate, bibtex-clean-entry):
	Changed to allow BibTeX entries to start in a column different
	from 1 (but still for speed reasons only whitespace is allowed
	prior to the `@' on the same line.

	* bibtex.el (map-bibtex-entries): Call it for known BibTeX entries
	only.  This allows entries as @Comment{...} which follow no
	specific structure without breaking the validation functions.
	(bibtex-validate): Check syntactical structure for known entries
	only.

	* bibtex.el (bibtex-autokey-abbrev): Sped up and changed to allow
	a length of zero.

	* bibtex.el (bibtex-entry-format): Remove option `month-strings'.
	(bibtex-validate): If given a prefix argument, check for
	questionable month fields.

	* bibtex.el (bibtex-generate-autokey): Use normal regexps created
	by bibtex-cfield instead of special ones.
	(bibtex-hide-entry-bodies): Sped up by using subst-char-in-region
	instead of using replace-regexp or replace-match.
	(bibtex-find-entry-location): A bug had been introduced by using
	search-bibtex-reference instead of re-search-forward (fixed).

	* bibtex.el (bibtex-field-delimiters): Renamed from
	bibtex-field-delimiter.
	(bibtex-entry-format): Constant empty-opts renamed to
	empty-opts-or-alts.
	(bibtex-remove-delimiters): Renamed from
	bibtex-remove-double-quotes-or-braces.
	(bibtex-reformat): New function.

	* bibtex.el (bibtex-fill-entry): New function to refill entry.
	(bibtex-mode-map): Defined key for bibtex-fill-entry.

	* bibtex.el (bibtex-field-delimiter): Substitutes variables
	bibtex-field-left-delimiter and bibtex-field-right-delimiter.
	(bibtex-field-left-delimiter, bibtex-field-right-delimiter): New
	helper functions.
	(bibtex-make-field, bibtex-pop): Use new variable
	bibtex-field-delimiter.
	(bibtex-empty-field, bibtex-string): Use new functions
	bibtex-field-left-delimiter and bibtex-field-right-delimiter.
	(bibtex-predefined-month-strings): New variable.
	(bibtex-predefined-strings): Use bibtex-predefined-month-strings.
	(bibtex-submit-bug-report): Use new variables
	bibtex-field-delimiter and bibtex-predefined-month-strings.

	* bibtex.el (bibtex-entry-format): Substitutes variable
	bibtex-clean-entry-zap-empty-opts-or-alts.  Various types of
	formatting options are available (see variable documentation).
	(bibtex-format-entry): New function doing the formatting of entries.
	Taken from bibtex-clean-entry and enhanced to support new variable
	bibtex-entry-format.
	(delete-whitespace): New helper function used by bibtex-format-entry.
	(bibtex-clean-entry): Call new function bibtex-format-entry.
	(bibtex-submit-bug-report): Use bibtex-entry-format instead of
	bibtex-clean-entry-zap-empty-opts-or-alts.
	(bibtex-do-auto-fill): New function to perform auto-filling in
	BibTeX mode.  In fact, this is the old function
	bibtex-auto-fill-function.
	(bibtex-mode): Don't set fill-prefix anymore, but use new function
	bibtex-do-auto-fill.

	* bibtex.el (bibtex-find-entry-location): Fixed bug (when
	bibtex-maintain-sorted-entries was non-nil, an entry with a key
	greater than all other keys wasn't inserted in the correct place).

	* bibtex.el (bibtex-mode): Don't use bibtex-auto-fill-function
	anymore, but use directly variable fill-prefix.

	* bibtex.el (bibtex-find-entry-location): Fixed bug (on duplicate
	keys, point must move to beginning of entry, so that bibtex-entry
	works correctly).

	* bibtex.el (bibtex-complete): Fixed bug (parameter string-list
	was mistakenly altered by the function itself).

	* bibtex.el (bibtex-mode-map): Bind bibtex-complete-key to C-TAB.

	* bibtex.el (bibtex-validate): Renamed from bibtex-validate-buffer
	since it can acts on region if active.  Use search-bibtex-reference.
	(search-bibtex-reference): New function to be used in places where
	prior a re-search-{forward|backward} for bibtex-reference or
	something alike was used.  This function is necessary due to the
	new limit of failure stack size in 19.32 and above.
	(bibtex-enclosing-reference-maybe-empty-head)
	(bibtex-sort-entries, bibtex-find-entry-location, bibtex-validate):
	Use new function search-bibtex-reference.
	(bibtex-pop, bibtex-clean-entry): Small change due to change in
	bibtex-enclosing-reference-maybe-empty-head.
	(bibtex-reference-infix, bibtex-reference-postfix): New constants
	necessary due to splitting bibtex-reference.
	(bibtex-reference): Deleted.
	(bibtex-type-in-reference, skip-whitespace-and-comments): Deleted.

	* bibtex.el (bibtex-mode): Don't turn auto-fill-mode on.  Use new
	variable normal-auto-fill-function.

	* bibtex.el (bibtex-field-string): Simplified.

	* bibtex.el (bibtex-mode-syntax-table): Changed syntax of
	double-quote back to quote syntax.

	* bibtex.el (bibtex-complete): New generic function for interface
	functions bibtex-complete-string and bibtex-complete-key.
	(bibtex-complete-key): New function.

	* bibtex.el (bibtex-sort-ignore-string-and-preamble): Renamed from
	bibtex-sort-ignore-string-entries.
	(map-bibtex-entries): Use bibtex-sort-ignore-string-and-preamble
	and ignore preamble entries as well.
	(bibtex-mode, bibtex-submit-bug-report, bibtex-sort-entries):
	Use bibtex-sort-ignore-string-and-preamble.
	(bibtex-count-entries): New function to count entries in buffer or
	region.

	* bibtex.el (bibtex-comma-after-last-field): New variable to
	decide if comma should be inserted at end of last field.
	(bibtex-entry): Support new variable bibtex-comma-after-last-field.

	* bibtex.el (bibtex-field-indentation, bibtex-text-indentation):
	Two new user options (replacing the former constants
	bibtex-field-alignment and bibtex-text-alignment).
	(bibtex-align-at-equal-sign): New user option.
	(bibtex-auto-fill-function, bibtex-make-field)
	(bibtex-remove-OPT-or-ALT, bibtex-clean-entry): Support new variables.

	* bibtex.el (bibtex-validate-buffer): Now only checks region if
	mark is active.  With optional argument checks if required fields
	are missing, too.

	* bibtex.el (bibtex-mode): Added support for imenu.

	* bibtex.el (bibtex-entry-field-alist)
	(bibtex-mode-user-optional-fields): Modified syntax to allow
	preinitialization of fields.
	(bibtex-make-field, bibtex-make-optional-field):
	Support preinitialization of fields.

	* bibtex.el (bibtex-autokey-prefix-string)
	(bibtex-autokey-preserve-case): New variables to support
	bibtex-generate-autokey.
	(bibtex-generate-autokey): Use new variables.

	* bibtex.el (bibtex-field-const, bibtex-reference-type)
	(bibtex-reference-key): Changed to match the (according to Oren
	Patashnik) allowed characters.

	* bibtex.el (bibtex-clean-entry-zap-empty-opts-or-alts): Renamed
	from bibtex-clean-entry-zap-empty-opts.
	(bibtex-entry-field-alist): Slightly modified syntax to support
	alternative fields needed for Book and InBook references.
	(bibtex-font-lock-keywords, bibtex-print-help-message)
	(bibtex-make-field, bibtex-pop, bibtex-clean-entry):
	Support ALT prefixed entries.
	(bibtex-mode): Documented new ALT prefixed fields.
	(bibtex-make-optional-field): Modified to give only field name as
	arg to bibtex-make-field.
	(bibtex-remove-OPT-or-ALT, bibtex-kill-optional-or-alternative-field):
	Renamed from bibtex-remove-OPT and bibtex-kill-optional-field,
	respectively.  Modified to support ALT prefixes.

	* bibtex.el (bibtex-enclosing-field, bibtex-print-help-message):
	Speed up things by not using bibtex-enclosing-regexp anymore.
	(bibtex-enclosing-regexp): Function deleted.

1997-06-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* loadup.el: Load latin-5.el.

1997-06-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* characters.el: Delete syntax stuff for Latin-1 and Latin-2.

	* mail-utils.el (mail-parse-comma-list):
	Use buffer-substring-no-properties.

	* debug.el (debug): Set overriding-terminal-local-map to nil,
	don't bind it, so it won't be restored on `q'.

1997-06-09 Thomas Wurgler <twurgler@goodyear.com>

        * emacs-lock.el: Added the string "emacs-lock" to all function
	and variable names, to make them unique to emacs-lock.

        * emacs-lock.el (check-was-buffer-locked): New function,
        on shell-mode-hook and telnet-mode-hook.
        (save-buffer-lock-setting): New permanent local variable.

        * emacs-lock.el (check-buffer-lock): New function, on kill-buffer-hook.
        (set-shell-sentinel): New function, on shell-mode-hook
	and telnet-mode-hook.
        
1997-06-09  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* simple.el (do-auto-fill): Typo in the previous change fixed.

1997-06-09  Kenichi Handa  <handa@etl.go.jp>

	* mule.el: Delete declaration for buffer-file-coding-system.  It
	is done in buffer.c now.  In the comment, change coding-system to
	coding system.  The name coding-vector is changed to coding-spec.
	(coding-vector-type, coding-vector-mnemonic,
	coding-vector-docstring, coding-vector-flags): Deleted.
	(coding-system-spec-ref): New function.
	(coding-system-type, coding-system-mnemonic, coding-system-flags):
	Use coding-system-spec-ref.
	(coding-system-doc-string): Renamed from coding-system-docstring.
	(coding-system-eol-type): Renamed from coding-system-eoltype.
	(coding-system-eol-type-mnemonic): Moved to mule-util.el.
	(coding-system-post-read-conversion): Likewise.
	(coding-system-pre-write-conversion): Likewise.
	(default-process-coding-system): Deleted.  Now declared in
	buffer.c.
	(make-subsidiary-coding-system): New function.
	(make-coding-system): Check arguments more strictly.  Do not make
	-unix, -dos, -mac variants for TYPE 4.
	(define-coding-system-alias): Call make-subsidiary-coding-system.
	(set-buffer-file-coding-system): Adjusted for the function name
	changes.
	(find-new-buffer-file-coding-system): Likewise.
	(default-process-coding-system): Deleted.  Now defined in coding.c.
	
	* mule-conf.el: Coding system names changed.

	* language: Most of files under this directory are modified
	because of changes of coding system names.

	* characters.el: Comment changed (iso-2022-7 -> iso-2022-7bit).

	* kkc.el (kkc-save-init-file): Coding system name changed from
	iso-2022-7 to iso-2022-7bit.

	* skkdic-conv.el: Likewise.

	* titdic-conv.el: Likewise.

	* mule-cmds.el: Define mouse-set-font in mule-menu-keymap.
	Disable menu set-buffer-process-coding-system if there's no
	process for the current buffer.
	(command-execute-with-coding-system): New function.
	(universal-coding-system-argument): Make it handle
	universal-arguement correctly.
	(describe-language-support): Call coding-system-doc-string instead
	of coding-system-docstring.

	* mule-diag.el (describe-coding-system): Change format of output.
	(describe-current-coding-system-briefly): Likewise.
	(describe-current-coding-system): Likewise.
	(print-coding-system-briefly): Likewise.
	(print-coding-system): Likewise.
	(list-coding-systems): Likewise.  Make it interactive.

	* mule-util.el (set-coding-system-alist): Deleted.
	(string-to-sequence): Doc string modified.
	(coding-system-list): Add optional arg BASE-ONLY.
	(coding-system-base): New function.
	(coding-system-plist): New function.
	(coding-system-equal): New function.
	(coding-system-unification-table): New function.

	* quail.el (quail-prefix-arg): New variable.
	(quail-start-translation): Make it handle a prefix argument.
	(quail-terminate-translation): Like wise.

	* simple.el (do-auto-fill): Bug fix for kinsoku processing.

1997-06-09  Erik Naggum  <erik@naggum.no>

	* latin-1.el: Normalized character names.
	* latin-2.el: Normalized character names.
	* latin-3.el: Normalized character names.
	* latin-4.el: Normalized character names.
	* latin-5.el: New file.

1997-06-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* webjump.el (webjump-sample-sites): Change the hot list.
	(webjump): Doc change.

	* mailalias.el (mail-directory-parser): Fix previous change.

1997-06-08  Stephen Gildea  <gildea@intouchsys.com>

	* time-stamp.el (time-stamp-string-preprocess, time-stamp-do-number):
	Avoid compiler warnings: pass all arguments to time-stamp-do-number
	explicitly, not dynamically.

1997-06-08  Dan Nicolaescu  <done@ece.arizona.edu>

	* icon.el (icon-font-lock-keywords-2): Use regexp-opt for the regexps. 

1997-06-08  Dave Love  <d.love@dl.ac.uk>

	* browse-url.el: Update keywords to show up in finder.
 	(browse-url-gnudoit-args, browse-url-generic-program)
 	(browse-url-gnudoit-program, browse-url-generic-args): New variables.
	(browse-url-w3-gnudoit): New procedure.
	(browse-url-mmm): New location of `remote' file for MMM 0.4.
	(browse-url-generic): New procedure.

	(browse-url-netscape): Test for w32.

	(browse-url-url-at-point): Assume mailto: if URL contains @.
	Don't use thingatpt; find the URL here to do it correctly.
	
	(browse-url-at-point, browse-url-of-file, browse-url-at-mouse):
	Call browse-url.
	(browse-url): Check for list browse-url-browser-function.
	(browse-url-choose-browser): New procedure.
	(browse-url-browser-function): Allow list value.

	(browse-url-process-environment): Call browse-url-emacs-display.
	(browse-url-emacs-display): New procedure.
	(browse-url-netscape-display): New variable.

	(browse-url-of-region): New procedure.
	(browse-url-of-buffer): Check for narrowed buffer.

	(browse-url-url-at-point): Rewrite to not use cl.el delete-if.
  	Fix multi-line URL matching.

	(browse-url-markedup-regexp): New variable.
	(browse-url-xterm-program): New variable.
	(browse-url-xterm-args): New variable.
	(browse-url-lynx-xterm): Use the above two vars.
	(browse-url-url-at-point): Use buffer-substring-no-properties.
	(browse-url-grail): Add missing optional arg.
	(browse-url-mmm): New procedure.

	(browse-url-netscape-startup-arguments): New variable.

1997-06-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* debug.el (debug, debugger-eval-expression):
	Treat overriding-terminal-local-map like overriding-local-map.
	(debugger-outer-overriding-terminal-local-map): New variable.

1997-06-07 Thomas Wurgler <twurgler@goodyear.com>

        * emacs-lock.el: Check for a lock when deleting a buffer.
        Turn off the lock on a shell or telnet buffer if its process
        is killed.  Reset the lock if the process is restarted.

1997-06-07  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* files.el (file-name-non-special): Handle
	file-name-completion and file-name-all-completions.

	* mailalias.el: Customize.  Doc fixes.
	Mark some risky local variables.

	* dired.el (dired-unmark-all-marks):
	Renamed from dired-unmark-all-files-no-query.

	* language/european.el (setup-8-bit-environment):
	Load the file with load, not require, so that we reload it if nec.

	* language/english.el ("English"): Improve doc string.

	* language/indian.el (describe-indian-environment-map): 
	Renamed from describe-indian-support-map.
	* language/devanagari.el: Corresponding changes.
	
	* language/european.el (describe-european-environment-map): 
	Renamed from describe-european-support-map.

	* language/cyrillic.el (describe-cyrillic-environment-map): 
	Renamed from describe-cyrillic-support-map.

	* language/chinese.el (describe-chinese-environment-map):
	Renamed from describe-chinese-support-map.

	* mule-cmds.el (describe-language-environment):
	Renamed from describe-language-support.
	Do the real work here; don't call describe-specified-language-support.
	Print the mnemonics when mentioning coding systems.
	Improve style of output.
	(describe-specified-language-environment):
	Renamed from describe-specified-language-support.
	Don't do the work here; call describe-language-environment.
	(describe-language-environment-map):
	Renamed from describe-language-support-map.

	* language/european.el (setup-8-bit-environment):
	Do not set set-case-syntax-offset.
	Subtract 128 when setting nonascii-insert-offset.
	Require latin-N if appropriate.

1997-06-06  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* startup.el (command-line): Don't call face-initialize.

	* diff.el (diff-command): Fix previous change.

	* startup.el (command-line): If environment specifies ISO 8859,
	always set up for both singe-byte and multibyte operation.
	But set-language-environment does most of the job now.

1997-06-06  Simon Marshall  <simon@diazepam.gnu.ai.mit.edu>

	* regexp-opt.el (regexp-opt): Doc fix.
	(regexp-opt-group): When extracting character sets, emit them after
	the remaining strings so the regexp will find the longest match.

1997-06-05  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* follow.el (set-process-filter): Advice doc fix.

1997-06-04  Stephen Gildea  <gildea@intouchsys.com>

	* time-stamp.el (time-stamp-format): Doc fix.  Use %:y.
	(time-stamp-string-preprocess): Don't just call format-time-string;
	handle compatibility for some old constructs.  Handle padding
	the historical way, while giving a warning if people actually
	depend on it.
	(time-stamp-conv-warn, time-stamp-conversion-warn)
	(time-stamp-do-number): New functions.
	
1997-06-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* diff.el: Customize.
	(diff-switches, diff-command): Add autoload cookies.

	* vc.el (diff-switches): defvar deleted.

	* format.el (format-insert-file): Fix arg order to format-decode.

1997-06-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* wid-edit.el (widget-kill-line): Fixed for overlays.

	* cus-edit.el (custom-buffer-create-internal): Show full
	documentation string in buffers with only a single item.

	* cus-edit.el (custom-mode-map): Suppress keymap.

	* wid-edit.el (widget-beginning-of-line): Work with overlays.
	(widget-end-of-line): Ditto.
	(widget-specify-inactive): Use inactive for mouse-face as well.
	(widget-read-event): New alias.
	(widget-button-click): Use it.
	Don't execute up events twice.
	(widget-field-end): Workaround for local-map at
	end of overlay.
	(widget-specify-field): Ditto.
	(widget-move): Fixed but with single button buffers.

	* cus-edit.el (custom-buffer-create-internal): Improved help
	strings for reset buttons.

	* wid-edit.el (widget-move): Restored support for
	`widget-echo-help' and `widget-move-hook'.
	(widget-documentation-string-value-create): Restore support for
	`widget-documentation--face'.

	* cus-edit.el (customize-variable-other-window): Added defalias.

	* widget.el (:complete): New keyword.
	(:complete-function): New keyword.
	* wid-edit.el (widget-complete): New command.
	(widget-keymap): Bind it.
	(widget-complete-field): New option.
	(widget-default-complete): New function.
	(default): Bind :complete.
	(string): Bind :complete-function.
	(sexp): Ditto.

	* wid-edit.el (widget-glyph-find): Would infloop when file not found.

	* wid-edit.el (widget-glyph-find): Try to avoid pure text glyphs.
	(widget-glyph-insert): Update doc string.

	* wid-edit.el (widget-button-click): Didn't restore `mouse-face'.

	* widget.el: Removed :hide-front-space and :hide-rear-space. 

1997-06-04 Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* informat.el (Info-tagify): Don't set Info-tag-table-marker
	if not in Info mode.

1997-06-03  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* sendmail.el (mail-setup): Don't set buffer-file-coding-system to nil.
	Instead, kill the local binding of it.

1997-06-03  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* mouse-drag.el (mouse-drag-safe-scroll): Doc fix.
	(mouse-drag-repeatedly-safe-scroll): Doc fix.
	(mouse-drag-events-are-point-events-p): Doc fix.
	(mouse-drag-should-do-col-scrolling): Doc fix.
	(mouse-throw-with-scroll-bar): Doc fix.

	* follow.el (follow-windows-aligned-p): Doc fix.
	(follow-post-command-hook, follow-recenter): Doc fix.
	(follow-end-of-buffer, follow-windows-aligned-p): Doc fix.
	(follow-post-command-hook, follow-maximize-region): Doc fix.
	(set-process-filter, process-filter, move-overlay): Advice doc fix.

1997-06-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* text-mode.el (spaced-text-mode): Renamed from text-mode.
	But change the mode name and hooks.
	(text-mode): Put the guts of indented-text-mode here.
	But don't define text-mode-abbrev-table, just use it.
	Don't set indent-line-function, and use text-mode-map.
	(indented-text-mode): Call text-mode.

	* cus-edit.el (custom-variable-prompt): Change prompt.

	* sendmail.el (mail-setup): Clear out buffer-file-coding-system.

1997-06-02  Martin Lorentzon  <emwson@emw.ericsson.se>

	* vc-hooks.el (vc-annotate): Entry "Annotate" added to menu and
	function `vc-annotate' to key-sequence `C-x v g'.
       
	* vc.el (vc-annotate-*): New functions and variables.

1997-06-02  Michael Kifer  <kifer@cs.sunysb.edu>

	* ediff-util.el (ediff-toggle-multiframe): improved.
	(ediff-setup,ediff-inferior-compare-regions): modified.
	(ediff-setup): bug fixed.
	* ediff-init.el (ediff-file-attributes): use ediff-file-remote-p.
	* ediff-wind.el:
	(ediff-setup-windows-multiframe-merge,
	ediff-setup-windows-multiframe-compare): improved window placement.
	* ediff-diff.el (ediff-make-fine-diffs):
	fixed messages about whitespace regions.
	* ediff-wind.el, ediff-ptch.el, ediff-mult.el, ediff-merg.el:
	custom.el'ed
	
1997-06-02  Michael Kifer  <kifer@cs.sunysb.edu>
	
	* viper-init.el (vip-parse-sexp-ignore-comments): new variable.
	* viper-cmd.el (vip-paren-match): parsing comments is now controled
	with vip-parse-sexp-ignore-comments.
	* viper-cmd.el (vip-goto-col): fixed.
	* viper-cmd.el (vip-autoindent): now expands abbrevs.
	(vip-adjust-keys-for): unbinds vip-autoindent, if vip-auto-indent
	is nil.
	* viper-cmd.el (vip-prefix-arg-value): fixed computation of integer 
	prefix args.
	* viper-cmd.el, viper-init.el: new files.
	
1997-06-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* easy-mmode.el: New file.

	* reftex.el: Many doc fixes.
	(reftex-mode-menu): Change menu items.

	* language/cyrillic.el (koi8-r): Use R for mode line.

	* language/european.el (iso-8859-1): Use `1' for mode line.
	(Latin-1...Latin-4 coding systems): Add lists of languages
	which use these coding systems.

1997-06-01  Rolf Ebert  <ebert@waporo.muc.de>
        
	* ada-mode.el (ada-mode): Set up support for find-file.el.
	(ada-other-file-alist): New variable moved from find-file.el.
	(ada-search-directories): Likewise.

	* find-file.el:
	(ada-other-file-alist): Variable definition moved to ada-mode.el.
	(ada-search-directories, ada-procedure-start-regexp): Likewise.
	(ada-package-start-regexp): Likewise.

	* ada-mode.el: Customize.

1997-06-01  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* smtpmail.el: Include time-stamp.
	(smtpmail-queue-dir, smtpmail-queue-index-file): New variables.
	(smtpmail-queue-mail): New variable.
	(smtpmail-send-it): Handle those variables.
	(smtpmail-send-queued-mail): New command.

	* filecache.el: New file.
	* meta-mode.el: New file.
	* battery.el: New file.
	* easy-mmode.el: New file.
	
	* rmail.el (rmail-mmdf-delim1, rmail-mmdf-delim2):
	Variables renamed from mmdf-delim1 and mmdf-delim2.

1997-06-01  Roderick Schertler  <roderick@ibcinc.com>

	* gud.el (gud-dgux-p, gud-dguxdbx-marker-filter): New functions.
	(dbx): Use them.

1997-06-01  Dan Nicolaescu  <done@ece.arizona.edu>

	* hideshow.el (hs-show-hidden-short-form): Updated doc string.
	(hs-adjust-block-beginning): Likewise.
	(hs-special-modes-alist): C and C++ should also use
	hs-c-like-adjust-block-beginning.
	(hs-find-block-beginning): If hs-adjust-block-beginning is t and
	we apply hs-adjust-block-beginning and we reach the point means
	that we found the block beginning.
	(hs-c-like-adjust-block-beginning): Renamed from
	java-hs-adjust-block-beginning. 

1997-06-01  Simon Leinen  <simon@switch.ch>

	* smtpmail.el (smtpmail-via-smtp): Recognize XVRB as a synonym for
 	VERB and XONE as a synonym for ONEX.

	(smtpmail-read-response): Add "%s" to `message' calls to avoid
 	problems with percent signs in strings.

	* smtpmail.el (smtpmail-read-response): Return all lines of the
 	response text as a list of strings.  Formerly only the first line
 	was returned.  This is insufficient when one wants to parse
 	e.g. an EHLO response.

	Ignore responses starting with "0".  This is necessary to support
 	the VERB SMTP extension.

	(smtpmail-via-smtp): Try EHLO and find out which SMTP service
 	extensions the receiving mailer supports.

	Issue the ONEX and XUSR commands if the corresponding extensions
 	are supported.

	Issue VERB if supported and `smtpmail-debug-info' is non-nil.

	Add SIZE attribute to MAIL FROM: command if SIZE extension is
 	supported.

	Add code that could set the BODY= attribute to MAIL FROM: if the
 	receiving mailer supports 8BITMIME.  This is currently disabled,
 	since doing it right might involve adding MIME headers to, and in
 	some cases reencoding, the message.

1997-06-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* wid-edit.el: Changed to overlays.
	* cus-edit.el (custom-buffer-create-internal): Remove kludge for
	getting read-only bob and eob in XEmacs.
	* wid-browse.el (widget-browse-at): Use `get-char-property'
	instead of `get-text-property'.
	* widget.el (:value-from :value-to): Deleted.
	* widget.el (:button-overlay, :field-overlay): New keywords. 
	* wid-edit.el (widget-default-delete): Delete overlays.
	(widget-field-value-delete): Delete overlay.

	* wid-edit.el (widget-specify-field-update): Specify both
	`ballon-help' and `help-echo'. 

	* wid-edit.el (visibility): Change "more" to "show".

	* cus-edit.el (:custom-category): New keyword.
	(custom-variable): Add it.
	(custom-face): Ditto.
	(custom-group): Ditto.
	(custom-magic-value-create): Replace %c with category in state
	text. 
	(custom-magic-alist): Use it.
	(custom-magic-show-hidden): Allow control on each custom
	category. 
	(custom-magic-value-create): Ditto.
	(custom-reset-current): Ignore extra arguments.
	(custom-reset-saved): Ditto.
	(custom-reset-standard): Ditto.
	(custom-reset-button-menu): New option.
	(custom-buffer-create-internal): Use it.

	* cus-edit.el (customize-variable): Uncomment alias.

1997-06-01  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* sun-curs.el (sc::cursors): Add an eval-and-compile.

1997-06-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-edit.el (custom-format-handler): Changed look of group
	indicators.

	* wid-edit.el (widget-kill-line): Use forward-line instead of
	search-forward.  

	* cus-edit.el (custom-magic-value-create): Cleanup.

	* wid-edit.el (set-text-properties): Redefine for broken XEmacsen.
	(widget-field-value-get): Remove workaround.
	(widget-specify-button): Specify both `ballon-help' and `help-echo'.

1997-06-01  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cus-edit.el (custom-variable-prompt):
	Handle variable-at-point returning 0.
	(customize-option): Renamed from custom-variable.
	(customize-variable): Add it as an alias.
	(customize-option-other-window):
	Renamed from customize-variable-other-window.
	(custom-load-symbol): Search for both short and absolute
	names of the library, when avoiding duplicate loading.

1997-05-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* mail-utils.el (mail-strip-quoted-names): Don't delete angle brackets
	when there's a colon inside them.

	* iso-cvt.el: Require `format'.
	(iso-translate-conventions): Take bounds as args.
	(iso-spanish, iso-german): Take bounds as args.
	(iso-iso2tex, iso-tex2iso, iso-gtex2iso, iso-iso2gtex): Likewise.
	(iso-iso2duden-trans-tab): New variable.
	(iso-iso2duden): New command.
	(iso-cvt-read-only, iso-cvt-write-only): New commands.
	(is-german-tex-p): Function deleted.
	(iso-fix-iso2tex, iso-fix-tex2iso): Functions deleted.
	(iso-cvt-ffh, iso-cvt-wfh, iso-cvt-ash): Functions deleted.
	(iso-cvt-define-menu): New function.
	
	* format.el (format-encode-run-method): New function.
	(format-decode-run-method): New function.
	(format-alist): Add many new formats.
	(format-annotate-function): Use format-encode-run-method.
	(format-encode-region): Likewise.
	(format-decode): Use format-decode-run-method.

	* startup.el (command-line): Detect Latin-N character sets
	from envvars, both for multibyte mode and single-byte mode.

1997-05-31 Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-edit.el (custom-format-handler): Don't show links for hidden
	items. 

	* wid-edit.el (widget-button-prefix): Move to `widget-button' group.
	(widget-button-suffix): Ditto.

	* cus-edit.el (custom-format-handler): New %e and %- escapes.
	(custom-group): Use them.

	* widget.el (:widget-doc): Removed keyword.
	* wid-edit.el (widget-help): Removed widget.
	(widget-help-action): Removed function.

	* widget.el (:documentation-shown): New keyword.
	* wid-edit.el (documentation-string): New widget.
	(widget-documentation-string-value-create): New function.
	(widget-documentation-string-action): New function.
	(widget-default-format-handler): Use them.
	* cus-edit.el (custom-toggle-hide): Hide documentation.

	* cus-edit.el (custom-buffer-sort-predicate): Fix :type.
	(custom-menu-sort-predicate): Ditto.

	* wid-edit.el (visibility): New widget.
	(widget-visibility-value-create): New function.
	(widget-glyph-find): New function.
	(widget-glyph-insert): Use it.
	* cus-edit.el (custom-variable-menu, custom-face-menu,
	custom-group-menu): Remove `Hide' entry.
	(custom-magic-show-hidden): New option.
	(custom-magic-value-create): Use it.
	(custom-face): Show visibility.

	* wid-edit.el (widget-glyph-insert-glyph): Clean up.

1997-05-31  Dan Nicolaescu  <done@ece.arizona.edu>

	* cpp.el (cpp-highlight-buffer): Make sure
	buffer-invisibility-spec contains `cpp'.
	(cpp-make-overlay-hidden): Use `cpp' as an invisible property. 

	* hideshow.el (hs-hide-comments-when-hiding-all)
	(hs-show-hidden-short-form, hs-minor-mode-hook): Move definitions up.
	Use defcustom. 
	(hs-find-block-beginning): Bind buffer-size, don't call it in a cycle. 
	(hs-hide-all): Likewise.

1997-05-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* language/european.el: Rename language environments from
	LatinN to Latin-N.

	* mule-cmds.el (set-language-environment): Add autoload cookie.
	Renamed from setup-language-environment.

	* startup.el (iso-8859-n-locale-regexp): Renamed from
	iso-8859-1-locale-regexp.

	* loadup.el: Always load faces.el.

	* faces.el (make-face): Call make-face-internal only if defined.
	(internal-set-face-1): Call set-face-attribute-internal
	only if it is defined.

1997-05-30  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cus-edit.el (custom-load-symbol): Don't reload a file
	that is already loaded.
	(custom-load-symbol): Simplify previous change.

	* wid-edit.el (widget-sexp-value-to-internal):
	Don't bother with pp for a symbol.

	* wid-edit.el: Don't require cl.
	(widget-default-format-handler): Don't use push.
	(widget-push-button-value-create): 
	(widget-group-value-create): 
	(widget-sublist): New function.
	(widget-item-match-inline): Use widget-subllist.
	(widget-remove-if): New function.
	(widget-choose): Use widget-remove-if.

	* cus-edit.el (cus-start): Require cus-start.
	(mule): Make i18n the parent group.

	* cus-start.el: Arrange to load it once during dumping,
	and again if needed by cus-edit.el.
	(custom-start-quote): Don't define as separate function.
	(load-path): Improve the :type.
	(delete-exited-processes): Fix group to processes-basics.

	* subr.el (substitute-key-definition): Check vectorp, not arrayp.

	* files.el (file-name-non-special): Special handling for
	substitute-in-file-name operation.

	* hippie-exp.el (he-dabbrev-skip-space, he-dabbrev-as-symbol):
	Move definitions up.  Use defcustom.

1997-05-30  Ken Manheimer  <klm@python.org>

	* Integrated Emacs 19.34 and XEmacs 19.15 corrections (typos,
 	  style, command revisions, etc).

	* Integrated immediate keybindings display.  See
	  `icomplete-show-key-bindings', `icomplete-get-keys', and
	  `icomplete-completions'.

	* `icomplete-get-keys': Return keys bound in prior buffer to func name.

	* Added icomplete delay behavior, so completions don't intrude as
 	  quickly for short input, with customization variables:

	  `icomplete-max-delay-chars' - Maximum number of initial chars to
	  apply icomplete compute delay.
	
	  `icomplete-compute-delay' - Completions-computation stall, used
	  only with large-number completions

	  `icomplete-delay-completions-threshold' Pending-completions
	  number over which to apply icomplete-compute-delay

1997-05-29  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* simple.el (line-move): If moving into intangible text,
	try to move to the end of the intangible segment if it's on that line.

	* simple.el (completion-setup-function): Do set completion-base-size.

1997-05-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-start.el: Use `standard-value' instead of `factory-value'. 

	* cus-edit.el (custom-variable-action): Clarified prompt.
	(custom-face-action): Ditto.
	(custom-group-action): Ditto.

	* cus-edit.el (custom-face-set): Call `face-spec-set' instead of
	`custom-face-display-set'. 
	(custom-face-save): Ditto.
	(custom-face-reset-saved): Ditto.
	(custom-face-reset-standard): Ditto.

	* cus-edit.el (custom-buffer-sort-predicate): New option.
	(custom-buffer-sort-alphabetically): New function.
	(custom-group-value-create): Use them.
	(custom-menu-sort-predicate): New option.
	(custom-menu-sort-alphabetically): New function.
	(custom-menu-create): Use them.

	* cus-edit.el (custom-magic-alist): Shortened message.

	* cus-edit.el: (custom-help-menu): Updated names.

	* cus-edit.el: Say `invoke' instead of `activate'.
	* wid-edit.el: Ditto.

	* wid-edit.el (widget-help): Fix format string.

	* cus-edit.el (custom-magic-value-create): Use push button
	brackets around state button.
	(custom-magic-value-create): Indent with three spaces.

	* cus-face.el (face-spec-set-match-display): Change error for
	unknown requirement to warning.

	* wid-edit.el (widget-link-prefix): Change to "[".
	(widget-link-suffix): Change to "]".

	* wid-edit.el (widget-color-item-button-face-get): Don't require
	facemenu for XEmacs.
	(widget-glyph-insert): Would bug out.

	* wid-edit.el (widget-glyph-directory): Fix doc. string.
	(widget-image-conversion): New option.
	(widget-glyph-insert): Use it.
	(widget-glyph-insert-glyph): No tag here.
	(widget-push-button-value-create): But here.

	* wid-edit.el (widget-field-face): Changed to dim gray.

	* wid-edit.el (widget-push-button-prefix): New option.
	(widget-push-button-suffix): New option.
	(widget-button): New group.

	* widget.el (:text-format): Removed.
	(:button-suffix): New keyword.
	(:button-prefix): New keyword.

	* wid-edit.el (widget-button-prefix): New variable.
	(widget-button-suffix): New variable.
	(widget-insert-indirect): New function.
	(widget-default-create): Use it.
	(default): Bind them.
	(widget-link-prefix): New option.
	(widget-link-suffix): New option.
	(link): Use them.
	(push-button): Don't use `:text-format'.
	(widget-push-button-value-create): Ditto.
	(widget-help): Update format.
	(checkbox): Ditto.
	(radio-button): Ditto.

	* cus-edit.el (custom-magic-alist): Use `invoke' instead of
	`push'. 

	* cus-edit.el (custom-magic-alist): Changed rogue state message.

	* custom.el (defface): Doc fix.

	* cus-edit.el (mule): New group for MULE merged emacsen.
	(auto-save): Spelling fix.

	* cus-edit.el, custom.el: Renamed `factory' to `standard'
	everywhere. 

	* cus-edit.el (custom-magic-show-button): Changed default to
	`nil'. 
	(custom): Removed `:format'.
	(custom-variable): Removed level button.
	(custom-face): Ditto.
	(custom-level): Deleted.
	(custom-level-action): Deleted.
	(custom-format-handler): Update caller.
	(custom-group-magic-alist): Merged into `custom-magic-alist'.
	(custom-magic-value-create): Use merged `custom-magic-alist'.
	(custom-group-state-update): Ditto.
	
1997-05-29  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* cus-edit.el (custom-face-display-set): Define if not defined.
	(custom-buffer-create-internal): Refer to the Emacs manual.

1997-05-29  Anders Holst (aho@nada.kth.se)

	* hippie-exp.el (he-file-name-beg): Don't trigger on parts of
	words with non-file chars.
	(he-lisp-symbol-beg): Use symbol syntax classes.
	(he-dabbrev-as-symbol): New variable.
	(he-dabbrev-beg,he-dabbrev-search,he-dabbrev-kill-search): Use it.

1997-05-29  Ken Manheimer  <klm@python.org>

	* icomplete.el: Integrated Emacs 19.34 and XEmacs 19.15
	corrections (typos, style, command revisions, etc).
	Integrated hacked up XEmacs immediate keybindings display.  See
	`icomplete-show-key-bindings', `icomplete-get-keys', and
	`icomplete-completions'.  Doesn't work with mainline GNU 
	Emacs 19.34 (because the cmdloop doesn't set owindow, and the
	current-local-map doesn't take optional buffer arg), so feature
	is, by default, inhibited unless we're running in XEmacs.
	(icomplete-get-keys): Return keys bound to func name in buffer
	"owindow" - since "owindow" is calling-buffer history present
	only in XEmacs, this function is only useful in XEmacs.
	(icomplete-max-delay-chars, icomplete-compute-delay): New vars.
	(icomplete-delay-completions-threshold): New var.
	These customize the delay behavior, so that completions don't
	intrude as quickly for short input.

1997-05-29  Anders Lindgren  <andersl@csd.uu.se>

	* follow.el (follow-submit-feedback, follow-mode): Doc fix.
	(follow-generic-filter): Don't restore the original buffer if it's
	dead, or if the filter explicitly selected a new buffer.

1997-05-29  John Heidemann  <johnh@isi.edu>

	* mouse-drag.el (mouse-drag-electric-col-scrolling): New variable;
        auto-enables horizontal scrolling when clicks on wrapped
        lines occur.

1997-05-29  Simon Marshall  <simon@diazepam.gnu.ai.mit.edu>

	* font-lock.el (font-lock-syntactic-keywords): New variable.
	(font-lock-fontify-syntactic-keywords-region): New function.  Use it.
	(font-lock-default-fontify-region): Call it first if variable non-nil.
	Wrap parse-sexp-lookup-properties to non-nil if called.
	(font-lock-default-unfontify-region): Remove syntax-table properties.
	(font-lock-apply-syntactic-highlight):
	(font-lock-fontify-syntactic-anchored-keywords): New functions.
	These syntactic keyword fontification functions place syntax-table text
 	properties in the buffer, in much the same way that keyword
 	fontification functions place face text properties.  The syntax-table
 	text properties are respected by syntactic and keyword fontification.
	(font-lock-eval-keywords): New function.
	(font-lock-set-defaults): Use it.
	(font-lock-keyword-depth): Function deleted.  Use regexp-opt-depth.

	* fast-lock.el (fast-lock-get-syntactic-properties): New function.
	(fast-lock-save-cache-1): Call it and save value.
	Save font-lock-syntactic-keywords.  Save 3 as version number.
	(fast-lock-cache-data): Take new args SYNTACTIC-KEYWORDS and
	SYNTACTIC-PROPERTIES.  Eval font-lock-syntactic-keywords with
	font-lock-eval-keywords.  Compile and compare all keywords.
	(fast-lock-get-syntactic-properties): New function.
	(fast-lock-add-properties): Renamed from fast-lock-set-face-properties.
	Take new arg SYNTACTIC-PROPERTIES and add syntax-table text properties.
	Now fast-lock.el saves a buffer's value of font-lock-syntactic-keywords
	and syntax-table text properties as added by font-lock.el.

	* sh-script.el (sh-font-lock-keywords*): Doc fixes.
	(sh-mode-syntax-table): Leave $ syntax alone.
	(sh-font-lock-syntactic-keywords): New variable.
	(sh-mode): Use it to set font-lock-defaults.

1997-05-29  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* edt.el (edt-emulation-on): Handle absence of TERM envvar.

	* iso-acc.el (iso-languages): For French and Portuguese,
	add comma as prefix.  For Latin-3, add period.
	Remove unnecessary backslashes before chars that don't need them.

	* edebug.el (edebug-signal): Avoid infinite recursion.

1997-05-28  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* regexp-opt.el: New file.

	* server.el (server-kill-buffer): Prevent infinite recursion.
	(server-kill-buffer-running): New variable.

1997-05-28  Hrvoje Niksic  <hniksic@srce.hr>

	* dired-aux.el: Customize.

1997-05-27  Dan Nicolaescu  <done@ece.arizona.edu>

	* hideshow.el (hs-special-modes-alist): Include also the
	comment regexp in the alist. This is needed for modes like C++
	where the comment beginning regexp is not easy to determine
	from the syntax table.
	Include ADJUST-BLOCK-BEGINNING in the alist.
	(hs-hide-comments-when-hiding-all): Add autoload cookie.
	(hs-show-hidden-short-form):
	(hs-adjust-block-beginning): New variables.

	Comment out `hs-menu-bar' as XEmacs support was removed.
	(hs-c-end-regexp): Remove variable, obsoleted by the rewrite of
	`hs-inside-comment-p'.
	
	(hs-discard-overlays): No need to test if we are inside the
	overlay, we surely are since we got the overlay using `overlays-at'.
	(hs-hide-block-at-point): Rewritten to use the new variables.
	Use only one parameter to specify the comment.
	(hs-show-block-at-point): No need for the COMMENT-REG parameter.
	(hs-safety-is-job-n): Correct typo.
	(hs-hide-initial-comment-block): Add ^L to the chars to skip.
	Take into account `hs-show-hidden-short-form' when testing.
	(hs-inside-single-line-comment-p): Function deleted, obsoleted by
	the rewrite of `hs-inside-comment-p'.
	(hs-inside-comment-p): Rewritten from scratch. Semantics changed
	when returning non-nil. We can be inside a comment, but that
	comment might not be hidable (the car of the return value should
	be non-nil to be hidable).
	(hs-grok-mode-type): Rewrite to be more understandable.
	`hs-c-end-regexp' does not exist any more.
	Initialize `hs-c-start-regexp' from the alist if specified there.
	Initialize `hs-adjust-block-beginning'.
	(hs-find-block-beginning): Rewritten to be able to deal with the
	situation when a block beginning spans multiple lines and the
	point is on one of those lines.
	(hs-already-hidden-p): Look first if we are inside a comment or a
	block, go to their end and look there for the overlays.
	(java-hs-adjust-block-beginning): New function.
	(hs-hide-all): Hide a comment block only if `hs-inside-comment-p'
	says is hidable.
	(hs-hide-block): Simplify.  Handle properly the result of
	`hs-inside-comment-p'.
	(hs-show-block): Likewise.
	(hs-minor-mode): Doc string fixes.
	Make `hs-adjust-block-beginning' buffer local.
	Delete making `hs-c-end-regexp' buffer local as it was deleted.

1997-05-27  Kenichi HANDA  <handa@nora.(none)>

	* mule.el (set-terminal-coding-system): New function.
	(set-keyboard-coding-system): New function.
	(set-buffer-process-coding-system): Name changed from
	set-current-process-coding-system.

	* encoded-kb.el (encoded-kbd-mode): Fix typo in doc-string.
	(encoded-kbd-set-coding-system): Deleted.

	* case-table.el (describe-buffer-case-table): Use aref instead of
	set-char-table-range.

	* loadup.el: Add comment for the code loading
	"language/devanagari".

	* mule-cmds.el: Delete defining "i" in mule-keymap.
	(mule-menu-keymap): New variable.  All menu items related to mule
	are defined in this keymap.
	(set-language-info): Change format of INFO for KEY documentation
	and setup-function.
	(setup-specified-language-environment): New function.
	(setup-language-environment): Call the above function.
	(describe-specified-language-support): New function.
	(describe-language-support): Call the above function.
	(universal-coding-system-argument): New function.
	(read-language-and-input-method-name): Doc-string fixed.  If
	default-input-method is nil, use previous-input-method as the
	default value.
	(set-default-input-method): Deleted.

	* language/*.el: Most of setup-LANGUAGE-environment functions are
	moved form LANGUAGE.el to LANG-util.el.  These functions now at
	first call setup-english-environment to reset various values to
	the defaults.

	* language/english.el (setup-english-environment): Set several
	default values more appropriately.

	* mule-conf.el: Set default value of coding-category-iso-else to
	iso-2022-lock.  Set priority of coding-category-emacs-mule higher.

	* files.el (find-file): Delete the facility of handling a prefix
	argument.
	(find-file-other-window, find-file-read-only): Likewise.
	(find-file-read-only-other-window): Likewise.
	(find-file-read-only-other-frame): Likewise.
	(find-alternate-file-other-window, find-alternate-file): Likewise.
	(write-file, insert-file, append-to-file): Likewise.

	* dired.el (dired-find-file): Likewise.

	* fontset.el (x-complement-fontset-spec): Add font names which are
	ignoring sizes in alternative-fontname-alist.

1997-05-27  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* mouse.el (mouse-undouble-last-event): Return nil if the event
	is not double or triple to start with.
	(mouse-show-mark): Handle scroll-bar events here.

1997-05-27  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* batmode.el: File deleted from distribution.
	
	* vi.el (vi-join-lines): Locally bind count.
	(vi-search-forward, vi-search-backward): Use isearch-update-ring.
	(vi-repeat-last-search, vi-reverse-last-search):
	Get string from the ring.
	(vi-mode-old-major-mode, vi-mode-old-mode-name): New defvars.
	(vi-mode-old-local-map, vi-mode-old-case-fold): Likewise.
	(vi-tilde-map): Move the defvar and bindings to the front.
	
	* ielm.el (ielm-input): New defvar.

	* browse-url.el (browse-url-netscape, browse-url-netscape-sentinel)
	(browse-url-netscape-send): Use browse-url-netscape-program,
	renamed from browse-url-netscape-command.

	* icon.el (indent-icon-exp): Bind last-depth.
	Consistently use inner-loop-done, not innerloop-done.

	* webjump.el (webjump-adult-p): Function deleted.

	* gulp.el (gulp-send-requests): Sort maintainers alphabetically.
	(gulp-create-m-p-alist): Don't print message here.  Bind fl-tm.
	(gulp-request-header, gulp-request-end): Update the default text.
	
	* info.el (Info-exit): Use bury-buffer simply.

1997-05-27  Dan Nicolaescu  <done@ece.arizona.edu>

	* icon.el (icon-mode): Adapt to new hideshow and improve regexps.
	(icon-forward-sexp-function): Use beginning-of-icon-defun and
	end-of-icon-defun.

1997-05-26  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* isearch.el (search-highlight): Make it t by default.
	(search-invisible): Doc fix.

	* simple.el (do-auto-fill): Don't give fill-context-prefix third arg.

	* fill.el (adaptive-fill-regexp): Allow - and |;
	allow spaces within the prefix.  Allow numeric headings.
	(adaptive-fill-first-line-regexp): New variable.
	(fill-context-prefix): Use adaptive-fill-first-line-regexp.
	If prefix from first line seems unreasonable, use whitespace instead.
	Reject it entirely only if it is a paragraph-starter.
	
1997-05-26  Simon Marshall  <simon@diazepam.gnu.ai.mit.edu>

	* comint.el (comint-send-input): When calculating the history entry,
	use insert to restore the old input, and insert before deleting.

	* ispell.el (ispell-overlay-window): Use inhibit-frame-unsplittable,
	instead of its old name.

1997-05-25  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* faces.el: Unconditionally create the standard faces at load time.
	Move face setup here from cus-start.el, and add attribute info.
	(x-create-frame-with-faces): Don't call frame-set-background-mode
	until after handling the reverse-video parameter.

	* cus-start.el: Move face setup to faces.el.
	
	* faces.el (modify-face): Don't call make-face-unbold
	if face has no font; likewise for make-face-unitalic.
	(x-create-frame-with-faces): Use nil for SET-ANYWAY
	when calling make-face-x-resource-internal.
	(face-initialize): Don't initialize any face attributes here.
	(face-fill-in): Don't call set-face-underline-p if underlining off.

	* subr.el (substitute-key-definition): Fix previous change.

	* Makefile (dontcompilefiles): Add latin-1.el ... latin-4.el;
	remove iso-syntax.el and i3-syntax.el.

1997-05-24  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* info.el (Info-suffix-list): Accept -info as suffix;
	also accept a subdir with a file called `index'.

	* texinfmt.el (texinfo-extra-inter-column-width):
	Renamed from extra-inter-column-width.  Doc fix.
	(texinfo-multitable-buffer-name):
	Variable renamed from multitable-temp-buffer-name.
	(texinfo-multitable-rectangle-name):
	Variable renamed from multitable-temp-rectangle-name.
	(texinfo-format-key): Don't insert angle-brackets.

1997-05-24  Bob Chassell  <bob@gnu.ai.mit.edu>

	* texinfo.el (texinfo-version): New function and variable.
	(texinfo-update-node): New autoload call.
	(texinfo-every-node-update): Likewise.
	(texinfo-sequential-node-update): Likewise.
	(texinfo-mode-map): New binding for C-c ].
	(texinfo-environment-regexp): Use concat, for clarity.
	(texinfo-insert-@end): Fix paren error.

	* texinfmt.el (texinfmt-version): New function and variable.
	(texi2info): New function.
	(texinfo-accent-commands): New variable.
	(texinfo-no-refill-regexp): Use concat to make it clearer.
	Add some more elements.
	(texinfo-part-of-para-regexp): Likewise.
	(texinfo-append-refill): Extend criterion 3 for when not to refill.
	(texinfo-raisesections-alist): Add @centerchap.
	(texinfo-lowersections-alist): Add @centerchap.
	(texinfo-format-scan): Handle many more @-char commands.
	(detailmenu): Add texinfo-format and texinfo-end properties,
	(centerchap): Add texinfo-format property,
	(texinfo-format-buffer): Doc fix.
	(texinfo-parse-line-arg): Add doc string.
	(texinfo-parse-arg-discard): Likewise.
	(texinfo-multitable): New Texinfo cmd.
	(texinfo-end-multitable): New function.
	(texinfo-multitable-widths): New function.
	(texinfo-multitable-extract-row): New function.
	(texinfo-multitable-item): New function.
	(texinfo-format-timestamp): New Texinfo cmd.
	(texinfo-format-kbd-regexp): New variable.
	(texinfo-format-kbd-end-regexp): New variable.
	(texinfo-format-kbd): New function for @kbd.
	(texinfo-format-ifeq): New Texinfo cmd.
	(texinfo-format-pounds): Likewise.
	(texinfo-format-refill): Handle *'s specially at line start.
	* Add properties for new commands.
	* Move all the no-op commands to the end, and add some.
	* Add many commands for ligatures and for letters with diacritics
	and other non-English special characters..

	* latin-1.el, latin-2.el, latin-3.el, latin-4.el:
	If set-case-syntax-set-multibyte is non-nil, define syntax
	for multibyte characters, and don't do `provide'.
	* case-table.el (set-case-syntax-set-multibyte): New variable.

1997-05-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* case-table.el (set-case-syntax-1): New function.
	(set-case-syntax-delims): Use set-case-syntax-1.
	(set-case-syntax-pair, set-case-syntax): Likewise.

1997-05-22  Ralph Schleicher  <rs@purple.UL.BaWue.DE>

	* libc.el (libc-highlight-overlay): New variable.
	(libc-search-index): Use an overlay for highlighting.

	* libc.el: New file.
	
1997-05-22  Hrvoje Niksic  <hniksic@srce.hr>

	* terminal.el: Use defgroup and defcustom.
	* dired.el, dired-x.el: Likewise.
	
1997-05-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* faces.el (face-inverse-video-p): New function.
	(set-face-inverse-video-p): New function.
	(internal-set-face-1): Handle the inverse-video attribute.
	(face-spec-set): Handle :inverse-video.
	(make-face, x-create-frame-with-faces): Make vectors length 9.
	(internal-facep): Expect length 9.
	(face-try-color-list): Use set-face-inverse-video-p.

	* cus-face.el (custom-face-attributes): Add :inverse-video.

1997-05-22  Erik Naggum  <erik@naggum.no>

	* latin-4.el: New file.

1997-05-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* latin-1.el, latin-2.el, latin-3.el:
	Use punctuation syntax for section sign.

	* reftex.el: New file.

1997-05-21  Steven L Baur  <steve@altair.xemacs.org>

	* add-log.el (change-log-font-lock-keywords): Tweak font-lock-keywords.

1997-05-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* subr.el (substitute-key-definition): Handle chartables.

	* custom.el (defface): Doc fix.

1997-05-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* custom.el (defface): Doc fix.

1997-05-21  Noah Friedman  <friedman@prep.ai.mit.edu>

	* eldoc.el (eldoc-message-commands): Move docstring into comments,
	since this isn't a user variable.
	(eldoc-message-commands-table-size, eldoc-use-idle-timer-p,
	eldoc-function-argstring-from-docstring-method-table): Use defvar,
	not defconst.
	(eldoc-last-data): Use cons explicitly; don't rely on dotted pair
	read syntax.  I'm worried the latter might get compiled as
	read-only data someday.
	(eldoc-docstring-message): If truncating symbol name, show ending
	of name rather than beginning.  The former is generally more unique.
	(eldoc-function-argstring-from-docstring-method-table): Handle
	pathological `save-restriction' case.
	[top level]: Add `indent-for-tab-command' to eldoc-message-commands.

1997-05-21  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* swedish.el: iso-syntax.el renamed to latin-1.el.

	* startup.el (command-line): iso-syntax.el renamed to latin-1.el.

	* loadup.el: Always load case-table and latin-1...latin-4.

	* latin-1.el: Renamed from iso-syntax.el.
	* latin-2.el: Renamed from iso02-syn.el.
	* latin-3.el: Renamed from i3-syntax.el.

	* cc-mode.el (c-C++-friend-key): Missing definition added back.

	* pc-select.el (pc-selection-mode): Swap meanings of f16 and f18;
	they were backwards.

	* awk-mode.el (awk-mode): Set parse-sexp-ignore-comments.

1997-05-21  Rolf Ebert  <re@waporo.muc.de>

	* ada-mode.el (ada-krunch-args): Use gnatkr instead of gnatk8.
	(ada-make-filename-from-adaname): Ditto.
	(ada-adjust-case-region): Use format functionality of message.
	(ada-indent-region): Ditto.
	(ada-check-matching-start): Ditto.
	(ada-check-defun-name): Ditto.

	* ada-mode.el (ada-font-lock-keywords): Default to subdued.  Doc fix.
	(ada-font-lock-syntactic-keywords): New variable.
	(ada-mode): Use it to set font-lock-defaults.

	* ada-mode.el (ada-font-lock-keywords-2): Single "raise" will be
	highlighted. "in out" parameters get type face (depends on order
	in regexp).

	* ada-mode.el (ada-mode): Remove explicit setting of user option
	`blink-matching-paren', font-lock treats `.' as word char.
	(ada-in-string-or-comment-p): Call `parse-partial-sexp' only once.
	(ada-untabify-buffer): Force returning `nil'.
	(ada-font-lock-keywords-1): Move "task" before "task (body|type)" to
	correct highlighting (regexp depends on order).

	* ada-mode.el (ada-in-char-const-p): Renamed from `ada-after-char-p'.
	Also test following character.
	(ada-adjust-case): Use better function `ada-in-char-const-p'
	(ada-in-string-or-comment-p): Test for being in a char constant.
	(ada-clean-buffer-before-saving): Changed default to t.
	(ada-mode): Set `font-lock-defaults' for Emacs only, use properties
	for XEmacs.

	* ada-mode.el (ada-indent-newline-indent): Simplified by just calling
	`ada-indent-current'.

	* ada-mode.el (ada-end-stmt-re): Added word delimiters in regexp.
	Removed `interactive' statements which were needed only for debugging.

	* ada-mode.el:
	Put format commands back in for emacs 19.30/19.29 compatibility.

	* ada-mode.el (ada-get-indent-label): A named block can begin
	without a declare part.
	(ada-check-defun-name): First of all, check for correct name in a
	named block without `declare' part.
	(ada-goto-matching-start): Change regexp as there may be no
	semicolon between `end' and keyword.
	(ada-get-current-indent): Remove warning as `begin' can introduce
	a block without a `declare'.
	(ada-goto-matching-decl-start): When searching backward, skip
	generic default proc/func ("is <>").

	* ada-mode.el
	(ada-named-block-re): New regexp for the name of a named block or loop.
	(ada-get-current-indent): Handle loop names at the stmt start.
	(ada-get-indent-end): Handle loop names at the stmt start.
	(ada-get-indent-noindent): Handle loop names at the stmt start.
	(ada-get-indent-loop): Handle loop names at the stmt start.
	(ada-search-prev-end-stmt): Generic instances are not `stmt-ends'.
	(ada-goto-previous-word): Use new function `ada-goto-next-word'.
	(ada-goto-next-word): Generalized old `ada-goto-previous-word' for
	both directions.

	* ada-mode.el (ada-indent-function): Removed unnecessary `package'
	case.
	(ada-get-indent-case): Before testing for `=>', be sure there is
	an `is'.
	(ada-search-prev-end-stmt): Test for `separate' keyword on the
	same line, which is not an `end-stmt'.

	* ada-mode.el (ada-font-lock-keywords-2):
	Correct regexp for hilit of unfollowed `end'.
	(ada-in-open-paren-p): Start parsing definitely outside of strings.
	(ada-gnat-style): New function.

	* ada-mode.el: Doc fixes.
	(ada-mode): Support new font-lock-mode.
	(ada-format-paramlist): Changed all `accept' to `access'.
	(ada-insert-paramlist): Changed all `accept' to `access'.
	(ada-in-comment-p): Use standard emacs way `parse-partial-sexp'.
	(ada-font-lock-keywords-1): Regexps in not byte-compiled code bahave
	different than byte-compiled regexps.
	Change order of some ored entries.

1997-05-21  Erik Naggum  <erik@naggum.no>

	* add-log.el (add-log-lisp-like-modes, add-log-c-like-modes)
	(add-log-tex-like-modes): New variables.
	(add-log-current-defun): Use them instead of constant lists.

1997-05-21  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-backend-admin): If SCCS should be used, and there
	is no "SCCS" subdirectory, create it.

1997-05-21  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* webjump.el (webjump-to-javaapi): Function deleted.
	(webjump-sample-sites): Delete various pointers to non-free things.

	* bindings.el (mode-line-mule-info): Add a colon.
	(mode-line-modified): Delete the initial dash.

1997-05-20  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* word-help.el (set-word-help-file): Renamed from set-help-file.

	* crisp.el (crisp-mode): Add autoload cookie.

	* Makefile (dontcompilefiles): Add list of files that should not
	be byte-compiled.

	* dos-w32.el (add-untranslated-filesystem)
	(remove-untranslated-filesystem): Add interactive spec.

	* crisp.el (crisp-last-last-command): Renamed from last-last-command
	and defvar added.

	* levents.el (event-closest-point): Fix paren error.

1997-05-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-start.el (load-path): Change tag again.

1997-05-20  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* mh-utils.el (mh-file-command-p): New function.
	(mh-path-search): Use that.
	(mh-find-progs): Don't check current directory
	unless explicitly requested.  Don't set mh-progs or mh-lib
	if the programs are not found.  Give an error message
	unless they are found.

1997-05-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* replace.el (perform-replace): Restore match data after read-event.

1997-05-19  Edward M Reingold  <emr@silver.wisdom.weizmann.ac.il>

	* holidays.el (holiday-float): Rewritten to fix bug when base date
	of holiday and holiday date are in different months.

	* diary-lib.el (diary-float): Rewritten to fix bug when base date
	of entry and entry date are in different months.  Added optional
	parameter DAY.
	(list-sexp-diary-entries): Revise description of diary-float.

1997-05-19  Drew Csillag  <drew@staff.prodigy.com>

	* m4-mode.el (m4-program): Guess which m4 binary to use.
	(m4-start-m4): New function.
	(m4-end-m4): New function.
	(m4-m4-buffer, m4-m4-region): Now use m4-start-m4.
	(m4-font-lock-keywords): Collaps 4 regex's into 1.

1997-05-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-start.el (load-path): Change a tag.

1997-05-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* files.el (path-separator, parse-colon-path): Doc fixes.

1997-05-18  Erik Naggum  <erik@naggum.no>

	* compile.el (compilation-parse-errors): Fix paren error.

	* dabbrev.el (dabbrev-expand, dabbrev--abbrev-at-point)
